package molpage.com;

import java.util.Iterator;
import java.util.List;

import sims.hibernate.*;
/**
 *   veido reportu - tab-delimited datu exportu.
 *   klasi lieto ExportData.jsp kura tiek saukta
 *    no ViewTop.jsp, ViewMiddle.jsp, ViewBottom.jsp
*/
public final class DataExport implements Iterator{
  private UserHttpSess session;
  private Iterator objIterator;
  private byte[] valueIndexArray;
  private int colCount;
  private List objList;
  private boolean isBatch = false;
  private SimsData currentObj = null;
  private ViewBatchManager batchMan; 
//  private boolean isTopBatch = false;
//  private boolean isMiddleBatch = false;
//  private boolean isBottomBatch = false;
  private int level;
  public DataExport(UserHttpSess tmpHttpSessObj, boolean isBatch) {
    session = tmpHttpSessObj;
    this.isBatch = isBatch;
    batchMan = session.getViewBatchManager();
  }

  public String getHeader(String selectName) {
    if (selectName.equals("top"))return getTopHeader();
    else
    if (selectName.equals("middle"))return getMiddleHeader();
    else
    if (selectName.equals("bottom"))return getBottomHeader();
    else return null;
  }

  private String getTopHeader() {
    try {
      level = 0;
//      isTopBatch = session.isTopBatch();
      StringBuffer xyz = new StringBuffer();
      MetadataManager mdm = this.session.getMetadataManager();
//      if (isTopBatch)
//        objList = session.getBatchArray();
//      else
      objList = session.getAllPersons( -1);
      String[] keyArray = mdm.getPersonKeyArray();
      colCount = keyArray.length;
      valueIndexArray = mdm.getPersonIndexArray();
      for (int i = 0; i < colCount; i++){
        if (i>0) xyz.append("\t");
        xyz.append(VocabulName.getTopPrefix());
        xyz.append(mdm.getTopName(keyArray[i]));
      }
      return xyz.toString();
    } catch (Exception ex) {
      Util.writeLog("getTopHeader",
                    "selectName",
                    (ex!=null)?ex.getMessage():"exception");
      return null;
    }
  }

  private String getMiddleHeader() {
    try {
      level = 1;
//      isMiddleBatch = session.isMiddleBatch();
      StringBuffer xyz = new StringBuffer();
      MetadataManager mdm = this.session.getMetadataManager();
      ViewSampleManager vam = session.getViewSampleManager();
      Long persId = vam.getPersonId();
//      if (isMiddleBatch)
//        objList = session.getBatchArray();
//      else
      objList = session.getAllSamples(persId, -1);
      String[] keyArray = mdm.getSampleKeyArray();
      colCount = keyArray.length;
      valueIndexArray = mdm.getSampleIndexArray();
      for (int i = 0; i < colCount; i++){
        if (i>0) xyz.append("\t");
        xyz.append(VocabulName.getMiddlePrefix());
        xyz.append(mdm.getMiddleName(keyArray[i]));
      }
      return xyz.toString();
    } catch (Exception ex) {
      Util.writeLog("getMiddleHeader",
                    "selectName",
                    (ex!=null)?ex.getMessage():"exception");
      return null;
    }
  }

  private String getBottomHeader() {
    try {
      level = 2;
//      isBottomBatch = session.isBottomBatch();
      StringBuffer xyz = new StringBuffer();
      MetadataManager mdm = this.session.getMetadataManager();
      ViewAliquotManager vam = session.getViewAliquotManager();
      Long persId = vam.getPersonId();
      Long samplId = vam.getSampleId();
//      if (isBottomBatch)
//        objList = session.getBatchArray();
//      else
      objList = session.getAllAliquots(persId, samplId, -1);
      String[] keyArray = mdm.getAliquotKeyArray();
      colCount = keyArray.length;
      valueIndexArray = mdm.getAliquotIndexArray();
      for (int i = 0; i < colCount; i++){
        if (i>0) xyz.append("\t");
        xyz.append(VocabulName.getBottomPrefix());
        xyz.append(mdm.getBottomName(keyArray[i]));
      }
      return xyz.toString();
    } catch (Exception ex) {
      Util.writeLog("getBottomHeader",
                    "selectName",
                    (ex!=null)?ex.getMessage():"exception");
      return null;
    }
  }

  public Iterator iterator() {
    objIterator = objList.iterator();
    return this;
  }

  public boolean hasNext() {
  	while (objIterator.hasNext()){
  	  currentObj = (SimsData) objIterator.next();
  	  if (!isBatch || batchMan.isSelected(currentObj.getId())) return true;
  	}
  	return false;	
  }

  public Object next() {
    int myRights = 0;
    if (currentObj == null) return null;
    if (level==0){
        myRights = session.getGrantedRights((Top)currentObj);
      } else
      if (level==1){
    	myRights = session.getGrantedRights(((Middle)currentObj).getParent()); 
      } else
      if (level==2){
    	myRights = session.getGrantedRights(((Bottom)currentObj).getParent().getParent());
      }
    if (myRights < 1000) return null;
    try{
      String[] var = currentObj.getValueArrayForExport(valueIndexArray, colCount);
      StringBuffer xyz = new StringBuffer();
      for (int i = 0; i < colCount; i++){
        if (i>0) xyz.append("\t");
        xyz.append(var[i] == null || var[i].equals("&nbsp;") ? "" : var[i]);
      }
      return xyz.toString();
    }catch( Exception ex){
      Util.writeLog( "DataExport", ex.getMessage(),"");
      return null; 
    }
  }

    public void remove() {
    }
}


