package molpage.com;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.Date;
import java.util.Calendar;
import org.hibernate.HibernateException;

import sims.hibernate.TempMetaData;
import sims.hibernate.TypeName;
import sims.hibernate.VocabulName;
import sims.hibernate.MetadataManager;

import java.util.List;
import java.util.Iterator;
import java.util.Set;
import java.util.Map;

public final class FilterObject {
    private String topString = null;
    private String middleString = null;
    private String bottomString = null;
    private boolean relevantTop = true;
    private boolean relevantMiddle = true;
     
    private HashMap<String,String> filterValues = null;
    private HashMap<String,String> tempFilterValues = null;
    private HashMap<String,Integer> invalidFields = null;
    private MetadataManager mdm;
    private UserHttpSess session;
    private boolean filterNotEmpty = false;
    
public FilterObject(UserHttpSess session, MetadataManager mdm) {
	this.mdm = mdm;
	this.session = session;
	filterValues = new HashMap<String,String>();
	filterNotEmpty = false;
}
public boolean isFilter(){return filterNotEmpty;}     
public void clearFilter(){filterNotEmpty = false;}     
public void setFilter( HttpServletRequest request){
    setGenericFilter( request);
}
public void setTempFilterValues(){
  if (tempFilterValues==null)	
    tempFilterValues = new HashMap<String,String>(filterValues);	
}
public void clearTempFilterValues(){
  tempFilterValues = null;	
}
public String getFilterValue( String fieldName) {
    String xyz = null;
    if ( filterValues != null) xyz = (String) filterValues.get(fieldName);
    return xyz;
}
public String getTempFilterValue( String fieldName) {
    String xyz = null;
    if ( tempFilterValues != null) xyz = (String) tempFilterValues.get(fieldName);
    return xyz;
}
public boolean containsFilterValue( String key) {
    return (filterValues!=null && filterValues.containsKey(key));
}
public String getFilterString( String fieldName){
    String xyz = null;
    if (tempFilterValues!=null)	xyz = ((String)tempFilterValues.get(fieldName));
    return (xyz==null)?"":xyz;
}
public boolean getFilterBoolean( String fieldName){
    Object xyz = null;
    if (tempFilterValues!=null)
      xyz = (tempFilterValues.get(fieldName));
    return xyz != null;
}
/*
public Query getPersonQuery( Session hibSess, String prefix, String orderClause){
   Query q = hibSess.createQuery(prefix + getPersonString( false)
                            + orderClause);
//    Date aDate = (Date)filterValues.get("l1dt01a");
//    Date bDate = (Date)filterValues.get("l1dt01b");
//    if (aDate!=null) q.setDate("l1dt01a",aDate);
//    if (bDate!=null) q.setDate("l1dt01b",bDate);
  return q;
}
public Query getPersonQuery( Session hibSess, String prefix){
   Query q = hibSess.createQuery(prefix + getPersonString( false));
//   Util.writeLog("Query", prefix + getPersonString(), "");
//    Date aDate = (Date)filterValues.get("l1dt01a");
//    Date bDate = (Date)filterValues.get("l1dt01b");
//    if (aDate!=null) q.setDate("l1dt01a",aDate);
//    if (bDate!=null) q.setDate("l1dt01b",bDate);
  return q;
}
public Query getSampleQuery( Session hibSess, String prefix, String orderClause){
   Query q = hibSess.createQuery(prefix + getSampleString( false)
	                            + orderClause);
//	    Date aDate = (Date)filterValues.get("l1dt01a");
//	    Date bDate = (Date)filterValues.get("l1dt01b");
//	    if (aDate!=null) q.setDate("l1dt01a",aDate);
//	    if (bDate!=null) q.setDate("l1dt01b",bDate);
  return q;
}
public Query getSampleQuery( Session hibSess, String prefix){
   Query q = hibSess.createQuery(prefix + getSampleString( false));
//	    Date aDate = (Date)filterValues.get("l1dt01a");
//	    Date bDate = (Date)filterValues.get("l1dt01b");
//	    if (aDate!=null) q.setDate("l1dt01a",aDate);
//	    if (bDate!=null) q.setDate("l1dt01b",bDa te);
  return q;
}
public Query getAliquotQuery( Session hibSess, String prefix, String orderClause){
   Query q = hibSess.createQuery(prefix + getAliquotString( false)
		                            + orderClause);
//		    Date aDate = (Date)filterValues.get("l1dt01a");
//		    Date bDate = (Date)filterValues.get("l1dt01b");
//		    if (aDate!=null) q.setDate("l1dt01a",aDate);
//		    if (bDate!=null) q.setDate("l1dt01b",bDate);
  return q;
}
public Query getAliquotQuery( Session hibSess, String prefix){
   Query q = hibSess.createQuery(prefix + getAliquotString( false));
//		    Date aDate = (Date)filterValues.get("l1dt01a");
//		    Date bDate = (Date)filterValues.get("l1dt01b");
//		    if (aDate!=null) q.setDate("l1dt01a",aDate);
//		    if (bDate!=null) q.setDate("l1dt01b",bDate);
  return q;
}
*/
public String getPersonString( boolean isTechn){
    StringBuffer xyz = new StringBuffer();
    if (relevantTop){
        xyz.append(", Middle as myMiddle");
        if (relevantMiddle)
            xyz.append(", Bottom as myBottom");
    }
    xyz.append(" where myTop.technology")
       .append((isTechn)?"=:technid ":" is null ");
    if (topString!=null)
        xyz.append(" and ")
           .append(topString);
    if (relevantTop){
        xyz.append(" and myMiddle.parent=myTop.id");
        if (middleString!=null)
            xyz.append(" and ")
               .append( middleString);
        if (relevantMiddle){
             xyz.append(" and ")
                .append("myBottom.parent=myMiddle.id");
             if (bottomString!=null)
                 xyz.append(" and ")
                    .append( bottomString);
        }
    }
//    Util.writeLog("personstring=",xyz.toString(),"");
    return xyz.toString();
}

public String getSampleString( boolean isTechn){
    StringBuffer xyz = new StringBuffer();
    if (relevantMiddle)
        xyz.append(", Bottom as myBottom");
    if (topString!=null)
        xyz.append(", Top as myTop");
    xyz.append(" where myMiddle.technology")
       .append((isTechn)?"=:technid ":" is null ");
    if (topString!=null){
        xyz.append("and myMiddle.parent=myTop.id and ")
           .append(topString);
        if (middleString!=null)
            xyz.append(" and ")
               .append(middleString);
    }
    else
    if (middleString!=null)
        xyz.append(" and ")
           .append(middleString);
    if (relevantMiddle){
        xyz.append(" and myBottom.parent=myMiddle.id");
        if (bottomString!=null)
            xyz.append(" and ")
               .append( bottomString);
    }
    return xyz.toString();
}

public String getAliquotString( boolean isTechn){
    StringBuffer xyz = new StringBuffer();
    if (middleString!=null || topString!=null)
        xyz.append(", Middle as myMiddle");
    if (topString!=null)
        xyz.append(", Top as myTop");
    xyz.append(" where myBottom.technology")
        .append((isTechn)?"=:technid ":" is null ");
    if (topString!=null){
        xyz.append("and myBottom.parent=myMiddle.id and myMiddle.parent=myTop.id and ")
           .append(topString);
        if (middleString!=null)
            xyz.append(" and ")
               .append(middleString);
        if (bottomString!=null)
            xyz.append(" and ")
               .append( bottomString);
    }
    else
    if (middleString!=null){
        xyz.append(" and myBottom.parent=myMiddle.id and ")
           .append(middleString);
        if (bottomString!=null)
            xyz.append(" and ")
               .append( bottomString);
    }
    else
    if (bottomString!=null)
        xyz.append(" and ")
           .append( bottomString);
    return xyz.toString();
}
/*
private Date getLowDate( String year, String month, String day){
    Date myDate = null;
    try {
        int yy = Integer.parseInt(year);
        if (yy>1900&&yy<2100){
            int mm = (month.equals(""))?1:Integer.parseInt(month);
            if (mm>0&&mm<13){
                int dd = (day.equals(""))?1:Integer.parseInt(day);
                if (dd > 0 & dd < 32) {
                    Calendar myCal = Calendar.getInstance();
                    myCal.set(yy, mm - 1, dd, 0, 0);
                    myDate = myCal.getTime();
                }
            }
        }
    } catch (Exception ex) {
    }
    return myDate;
}
private Date getHighDate( String year, String month, String day){
    Date myDate = null;
    try {
        int yy = Integer.parseInt(year);
        if (yy>1900&&yy<2100){
            int mm = (month.equals(""))?12:Integer.parseInt(month);
            if (mm>0&&mm<13){
                int dd = (day.equals(""))?31:Integer.parseInt(day);
                if (dd > 0 & dd < 32) {
                    Calendar myCal = Calendar.getInstance();
                    myCal.set(yy, mm - 1, dd, 23, 59);
                    myDate = myCal.getTime();
                }
            }
        }
    } catch (Exception ex) {
    }
    return myDate;
}
*/
public String getSearchDatePrompter( String fieldName){
    StringBuffer xyz = new StringBuffer();
    Date aDate = null;
    Date bDate = null;
    if (filterValues!=null){
//      aDate = (Date)filterValues.get(fieldName+"a");
//      bDate = (Date)filterValues.get(fieldName+"b");
    }
    xyz.append("<td><table><tr><td class='dialh'>from(yyyy)</td>");
    xyz.append("<td><input type='text' name='");
    xyz.append(fieldName);
    xyz.append("a' maxlength='4' size='4' value='");
    if (aDate!=null) xyz.append( Util.getYear( aDate));
/*  pagaidaam tikai gadu
    xyz.append("'><input type='text' name='");
    xyz.append(fieldName);
    xyz.append("amonth' maxlength='2' size='2' value='");
    if (aDate!=null) xyz.append( getMonth( aDate));
    xyz.append("'><input type='text' name='");
    xyz.append(fieldName);
    xyz.append("aday' maxlength='2' size='2' value='");
    if (aDate!=null) xyz.append( getDay( aDate));
*/
    xyz.append("'></td></tr><tr><td class='dialh'>to(yyyy)</td>");
    xyz.append("<td><input type='text' name='");
    xyz.append(fieldName);
    xyz.append("b' maxlength='4' size='4' value='");
    if (bDate!=null) xyz.append( Util.getYear( bDate));
    xyz.append("'></td></tr></table></td>");
    return xyz.toString();
}

private Date getLowDate( String year){
    Date myDate = null;
    try {
        int yy = Integer.parseInt(year);
        if (yy>1900&&yy<2100){
                    Calendar myCal = Calendar.getInstance();
                    myCal.set(yy, 0, 1, 0, 0);
                    myDate = myCal.getTime();
        }
    } catch (Exception ex) {
    }
    return myDate;
}
private Date getHighDate( String year){
    Date myDate = null;
    try {
        int yy = Integer.parseInt(year);
        if (yy>1900&&yy<2100){
                    Calendar myCal = Calendar.getInstance();
                    myCal.set(yy, 11, 31, 23, 59);
                    myDate = myCal.getTime();
        }
    } catch (Exception ex) {
    }
    return myDate;
}
  public String getSearchVocabulary( Class cl, String fieldName) throws
  HibernateException {
    StringBuffer xyz = new StringBuffer();
    List list = session.getAllIdAndNames( cl);
    if (list != null){
      xyz.append("<td><select name='");
      xyz.append(fieldName);
      xyz.append("'>");
      xyz.append("<option value='0'>");
      String selectedIds = getTempFilterValue( fieldName);
      Long selectedId = new Long(0);
      if (selectedIds!=null) selectedId = new Long(selectedIds); 
      Iterator iter = list.iterator();
      while (iter.hasNext()) {
        Object[] obj = (Object[])iter.next();
        Long id = (Long)obj[0]; 
        String visibleName = (String)obj[1];
        xyz.append("<option");
        if (id.equals(selectedId))xyz.append(" selected");
        xyz.append(" value='")
           .append(id)
           .append("'>")
           .append(visibleName);
      }
    }
    xyz.append("</select></td>");
    return xyz.toString();
}
  public void clearInvalidFields() {
    invalidFields = null;
  }
  private void setInvalidFields(String fieldName, int rezult) {
    if (invalidFields == null) invalidFields = new HashMap<String,Integer>();
    invalidFields.put(fieldName, new Integer(rezult));
  }
  private String getFieldId(String fieldName) {
      if (invalidFields != null){
        Integer rezult = (Integer) invalidFields.get(fieldName);
        invalidFields.remove(fieldName);
        if (rezult != null)
          return " id=\"kluda\" title=\"Invalid value\"";
      }
      return "";
    }
  
  private boolean checkDate( HttpServletRequest request, String fieldName){
	    int yy=0, mm=1, dd=1, hh=0, mi=0; boolean rez = true;
	    String dtxx = fieldName;   //year
	    String year = request.getParameter(dtxx);
	    String month = request.getParameter(dtxx+'1');
	    String day = request.getParameter(dtxx+'2');
	    String hour = request.getParameter(dtxx+'3');
	    String minute = request.getParameter(dtxx+'4');
	    if ((year==null||year.equals(""))&&
	        (month==null||month.equals(""))&&
	        (day==null||day.equals(""))&&
	        (hour==null||hour.equals(""))&&
	        (minute==null||minute.equals(""))) return rez;
	    try { yy = Integer.parseInt(year);
	        if (yy<1900||yy>2100){
	            rez = false; 
	        }
	    } catch(Exception ex){
	        rez = false; 
	    }
	    if (month != null)
	      try { mm = Integer.parseInt(month);
	          if (mm<1||mm>12){
	            rez = false; 
	          }
	      } catch(Exception ex){
	          rez = false; 
	      }
	    if (day != null)
	      try { dd = Integer.parseInt(day);
	          if (dd<1||dd>31){
	            rez = false; 
	          }
	      } catch(Exception ex){
	           rez = false; 
	      }
	    if (hour != null)
	      try { hh = Integer.parseInt(hour);
	          if (hh<0||hh>23){
	            rez = false; 
	          }
	      } catch(Exception ex){
	          rez = false; 
	      }
	    if (minute != null) 
	      try { mi = Integer.parseInt(minute);
	          if (mi<0||mi>59){
	            rez = false; 
	          }
	      } catch(Exception ex){
	           rez = false; 
	      }
    return rez;
  }

  private boolean checkYear( String year){
    boolean rez = true;  int yy;
    if (!year.trim().equals("")) 
	try { yy = Integer.parseInt(year);
      if (yy<1900||yy>2100) rez = false; 
    } catch(Exception ex){
        rez = false; 
    }
	return rez;
  } 
  
  private boolean checkFilterValues( int type, HttpServletRequest request) throws Exception {
	boolean rez = true;
    String prefix = (type==0)?"l0":(type==1)?"l1":"l2";
    for (int i = 1; i <= VocabulName.getIdentificyCount(); i++) {
        String key = VocabulName.getFieldNameIVT(i);
        if (mdm.hasField(type, key)) {
          String value = request.getParameter(prefix+key);
          if (value != null) tempFilterValues.put(prefix+key, value);
        }
      }  
    for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
        String key = VocabulName.getFieldNameVT(i);
        if (mdm.hasField(type, key)) {
          String value = request.getParameter(prefix+key);
          if (value != null) tempFilterValues.put(prefix+key, value);
        }
      }  
    for (int i = 1; i <= VocabulName.getStringCount(type); i++) {
        String key = VocabulName.getFieldNameST(i);
        if (mdm.hasField(type, key)) {
          String value = request.getParameter(prefix+key);
          if (value != null) tempFilterValues.put(prefix+key, value);
          value = request.getParameter(prefix+key+"ex");
          if (value!=null && value.equals("1")) 
        	  tempFilterValues.put(prefix+key+"ex",value);
        }
      }  
    for (int i = 1; i <= VocabulName.getIntegerCount(type); i++) {
      String key = VocabulName.getFieldNameIT(i);
      if (mdm.hasField(type, key)) {
        String value = request.getParameter(prefix+key);
        if (value != null){
          tempFilterValues.put(prefix+key, value);
          if (!Util.checkIntegerValue(value)){
            rez = false;	
            setInvalidFields(prefix+key, 7);
          }  
        }  
        value = request.getParameter(prefix+key+"ex");
        if (value != null){
          tempFilterValues.put(prefix+key+"ex", value);
          if (!Util.checkIntegerValue(value)){
            rez = false;	
            setInvalidFields(prefix+key+"ex", 7);
          }  
        }  
      }
    }  
    for (int i = 1; i <= VocabulName.getFloatCount(type); i++) {
      String key = VocabulName.getFieldNameFT(i);
      if (mdm.hasField( type, key)) {
        String value = request.getParameter(prefix+key);
        if (value != null){
          tempFilterValues.put(prefix+key, value);
          if (!Util.checkFloatValue(value)){
            rez = false;	
            setInvalidFields(prefix+key, 7);
          }  
        }  
        value = request.getParameter(prefix+key+"ex");
        if (value != null){
          tempFilterValues.put(prefix+key+"ex", value);
          if (!Util.checkFloatValue(value)){
            rez = false;	
            setInvalidFields(prefix+key+"ex", 7);
          }  
        }  
      }
    }  
    for (int i = 1; i <= VocabulName.getDateCount(type); i++) {
      String key = VocabulName.getFieldNameDT(i);
      if (mdm.hasField( type, key)) {
          String value = request.getParameter(prefix+key);
          if (value != null){
            tempFilterValues.put(prefix+key, value);
            if (!checkYear(value)){
              rez = false;	
              setInvalidFields(prefix+key, 7);
            }  
          }  
          value = request.getParameter(prefix+key+"ex");
          if (value != null){
            tempFilterValues.put(prefix+key+"ex", value);
            if (!checkYear(value)){
              rez = false;	
              setInvalidFields(prefix+key+"ex", 7);
            }  
          }  
        }
      }  
    return rez;
  }
  public boolean checkFilterValues( HttpServletRequest request) throws Exception {
	clearInvalidFields();
    tempFilterValues = new HashMap<String,String>(); //this will contain selected filter
    boolean rez1 = checkFilterValues(0,request);
    boolean rez2 = checkFilterValues(1,request);
    boolean rez3 = checkFilterValues(2,request);
    String xyz = request.getParameter("relevpers");
    if (xyz!=null) tempFilterValues.put("relevpers", "true");
    xyz = request.getParameter("relevsampl");
    if (xyz!=null) tempFilterValues.put("relevsampl", "true");
    String owgroup = request.getParameter("ow_group");
    if (owgroup != null && !owgroup.equals("")) tempFilterValues.put("ow_group",owgroup);
    String owuser = request.getParameter("ow_user");
    if (owuser != null && !owuser.equals("")) tempFilterValues.put("ow_user",owuser);
    String persstring = request.getParameter("persstring");
    String persstringex = request.getParameter("persstringex");
    if (persstring!=null && !persstring.trim().equals(""))
      tempFilterValues.put("persstring",persstring);
    if (persstringex!=null && persstringex.equals("1"))
    	  tempFilterValues.put("persstringex",persstringex);
    String samstring = request.getParameter("samstring");
    String samstringex = request.getParameter("samstringex");
    if (samstring!=null && !samstring.trim().equals(""))
      tempFilterValues.put("samstring",samstring);
    if (samstringex!=null && samstringex.equals("1"))
    	  tempFilterValues.put("samstringex",samstringex);
    String aliqstring = request.getParameter("aliqstring");
    String aliqstringex = request.getParameter("aliqstringex");
    if (aliqstring!=null && !aliqstring.trim().equals(""))
      tempFilterValues.put("aliqstring",aliqstring);
    if (aliqstringex!=null && aliqstringex.equals("1"))
    	  tempFilterValues.put("aliqstringex",aliqstringex);
    return rez1 && rez2 && rez3;
  }

//make generic html
  public String makeClearFilter( int type
	          ) throws Exception {
	    StringBuffer xyz = new StringBuffer();
	    String prefix;
	    List params;
	    if (type==0){
	    	prefix = "l0";
	    	params = mdm.getPersonMetaDataForFilter();
	    } else
	    if (type==1){
	     	prefix = "l1";
	       	params = mdm.getSampleMetaDataForFilter();
	    } else
	    {
	       	prefix = "l2";
	       	params = mdm.getAliquotMetaDataForFilter();
	    } 
	    Iterator iter = params.iterator();
	    while (iter.hasNext()) {
	      TempMetaData metadata = (TempMetaData) iter.next();
	      if (metadata.getPositionInFilter()==0)continue;
	      String key = metadata.getVisibleName();
	      int dtype = VocabulName.getNameType(key); 
	      if (dtype==0)continue;
	      if (dtype==TypeName.IDENTIFICY || dtype==TypeName.TABLE){
	  	    xyz.append("document.fForm.")
		       .append(prefix+key)
		       .append(".selectedIndex=-1;\r\n");
		  } else
	      if (dtype==TypeName.STRING){
    	    xyz.append("document.fForm.")
	 	       .append(prefix+key)
	 	       .append(".value=\"\";");
	   	    xyz.append("document.fForm.")
	 	       .append(prefix+key+"ex")
	 	       .append("[0].checked=true;\r\n");
		  } else
	      if (dtype==TypeName.NUMBER || dtype==TypeName.FLOAT){
	        xyz.append("document.fForm.")
		       .append(prefix+key)
	 	       .append(".value=\"\";");
	        xyz.append("document.fForm.")
		       .append(prefix+key+"ex")
	 	       .append(".value=\"\";");
	        xyz.append("document.fForm.")
		       .append(prefix+key+"ex")
	 	       .append(".disabled=true;");
	        xyz.append("document.fForm.")
		       .append(prefix+key+"ex")
	 	       .append(".style.backgroundColor=\"#E5EAF0\";");
	   	    xyz.append("document.fForm.")
	 	       .append(prefix+key+"exex")
	 	       .append("[1].checked=true;\r\n");
		  } else
	      if (dtype==TypeName.DATETIME){
            xyz.append("document.fForm.")
		       .append(prefix+key)
		       .append(".value=\"\";");
	        xyz.append("document.fForm.")
		       .append(prefix+key+"ex")
	 	       .append(".value=\"\";");
	        xyz.append("document.fForm.")
		       .append(prefix+key+"ex")
	 	       .append(".disabled=true;");
	        xyz.append("document.fForm.")
		       .append(prefix+key+"ex")
	 	       .append(".style.backgroundColor=\"#E5EAF0\";");
	   	    xyz.append("document.fForm.")
	 	       .append(prefix+key+"exex")
	 	       .append("[1].checked=true;\r\n");
	  	  }
	    }  
	    return xyz.toString();
	  }
//make generic html
  public String makeGenericHTML( int type
	          ) throws Exception {
    StringBuffer xyz = new StringBuffer();
    String prefix;
    List params;
    if (type==0){
    	prefix = "l0";
    	params = mdm.getPersonMetaDataForFilter();
    } else
    if (type==1){
     	prefix = "l1";
       	params = mdm.getSampleMetaDataForFilter();
    } else
    {
       	prefix = "l2";
       	params = mdm.getAliquotMetaDataForFilter();
    } 
    Iterator iter = params.iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getPositionInFilter()==0)continue;
      String key = metadata.getVisibleName();
      int dtype = VocabulName.getNameType(key); 
      if (dtype==0)continue;
      if (dtype==TypeName.IDENTIFICY || dtype==TypeName.TABLE){
        Class cl = metadata.getBaseClass(); 
	    xyz.append("<tr><td width='20%'>")
	     .append(metadata.getLongName())
	     .append("</td>")
	     .append(getSearchVocabulary( cl, prefix+key))
	     .append("<td></td></tr>\r\n");
	  } else
      if (dtype==TypeName.STRING){
        String value = getTempFilterValue(prefix+key);
		xyz.append("<tr><td width='20%'>")
			 .append(metadata.getLongName())
			 .append("</td>");
         xyz.append("<td><input type='text' size='30' name='");
         xyz.append(prefix+key);
         if (value!=null)
          	xyz.append("' value='")
          	   .append(value);
         xyz.append("'>&nbsp;");
         xyz.append("<input type='radio' name='")
            .append(prefix+key+"ex")
            .append("' value='0'");
         if (!getFilterBoolean(prefix+key+"ex"))
          	xyz.append(" checked");
         xyz.append("/>prefix");
         xyz.append("<input type='radio' name='")
            .append(prefix+key+"ex")
            .append("' value='1'");
         if (getFilterBoolean(prefix+key+"ex"))
       	    xyz.append(" checked");
         xyz.append("/>exactly");
         xyz.append("</td><td></td></tr>\r\n");
	  } else
      if (dtype==TypeName.NUMBER || dtype==TypeName.FLOAT){
 		xyz.append("<tr><td width='20%'>")
		 .append(metadata.getLongName())
		 .append("</td>");
        String value = getTempFilterValue(prefix+key);
        xyz.append("<td><input type='text' size='5' name='");
        xyz.append(prefix+key);
        if (value!=null)
           	xyz.append("' value='")
           	   .append(value);
         xyz.append("'")
            .append(getFieldId(prefix+key))
            .append(">");
         value = getTempFilterValue(prefix+key+"ex");
         xyz.append("&nbsp;<input type='text' size='5' name='");
         xyz.append(prefix+key+"ex'");
         if (value!=null)
            	xyz.append(" value='")
            	   .append(value)
                   .append("'");
         else xyz.append(" disabled style='background-color:#E5EAF0;'");
         xyz.append(getFieldId(prefix+key+"ex"))
            .append(">&nbsp;");

         xyz.append("<input type='radio' name='")
          .append(prefix+key+"exex")
          .append("' value='0'");
         if (value!=null)
        	xyz.append(" checked");
         xyz.append(" onclick='changeMark(\"")
            .append(prefix+key)
            .append("\",\"0\");'/>interval");
         xyz.append("<input type='radio' name='")
          .append(prefix+key+"exex")
          .append("' value='1'");
         if (value==null)
     	    xyz.append(" checked");
         xyz.append(" onclick='changeMark(\"")
         .append(prefix+key)
         .append("\",\"1\");'/>exactly");
		 xyz.append("</td><td></td></tr>\r\n");
	  } else
      if (dtype==TypeName.DATETIME){
        String value = getTempFilterValue(prefix+key);
   		xyz.append("<tr><td width='20%'>")
  		 .append(metadata.getLongName())
  		 .append("</td>");
          xyz.append("<td><input type='text' maxlength='4' size='4'")
             .append("alt='yyyy(year)' name='");
          xyz.append(prefix+key);
          if (value!=null)
           	xyz.append("' value='")
           	   .append(value);
          xyz.append("'")
             .append(getFieldId(prefix+key))
             .append(">");
          value = getTempFilterValue(prefix+key+"ex");
          xyz.append("&nbsp;<input type='text' maxlength='4' size='4'")
             .append("alt='yyyy(year)' name='");
          xyz.append(prefix+key+"ex'");
          if (value!=null)
           	xyz.append(" value='")
           	   .append(value)
               .append("'");
          else xyz.append(" disabled style='background-color:#E5EAF0;'");
          xyz.append(getFieldId(prefix+key+"ex"))
             .append(">&nbsp;");

          xyz.append("<input type='radio' name='")
             .append(prefix+key+"exex")
             .append("' value='0'");
          if (value!=null)
           	xyz.append(" checked");
          xyz.append(" onclick='changeMark(\"")
          .append(prefix+key)
          .append("\",\"0\");'/>interval");
          xyz.append("<input type='radio' name='")
             .append(prefix+key+"exex")
             .append("' value='1'");
          if (value==null)
       	    xyz.append(" checked");
          xyz.append(" onclick='changeMark(\"")
          .append(prefix+key)
          .append("\",\"1\");'/>exactly");
   		 xyz.append("</td><td></td></tr>\r\n");
  	  }
    }  
    return xyz.toString();
  }
  
//--- Set Target (HttpServletRequest)---------------------------------
  private String setTypeFilter( int type, HttpServletRequest request) {
  StringBuffer xyz = new StringBuffer();
  String prefix = (type==0)?"l0":(type==1)?"l1":"l2";
  String myName = (type==0)?"myTop.":(type==1)?"myMiddle.":"myBottom.";
  for (int i = 1; i <= VocabulName.getIdentificyCount(); i++) {
    String key = VocabulName.getFieldNameIVT(i);
    if (mdm.hasField(type, key)) {
      String selectedId = request.getParameter(prefix+key);
      if (selectedId!=null && !selectedId.equals("0")){
    	filterValues.put(prefix+key, selectedId);
  	    xyz.append(myName)
  	       .append(key)
  	       .append("='")
  	       .append(selectedId)
  	       .append("' and ");
      }
    }
  }  
  for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
    String key = VocabulName.getFieldNameVT(i);
    if (mdm.hasField(type, key)) {
      String selectedId = request.getParameter(prefix+key);
      if (selectedId!=null && !selectedId.equals("0")){
    	filterValues.put(prefix+key, selectedId);
    	xyz.append(myName)
    	       .append(key)
    	       .append("='")
    	       .append(selectedId)
    	       .append("' and ");
      }
    }
  }  
  for (int i = 1; i <= VocabulName.getStringCount(type); i++) {
    String key = VocabulName.getFieldNameST(i);
    if (mdm.hasField( type, key)) {
      String selstring = request.getParameter(prefix+key);
      String selstringex = request.getParameter(prefix+key+"ex");
      if (selstring!=null && !selstring.equals("")){
    	filterValues.put(prefix+key, selstring);
        if (selstringex!=null && selstringex.equals("1")){ 
          filterValues.put(prefix+key+"ex",selstringex);
          xyz.append(myName)
   	       .append(key)
   	       .append("='")
       	   .append(selstring);
        } else {	   
          xyz.append(myName)
   	       .append(key)
   	       .append(" like '")
           .append(selstring);
          if ((selstring.indexOf('%')<0)&&(selstring.indexOf('_')<0)) xyz.append('%');
        }
        xyz.append("' and ");
      }
    }
  }  
  for (int i = 1; i <= VocabulName.getIntegerCount(type); i++) {
    String key = VocabulName.getFieldNameIT(i);
    if (mdm.hasField(type, key)) {
      String value = request.getParameter(prefix+key);
      String valueex = request.getParameter(prefix+key+"ex");
      if (value!=null && !value.equals("")){
        if (!Util.checkIntegerValue(value))continue;
        filterValues.put(prefix+key, value);
        if (valueex!=null && !valueex.equals("")){
            if (!Util.checkIntegerValue(valueex))continue;
            filterValues.put(prefix+key+"ex", valueex);
            xyz.append(myName)
 	       .append(key)
 	       .append(">='")
 	       .append(value)
 	       .append("' and ");
            xyz.append(myName)
  	       .append(key)
  	       .append("<='")
  	       .append(valueex)
  	       .append("' and ");
        }
        else    
        xyz.append(myName)
        	       .append(key)
        	       .append("='")
        	       .append(value)
        	       .append("' and ");
      }
    }
  }  
  for (int i = 1; i <= VocabulName.getFloatCount(type); i++) {
    String key = VocabulName.getFieldNameFT(i);
    if (mdm.hasField( type, key)) {
      String value = request.getParameter(prefix+key);
      String valueex = request.getParameter(prefix+key+"ex");
      if (value!=null && !value.equals("")){
        if (!Util.checkFloatValue(value))continue;
        filterValues.put(prefix+key, value);
        if (valueex!=null && !valueex.equals("")){
            if (!Util.checkFloatValue(valueex))continue;
            filterValues.put(prefix+key+"ex", valueex);
            xyz.append(myName)
 	       .append(key)
 	       .append(">='")
 	       .append(value)
 	       .append("' and ");
            xyz.append(myName)
  	       .append(key)
  	       .append("<='")
  	       .append(valueex)
  	       .append("' and ");
        }
        else    
      	xyz.append(myName)
        	       .append(key)
        	       .append("='")
        	       .append(value)
        	       .append("' and ");
      }
    }
  }  
  for (int i = 1; i <= VocabulName.getDateCount(type); i++) {
  String key = VocabulName.getFieldNameDT(i);
  if (mdm.hasField( type, key)) {
      String value = request.getParameter(prefix+key);
      String valueex = request.getParameter(prefix+key+"ex");
      if (value!=null && !value.equals("")){
        if (!checkYear(value))continue;
        filterValues.put(prefix+key, value);
        if (valueex!=null && !valueex.equals("")){
            if (!checkYear(valueex))continue;
            filterValues.put(prefix+key+"ex", valueex);
        } else valueex = value;    
        xyz.append(myName)
 	       .append(key)
 	       .append(">='")
 	       .append(value)
 	       .append("-01-01' and ");
	    xyz.append(myName)
  	       .append(key)
  	       .append("<='")
  	       .append(valueex)
  	       .append("-12-31' and ");
      }
    }
  }  
  return xyz.toString();
}
  public void setGenericFilter( HttpServletRequest request){
	filterValues.clear();  
//    HashMap<String,Object> uvz = new HashMap<String,Object>(); //this will contain selected filter
    StringBuffer xyz = new StringBuffer();
    Boolean relevpers = new Boolean(request.getParameter("relevpers"));
    relevantTop = relevpers.booleanValue();
    if (relevantTop) filterValues.put("relevpers", "true");
    Boolean relevsampl = new Boolean(request.getParameter("relevsampl"));
    relevantMiddle = relevsampl.booleanValue();
    if (relevantMiddle) filterValues.put("relevsampl", "true");
//	forms ownerstring
    String owgroup = request.getParameter("ow_group");
    if (owgroup != null && !owgroup.equals("")) {
      filterValues.put("ow_group",owgroup);
      xyz.append(" (myTop.ownerGroup = '")
         .append(owgroup)
         .append("') and ");
    }
    String owuser = request.getParameter("ow_user");
    if (owuser != null && !owuser.equals("")) {
      filterValues.put("ow_user",owuser);
      xyz.append(" (myTop.owner = '")
         .append(owuser)
         .append("') and ");
    }
    String persstring = request.getParameter("persstring");
    String persstringex = request.getParameter("persstringex");
    if (persstring!=null && !persstring.trim().equals("")){
      filterValues.put("persstring",persstring);
      if (persstringex!=null && persstringex.equals("1")){ 
    	filterValues.put("persstringex",persstringex);
        xyz.append("(myTop.visibleName = '")
       	   .append(persstring);
      } else {	   
        xyz.append("(myTop.visibleName like '");
        xyz.append(persstring);
        if ((persstring.indexOf('%')<0)&&(persstring.indexOf('_')<0)) xyz.append('%');
      }
      xyz.append("') and ");
    }
    xyz.append(setTypeFilter( 0, request));
    int j = xyz.length();
    if ( j > 5)xyz.delete(j - 5, j);  //delets unnecessary " and "
    topString = (xyz.length()>0)?xyz.toString():null;

    xyz = new StringBuffer();
    String samstring = request.getParameter("samstring");
    String samstringex = request.getParameter("samstringex");
    if (samstring!=null && !samstring.trim().equals("")){
      filterValues.put("samstring",samstring);
      if (samstringex!=null && samstringex.equals("1")){ 
    	filterValues.put("samstringex",samstringex);
        xyz.append("(myMiddle.visibleName = '")
       	   .append(samstring);
      } else {	   
        xyz.append("(myMiddle.visibleName like '");
        xyz.append(samstring);
        if ((samstring.indexOf('%')<0)&&(samstring.indexOf('_')<0)) xyz.append('%');
      }
      xyz.append("') and ");
    }
    xyz.append(setTypeFilter( 1, request));
    j = xyz.length();
    if ( j > 5)xyz.delete(j - 5, j);  //delets unnecessary " and "
    middleString = (xyz.length()>0)?xyz.toString():null;

    xyz = new StringBuffer();
    String aliqstring = request.getParameter("aliqstring");
    String aliqstringex = request.getParameter("aliqstringex");
    if (aliqstring!=null &&  !aliqstring.trim().equals("")){
      filterValues.put("aliqstring",aliqstring);
      if (aliqstringex!=null && aliqstringex.equals("1")){ 
    	filterValues.put("aliqstringex",aliqstringex);
        xyz.append("(myBottom.visibleName = '")
       	   .append(aliqstring);
      } else {	   
        xyz.append("(myBottom.visibleName like '");
        xyz.append(aliqstring);
        if ((aliqstring.indexOf('%')<0)&&(aliqstring.indexOf('_')<0)) xyz.append('%');
      }
      xyz.append("') and ");
    }
    xyz.append(setTypeFilter( 2, request));
    j = xyz.length();
    if ( j > 5)xyz.delete(j - 5, j);  //delets unnecessary " and "
    bottomString = (xyz.length()>0)?xyz.toString():null;
    filterNotEmpty = !filterValues.isEmpty();
  }
  
  public String filterToString(){
	  StringBuffer xyz = new  StringBuffer();
	  Set zyx = filterValues.entrySet();
	  Iterator fiter = zyx.iterator();
      while (fiter.hasNext()) {
        Map.Entry entry = (Map.Entry)fiter.next();
        String key = (String)entry.getKey();
        String value = (String)entry.getValue();
        xyz.append(key)
           .append('\r')
           .append(value)
           .append('\r');
      }
	  return xyz.toString();
  }
  private String setTypeString( int type) {
	  StringBuffer xyz = new StringBuffer();
	  String prefix = (type==0)?"l0":(type==1)?"l1":"l2";
	  String myName = (type==0)?"myTop.":(type==1)?"myMiddle.":"myBottom.";
	  for (int i = 1; i <= VocabulName.getIdentificyCount(); i++) {
	    String key = VocabulName.getFieldNameIVT(i);
	    if (mdm.hasField(type, key)) {
	      String selectedId = filterValues.get(prefix+key);
	      if (selectedId!=null && !selectedId.equals("0")){
	  	    xyz.append(myName)
	  	       .append(key)
	  	       .append("='")
	  	       .append(selectedId)
	  	       .append("' and ");
	      }
	    }
	  }  
	  for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
	    String key = VocabulName.getFieldNameVT(i);
	    if (mdm.hasField(type, key)) {
	      String selectedId = filterValues.get(prefix+key);
	      if (selectedId!=null && !selectedId.equals("0")){
	    	xyz.append(myName)
	    	       .append(key)
	    	       .append("='")
	    	       .append(selectedId)
	    	       .append("' and ");
	      }
	    }
	  }  
	  for (int i = 1; i <= VocabulName.getStringCount(type); i++) {
	    String key = VocabulName.getFieldNameST(i);
	    if (mdm.hasField( type, key)) {
	      String selstring = filterValues.get(prefix+key);
	      String selstringex = filterValues.get(prefix+key+"ex");
	      if (selstring!=null && !selstring.equals("")){
	        if (selstringex!=null && selstringex.equals("1")){ 
	          xyz.append(myName)
	   	       .append(key)
	   	       .append("='")
	       	   .append(selstring);
	        } else {	   
	          xyz.append(myName)
	   	       .append(key)
	   	       .append(" like '")
	           .append(selstring);
	          if ((selstring.indexOf('%')<0)&&(selstring.indexOf('_')<0)) xyz.append('%');
	        }
	        xyz.append("' and ");
	      }
	    }
	  }  
	  for (int i = 1; i <= VocabulName.getIntegerCount(type); i++) {
	    String key = VocabulName.getFieldNameIT(i);
	    if (mdm.hasField(type, key)) {
	      String value = filterValues.get(prefix+key);
	      String valueex = filterValues.get(prefix+key+"ex");
	      if (value!=null && !value.equals("")){
	        if (!Util.checkIntegerValue(value))continue;
	        if (valueex!=null && !valueex.equals("")){
	            if (!Util.checkIntegerValue(valueex))continue;
	            xyz.append(myName)
	 	       .append(key)
	 	       .append(">='")
	 	       .append(value)
	 	       .append("' and ");
	            xyz.append(myName)
	  	       .append(key)
	  	       .append("<='")
	  	       .append(valueex)
	  	       .append("' and ");
	        }
	        else    
	        xyz.append(myName)
	        	       .append(key)
	        	       .append("='")
	        	       .append(value)
	        	       .append("' and ");
	      }
	    }
	  }  
	  for (int i = 1; i <= VocabulName.getFloatCount(type); i++) {
	    String key = VocabulName.getFieldNameFT(i);
	    if (mdm.hasField( type, key)) {
	      String value = filterValues.get(prefix+key);
	      String valueex = filterValues.get(prefix+key+"ex");
	      if (value!=null && !value.equals("")){
	        if (!Util.checkFloatValue(value))continue;
	        if (valueex!=null && !valueex.equals("")){
	            if (!Util.checkFloatValue(valueex))continue;
	            xyz.append(myName)
	 	       .append(key)
	 	       .append(">='")
	 	       .append(value)
	 	       .append("' and ");
	            xyz.append(myName)
	  	       .append(key)
	  	       .append("<='")
	  	       .append(valueex)
	  	       .append("' and ");
	        }
	        else    
	      	xyz.append(myName)
	        	       .append(key)
	        	       .append("='")
	        	       .append(value)
	        	       .append("' and ");
	      }
	    }
	  }  
	  for (int i = 1; i <= VocabulName.getDateCount(type); i++) {
	  String key = VocabulName.getFieldNameDT(i);
	  if (mdm.hasField( type, key)) {
	      String value = filterValues.get(prefix+key);
	      String valueex = filterValues.get(prefix+key+"ex");
	      if (value!=null && !value.equals("")){
	        if (!checkYear(value))continue;
	        if (valueex!=null && !valueex.equals("")){
	            if (!checkYear(valueex))continue;
	        } else valueex = value;    
	        xyz.append(myName)
	 	       .append(key)
	 	       .append(">='")
	 	       .append(value)
	 	       .append("-01-01' and ");
		    xyz.append(myName)
	  	       .append(key)
	  	       .append("<='")
	  	       .append(valueex)
	  	       .append("-12-31' and ");
	      }
	    }
	  }  
	  return xyz.toString();
	}
  private void setGenericString(){
    StringBuffer xyz = new StringBuffer();
  	String relevpers = filterValues.get("relevpers");
	relevantTop = relevpers!=null;
	String relevsampl = filterValues.get("relevsampl");
    relevantMiddle = relevsampl!=null;
	String owgroup = filterValues.get("ow_group");
    if (owgroup != null && !owgroup.equals("")) {
      xyz.append(" (myTop.ownerGroup = '")
         .append(owgroup)
         .append("') and ");
    }
    String owuser = filterValues.get("ow_user");
    if (owuser != null && !owuser.equals("")) {
      xyz.append(" (myTop.owner = '")
         .append(owuser)
         .append("') and ");
    }
    String persstring = filterValues.get("persstring");
    String persstringex = filterValues.get("persstringex");
    if (persstring!=null && !persstring.trim().equals("")){
      if (persstringex!=null && persstringex.equals("1")){ 
        xyz.append("(myTop.visibleName = '")
       	   .append(persstring);
      } else {	   
        xyz.append("(myTop.visibleName like '");
        xyz.append(persstring);
        if ((persstring.indexOf('%')<0)&&(persstring.indexOf('_')<0)) xyz.append('%');
      }
      xyz.append("') and ");
    }
    xyz.append(setTypeString( 0));
    int j = xyz.length();
    if ( j > 5)xyz.delete(j - 5, j);  //delets unnecessary " and "
    topString = (xyz.length()>0)?xyz.toString():null;
    xyz = new StringBuffer();
    String samstring = filterValues.get("samstring");
    String samstringex = filterValues.get("samstringex");
    if (samstring!=null && !samstring.trim().equals("")){
      if (samstringex!=null && samstringex.equals("1")){ 
        xyz.append("(myMiddle.visibleName = '")
       	   .append(samstring);
      } else {	   
        xyz.append("(myMiddle.visibleName like '");
        xyz.append(samstring);
        if ((samstring.indexOf('%')<0)&&(samstring.indexOf('_')<0)) xyz.append('%');
      }
      xyz.append("') and ");
    }
    xyz.append(setTypeString( 1));
    j = xyz.length();
    if ( j > 5)xyz.delete(j - 5, j);  //delets unnecessary " and "
    middleString = (xyz.length()>0)?xyz.toString():null;
    xyz = new StringBuffer();
    String aliqstring = filterValues.get("aliqstring");
    String aliqstringex = filterValues.get("aliqstringex");
    if (aliqstring!=null &&  !aliqstring.trim().equals("")){
      if (aliqstringex!=null && aliqstringex.equals("1")){ 
        xyz.append("(myBottom.visibleName = '")
       	   .append(aliqstring);
      } else {	   
        xyz.append("(myBottom.visibleName like '");
        xyz.append(aliqstring);
        if ((aliqstring.indexOf('%')<0)&&(aliqstring.indexOf('_')<0)) xyz.append('%');
      }
      xyz.append("') and ");
    }
    xyz.append(setTypeString( 2));
    j = xyz.length();
    if ( j > 5)xyz.delete(j - 5, j);  //delets unnecessary " and "
    bottomString = (xyz.length()>0)?xyz.toString():null;
    filterNotEmpty = !filterValues.isEmpty();
  }
  public void stringToFilter(String filterString){
    filterValues.clear();
    int from = 0; int to = 0; 
    while (true){
      to = filterString.indexOf('\r',from); if (to < 0) break;	
      String key = filterString.substring(from, to);
      from = to + 1;
      to = filterString.indexOf('\r', from);  if (to < 0) break;
      String value = filterString.substring(from, to);
      from = to + 1;
      filterValues.put(key, value);
    }
    setGenericString();
  }
}
