package molpage.com;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.*;

import org.hibernate.Session;
import org.hibernate.Transaction;
import javax.servlet.http.*;

import sims.hibernate.*;

import org.hibernate.Query;
import org.hibernate.HibernateException;

import java.lang.reflect.Method;
import java.io.File;
import molpage.pri.WebappConfig;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2008</p>
 * <p>Company:LUMII </p>
 * @author not attributable
 * @version 1.0
 */

public final class UserHttpSess {
    private HttpSession httpSess = null;
    private String httpSessId = null;
    private Session hibSess = null;
    private File tempFile = null;

    private User currentUser = null;
//currentUser rights
    private int[] grantingOwners = null;
    private int[] grantedRights = null;
    private int grantingUserCount = 0;
    private int[] grantingGroups = null;
    private int[] grantedGroupRights = null;
    private int grantingGroupCount = 0;
    private STechnology currentTechnology = null;
    private int technologyCount = 0;
    private Top currentTop = null;
    private Middle currentMiddle = null;
    private Bottom currentBottom = null;
    private Top tempTop = null;
    private Middle tempMiddle = null;
    private Bottom tempBottom = null;

    private String personSortCol = "visibleName";
    private String sampleSortCol = "visibleName";
    private String aliquotSortCol = "visibleName";
    private boolean personSortDir = true; //true - asc; false - desc
    private boolean sampleSortDir = true;
    private boolean aliquotSortDir = true;
    private HashMap<String,Integer>invalidFields = null;

    private MetadataManager mdm = null;
    private ViewPersonManager vpm = null;
    private ViewSampleManager vsm = null;
    private ViewAliquotManager vam = null;
    private ViewBatchManager batchMan = null;
    private FilterObject filter = null;  //
    private int topBatch = 0;
    private int middleBatch = 0;
    private int bottomBatch = 0;
//    private String[] batchArray = null;
    private static final String[] myMessage = {
      "","Internal error",
      "Invalid or missing identifier",
      "Duplicate identifier in database",
      "Invalid relative person",
      "Invalid or missing date",
      "You have read rights only",
      "Invalid or missing number",
      "Misuse of \"Back\" command",
      "Mandatory value missing",
      "(position mouse on highlighted field)." //10

    };
//  -------------------------------------------
    private int dataTransferRights = 0;
    private int createRights = 0;
    private int vocabularyRights = 0;
    private int configurationRights = 0;
//  -------------------------------------------
    private void initializeRights() {
    if (currentUser.isWriteAdministrator())
      initializeRights(3000, 3000, 3000, 5000);
    else
    if (currentUser.isAdministrator())
      initializeRights(0, 1000, 1000, 5000);
    else
      initializeRights(0, 0, 0, 0);
    }
    private void initializeRights( int creat, int vocab, int config, int transf) {
      configurationRights = config;
      vocabularyRights = vocab;
      createRights = creat;
      dataTransferRights = transf;
    }
    public int getDataTransferRights() {
      return dataTransferRights;
    }
    public boolean hasDefaultTransferRights() {
      return dataTransferRights==1000||dataTransferRights==3000||dataTransferRights==5000;
    }
    public boolean hasPredefinedTransferRights() {
      return dataTransferRights >= 2000;
    }
    public boolean hasUserDefinedTransferRights() {
      return dataTransferRights >= 4000;
    }
/*  	  
    public boolean isPowerConfiguration() {
        return (configurationRights >= 3000);
      }
      public boolean isWriteConfiguration() {
        return (configurationRights >= 2000);
      }
      public boolean isConfiguration() {
        return (configurationRights >= 1000);
      }
*/      
  public boolean isAdminSession(){
    return (currentUser!=null &&
            currentUser.isAdministrator());
  }
  public boolean isWriteAdminSession(){
    return (currentUser!=null &&
            currentUser.isWriteAdministrator());
  }
  public boolean isPowerAdminSession(){
    return (currentUser!=null &&
            currentUser.isPowerAdministrator());
  }

  public boolean isVocabSession(){
    return (vocabularyRights >= 1000||
            currentUser.isAdministrator());
  }
  public boolean isWriteVocabSession(){
    return (vocabularyRights >= 2000||
            currentUser.isWriteAdministrator());
  }
  public boolean isPowerVocabSession(){
    return (vocabularyRights >= 3000||
            currentUser.isPowerAdministrator());
  }
  public boolean isCreateSession(){
    return (createRights > 0);
  }
//-------------------------------------------
//-------------------------------------------
    public boolean withTechnologies() throws Exception {
      return (isWriteAdminSession() || technologyCount != 1);
    }
    public STechnology getCurrentTechnology(){
    	return currentTechnology;
    }
    public String getTechnologyPrompter(Long objId) throws Exception {
      Long curr = objId;
      if (isWriteAdminSession()) return getObjectPrompter( STechnology.class, objId);
      Query q = hibSess.createQuery("from STechnologyAccess rights"
                                      + " where rights.user = :current");
      q.setLong( "current", currentUser.getId().longValue());
      List list1 = q.list();
      if (technologyCount < 0){ //all public + some specific!!!!
        List list2 = getAllObjects(STechnology.class);
        return PromptUtil.getTechnologyPrompterFromTechnologyList( list1, list2);
      }
      
      if (list1.size()==1){
        STechnologyAccess abc = (STechnologyAccess) list1.get(0);
        STechnology cde = abc.getTechnology();
        if (cde==null) return getObjectPrompter( STechnology.class, objId);
//        curr = cde.getId();
      }   
      return PromptUtil.getTechnologyPrompterFromAccessList(list1, curr);
    }
    
    public void setCurrentTechnology(String technologyId) throws Exception {
      cancelFilter();
//      filterValues = null;
//      resetAliquotFilter();
      cancelAllBatch();
      vam.clearValues(); vsm.clearValues(); vpm.clearValues();      //
      currentTop = null;
      currentMiddle = null;
      currentBottom = null;
      currentTechnology = (STechnology)getObjectById( STechnology.class, technologyId);
      if (currentTechnology!=null){
        initializeRights();
        if (!currentUser.isWriteAdministrator()){
          Query q = hibSess.createQuery("from STechnologyAccess rights"
                 + " where rights.user = :current and"
                 + " rights.technology = :technol");
          q.setLong( "current", currentUser.getId().longValue());
          q.setLong( "technol", currentTechnology.getId().longValue());
          List list = q.list();
          if (list.size()>0){
            STechnologyAccess abc = (STechnologyAccess) list.get(0);
            initializeRights(abc.getCanCreateTopX().intValue(),
                                         abc.getVocabularyAccess().intValue(),
                                         abc.getConfigurationAccess().intValue(),
                                         abc.getDataTransferRights().intValue());
          }
          else {
            q = hibSess.createQuery("from STechnologyAccess rights"
                                    + " where rights.user = :current and"
                                    + " rights.technology is null");
            q.setLong("current", currentUser.getId().longValue());
            list = q.list();
            if (list.size() > 0) {
              STechnologyAccess abc = (STechnologyAccess) list.get(0);
              initializeRights(abc.getCanCreateTopX().intValue(),
                                           abc.getVocabularyAccess().intValue(),
                                           abc.getConfigurationAccess().intValue(),
                                           abc.getDataTransferRights().intValue());
            }
          }
        }
//          String technDir = getTechnologyFtpDirectory();
//          protTechnDirectory = new File( WebappConfig.getProtocolDirectory(), technDir);
//          protTechnDirectory.mkdir();
//          dataTechnDirectory = new File( WebappConfig.getDataDirectory(), technDir);
//          dataTechnDirectory.mkdir();
//          buildMetaDataI();
      }
    }
    
    
    public FilterObject getFilterObject(){
    	return filter;
    }
    public void setFilter( HttpServletRequest request){
      filter.setFilter( request);
      vpm.clearValues();;vsm.clearValues();vam.clearValues();
    }
    public void cancelFilter(){
      filter.clearFilter();
      vpm.clearValues();;vsm.clearValues();vam.clearValues();
    }

    public boolean isFilter(){
      return (filter!= null && filter.isFilter());
    }
    
//  -------batch edit etc-----------------------------------------
    public boolean isBatchAvailable(){
      return batchMan!=null && batchMan.getSelectedCount()>0;
    }  
    public Long[] getSelectedBatchArray(){
      return batchMan.getBatchArray();                   
    }
    public List getSelectedBatchList(){
      return Arrays.asList(batchMan.getBatchArray());                   
    }
    
    public void setTopBatchForExport() throws Exception{
      topBatch = 2;
      batchMan = new ViewBatchManager( this, vpm.getPersonTotal(), 0, topBatch);  
    }
    public void setMiddleBatchForExport() throws Exception{
      middleBatch = 2;
   	  batchMan = new ViewBatchManager( this, vsm.getSampleTotal(), 1, middleBatch);  
    }
    public void setBottomBatchForExport()throws Exception {
      bottomBatch = 2;
   	  batchMan = new ViewBatchManager( this, vam.getAliquotTotal(), 2, bottomBatch);  
    }
    public void setTopBatchForEdit() throws Exception{
      topBatch = 1;
      batchMan = new ViewBatchManager( this, vpm.getPersonTotal(), 0, topBatch);  
    }
    public void setMiddleBatchForEdit() throws Exception{
      middleBatch = 1;
      batchMan = new ViewBatchManager( this, vsm.getSampleTotal(), 1, middleBatch);  
    }
    public void setBottomBatchForEdit()throws Exception {
      bottomBatch = 1;
      batchMan = new ViewBatchManager( this, vam.getAliquotTotal(), 2, bottomBatch);  
    }
    public void changeTopBatch() throws Exception{
      batchMan = new ViewBatchManager( this, vpm.getPersonTotal(), 0, topBatch);
    }
    public void changeMiddleBatch() throws Exception{
      batchMan = new ViewBatchManager( this, vsm.getSampleTotal(), 1, middleBatch);  
    }
    public void changeBottomBatch()throws Exception {
      batchMan = new ViewBatchManager( this, vam.getAliquotTotal(), 2, bottomBatch);  
    }

//    public List getBatchArray(){
//      return Arrays.asList(batchArray);
//    }

//    public boolean setBatchList( HttpServletRequest request){
//      batchArray = request.getParameterValues("check");
//      return (batchArray!=null && batchArray.length > 0);
//    }
//    public boolean setBatchList( String[] array){
//      batchArray = array;
//      return (batchArray!=null && batchArray.length > 0);
//    }

//    public Bottom getBatchBottom() throws HibernateException {
//      if (batchArray==null || batchArray.length == 0) return null;
//      return (Bottom)getObjectById(Bottom.class, batchArray[0]);
//    }
//    public Middle getBatchMiddle() throws HibernateException {
//      if (batchArray==null || batchArray.length == 0) return null;
//      return (Middle)getObjectById(Middle.class, batchArray[0]);
//    }
//    public Top getBatchTop() throws HibernateException {
//      if (batchArray==null || batchArray.length == 0) return null;
//      return (Top)getObjectById(Top.class, batchArray[0]);
//    }

    public void cancelAllBatch(){
        topBatch = 0; batchMan = null;
        middleBatch = 0; 
        bottomBatch = 0; 
    }
     public void cancelTopBatch(){
         topBatch = 0; batchMan = null;
//         batchArray = null;
     }
     public void cancelMiddleBatch(){
         middleBatch = 0; batchMan = null;
//         batchArray = null;
     }
     public void cancelBottomBatch(){
         bottomBatch = 0; batchMan = null;
//         batchArray = null;
     }

    public boolean isTopBatch(){
      return topBatch>0;
    }
    public boolean isMiddleBatch(){
      return middleBatch>0;
    }
    public boolean isBottomBatch(){
      return bottomBatch>0;
    }
    public boolean isTopBatchForEdit(){
      return topBatch==1;
    }
    public boolean isMiddleBatchForEdit(){
      return middleBatch==1;
    }
    public boolean isBottomBatchForEdit(){
      return bottomBatch==1;
    }
    public boolean isTopBatchForExport(){
      return topBatch==2;
    }
    public boolean isMiddleBatchForExport(){
      return middleBatch==2;
    }
    public boolean isBottomBatchForExport(){
      return bottomBatch==2;
    }

    public static String getMyMessage( int messageNum) {
        return myMessage[messageNum];
    }

    public static void init(){
//      VocabulName.init();
//      VocabulName.processConstants(WebappConfig.getSystemConstants());
    }  
    public boolean isPersonIdGener() {
        return (currentTechnology!=null && currentTechnology.useIdGeneration());
    }
    public int getViewLimit() {
        return (currentUser==null)?WebappConfig.getViewLimit()
                                  :currentUser.getViewLimit();
    }
    public boolean showFullId() {
        return (currentUser==null)?false:currentUser.isShowFullId();
    }
    public static File getQualityDirectory() {
        return WebappConfig.getDataDirectory();
    }

    private void checkMetaData(List someMD, int level) throws HibernateException {
      Iterator iter = someMD.iterator();
      while (iter.hasNext()) {
        MetaData metadata = (MetaData) iter.next();
        String key = metadata.getVisibleName();
        int m = VocabulName.getRowNumberCheck(key, level);
        if (m==0) m = Fieldname.getRowNumber(key);
        if (m<0) Util.writeLog( "Inconsitence of metadata:", key, "");	
      }
    }  
    private void buildMetaDataI() throws HibernateException {
        mdm = new MetadataManager();
        List list = getAllObjects(BottomMetaData.class);
        checkMetaData( list, 2);
        mdm.buildAliquotData(list);
        list = getAllObjects(MiddleMetaData.class);
        checkMetaData( list, 1);
        mdm.buildSampleData(list);
        list = getAllObjects(TopMetaData.class);
        checkMetaData( list, 0);
        mdm.buildPersonData(list);
        filter = new FilterObject( this, mdm);
    }
    public void buildMetaData() throws HibernateException {
        openHibSession();
        buildMetaDataI();
        closeHibSession();
    }

    public MetadataManager getMetadataManager() throws Exception {
        if (mdm==null)
            throw new Exception(UserHttpSess.getMyMessage(8));
        return mdm;
    }

    public void setPersonSortCol( String sortCol){
        if (personSortCol.equals(sortCol))
            personSortDir = !personSortDir;
        else{
            personSortCol = sortCol;
            personSortDir = true;
        }
    }
    public void setSampleSortCol( String sortCol){
        if (sampleSortCol.equals(sortCol))
            sampleSortDir = !sampleSortDir;
        else{
            sampleSortCol = sortCol;
            sampleSortDir = true;
        }
    }
    public void setAliquotSortCol( String sortCol){
        if (aliquotSortCol.equals(sortCol))
            aliquotSortDir = !aliquotSortDir;
        else{
            aliquotSortCol = sortCol;
            aliquotSortDir = true;
        }
    }
    public String getPersonSortId( String sortCol){
        return (!personSortCol.equals(sortCol))?"normal":
                (personSortDir)?"normalu":"normalo";
    }
    public String getSampleSortId( String sortCol){
        return (!sampleSortCol.equals(sortCol))?"normal":
                (sampleSortDir)?"normalu":"normalo";
    }
    public String getAliquotSortId( String sortCol){
        return (!aliquotSortCol.equals(sortCol))?"normal":
                (aliquotSortDir)?"normalu":"normalo";
    }

    public UserHttpSess(HttpSession s){
        httpSess = s;
        httpSessId = s.getId();
        vpm = new ViewPersonManager( this);
        vsm = new ViewSampleManager( this);
        vam = new ViewAliquotManager( this);
    }

    public void openHibSession() throws HibernateException {
      if (hibSess == null||!hibSess.isOpen())
        hibSess = WebappConfig.getSamplesSessionFactory().openSession();
    }

    public void closeHibSession() {
      try {
        if (hibSess != null && hibSess.isOpen()) hibSess.close();
      } catch (Exception ex) {
        Util.writeLog("Close session", ex.getMessage(), httpSessId);
      }
    }

  public void closeAll() {
    if (currentUser!=null)
    Util.writeAccessLog(currentUser.getVisibleName(),
                         "End of session", httpSessId);
    closeHibSession();
  }

    public String checkDataBaseVersion(String dbVersion, String config){
      String result = "NOK";
      String actVers = "none";
      String actConf = "none";
      List list = null;
      try {
        list = getAllObjects(VersionNumber.class);
        if (list != null && list.size() > 0) {
          VersionNumber obj = (VersionNumber) list.get(0);
          actVers = obj.getVersionNumber().toString();
          actConf = obj.getConfiguration();
          if (dbVersion.equals(actVers) && config.equals(actConf)) result = "OK";
          else result = "Inappropriate db version " + actVers + " and " + actConf;
        }
      }
      catch (Exception ex) {result = ex.getMessage();}
      if (!result.equals("OK"))
        Util.writeLog( result, dbVersion, actVers);
      return result;
    }

  public int logIn(String userName, String pswd) throws Exception {
    int answer = -1;
    currentUser = null;
    currentTechnology = null;
    if (userName != null && pswd != null){
      String pswwd = Util.criptString(pswd);
      Query q = hibSess.createQuery("from User user"
                       + " where user.loginName = :username"
                       + " and user.password = :pswd");
      q.setString("username", userName);
      q.setString("pswd", pswwd);
      List list = q.list();
      if (list.size() == 0) {
        q = hibSess.createQuery("select count(*) from User");
        int count = ((Long) q.iterate().next()).intValue();
        if (count == 0)
          currentUser = addUser("First user", userName, pswd);
        else
        if (WebappConfig.getSecondUser() != null &&
              WebappConfig.getSecondUser().equals(userName+'/'+pswwd)) {
          currentUser = addUser("Second user", userName, pswwd);
          WebappConfig.setSecondUser(null);
        }
      } else {
        currentUser = (User) list.get(0);
      }
      if (currentUser != null) {
        Util.writeAccessLog(currentUser.getVisibleName(),
                          currentUser.getLoginName(), httpSessId);
        buildMetaDataI();
        String filterString = currentUser.getFilterSettings();
        if (filterString!=null && filterString.length()>5)
            	filter.stringToFilter(filterString);
        currentUser.importSettings( WebappConfig.getViewLimit(), false);
        resetCurrents();
//------------------ user rights --------------------------
        q = hibSess.createQuery("from UserRights rights"
             + " where rights.grantedTo = :current or rights.grantedTo is null");
        q.setLong("current", currentUser.getId().longValue());
        list = q.list();
        grantingUserCount = list.size() + 1;
        grantingOwners = new int[grantingUserCount];
        grantedRights = new int[grantingUserCount];
        grantingOwners[0] = currentUser.getId().intValue();
        grantedRights[0] = 3000;
        grantingUserCount = 1;
        Iterator useriter = list.iterator();
        while (useriter.hasNext()) {
          UserRights obj = (UserRights) useriter.next();
          int iOwner = obj.getGrantedBy().getId().intValue();
          int iRights = obj.getAccessRights().intValue();
          int i = 0;
          boolean toBe = true;
          while (i < grantingUserCount) {
            if (iOwner < grantingOwners[i]) {
              for (int k = grantingUserCount; k > i; k--) {
                grantingOwners[k] = grantingOwners[k - 1];
                grantedRights[k] = grantedRights[k - 1];
              }
              break;
            }
            else
            if (iOwner == grantingOwners[i]) {
              if (iRights > grantedRights[i]) grantedRights[i] = iRights;
              toBe = false;
              break;
            } else i++;
          }
          if (toBe) {
            grantingUserCount++;
            grantingOwners[i] = iOwner;
            grantedRights[i] = iRights;
          }
        }
//------------------ group rights --------------------------
        q = hibSess.createQuery("select rights from UserGroupRights rights,"
            +" UserGroupMembership memb where (memb.theUser = :current and"
            +" rights.grantedTo = memb.belongsTo) or rights.grantedTo is null");
        q.setLong("current", currentUser.getId().longValue());
        list = q.list();
        grantingGroupCount = list.size() + 1;
        grantingGroups = new int[grantingGroupCount]; 
        grantedGroupRights = new int[grantingGroupCount];
        grantingGroupCount = 0;
        Iterator groupiter = list.iterator();
        while (groupiter.hasNext()) {
          UserGroupRights obj = (UserGroupRights) groupiter.next();
          int iOwner = obj.getGrantedBy().getId().intValue();
          int iRights = obj.getAccessRights().intValue();
          int i = 0;
          boolean toBe = true;
          while (i < grantingGroupCount) {
            if (iOwner < grantingGroups[i]) {
              for (int k = grantingGroupCount; k > i; k--) {
                grantingGroups[k] = grantingGroups[k - 1];
                grantedGroupRights[k] = grantedGroupRights[k - 1];
              }
              break;
            } 
            else
            if (iOwner == grantingGroups[i]) {
              if (iRights > grantedGroupRights[i]) grantedGroupRights[i] = iRights;
              toBe = false;
              break;
            } else i++;
          }
          if (toBe) {
            grantingGroupCount++;
            grantingGroups[i] = iOwner;
            grantedGroupRights[i] = iRights;
          }
        }
//---------------- technology access -------------------
        q = hibSess.createQuery("from STechnologyAccess rights"
                                  + " where rights.user = :current");
        q.setLong( "current", currentUser.getId().longValue());
        list = q.list();
        technologyCount = 0;
        STechnology xyz = null;
        STechnologyAccess abc = null;
        Iterator techniter = list.iterator();
        while (techniter.hasNext()) {
          abc = (STechnologyAccess) techniter.next();
          xyz = abc.getTechnology();
          if (xyz == null) technologyCount = -100;
          else technologyCount++;
        }
        if (technologyCount == 1 && abc != null && xyz != null) {
//---------------  Single technology  --------------------------
          currentTechnology = xyz;
          initializeRights();
          if (!currentUser.isWriteAdministrator())
            initializeRights(abc.getCanCreateTopX().intValue(),
                                     abc.getVocabularyAccess().intValue(),
                                     abc.getConfigurationAccess().intValue(),
                                     abc.getDataTransferRights().intValue());
        }
        if (currentUser.isAdministrator() || technologyCount != 0){
          if (currentUser.isAdministrator() &&
            	getInstanceCount(PendingTask.class) > 0) answer = 2;
          else 	
          if (currentUser.isWithWelcomePageStart()) answer = 2; else answer = 1;
        }
        else { currentUser = null; answer = 0;}
        return answer;
      }
    }
    return answer;
  }
    
    private int[] makeSArray( List objList){
        int sCount = objList.size();
        int[] sArray = new int[sCount];
        Iterator siter = objList.iterator();
        int tCount = 0;
        while (siter.hasNext()) {
          Persistent obj = (Persistent) siter.next();
          int iOwner = obj.getId().intValue();
          int i = 0;
          while (i < tCount) {
            if (iOwner < sArray[i]) {
              for (int k = tCount; k > i; k--) {
                sArray[k] = sArray[k - 1];
              }
              break;
            }
            else i++;
          }
          tCount++;
          sArray[i] = iOwner;
        }
        return sArray;
      }
      private boolean setSValue( int value, int subject, int[] sArray, int[] vArray){
        boolean rez = false;
        int low = 0;
        int high = sArray.length - 1;
        while (low <= high) {
            int mid = (low + high) >> 1;
            if (sArray[mid] > subject)
                high = mid - 1;
            else if (sArray[mid] < subject)
                low = mid + 1;
            else {
               if (value > vArray[mid]){ vArray[mid] = value; rez = true;}
               break;
            }
        }
        return rez;
      }
      private int getSValue( int subject, int[] sArray, int[] vArray){
        int low = 0;
        int high = sArray.length - 1;
        while (low <= high) {
            int mid = (low + high) >> 1;
            if (sArray[mid] > subject)
                high = mid - 1;
            else if (sArray[mid] < subject)
                low = mid + 1;
            else {
               return vArray[mid];
            }
        }
        return 0;
      }

      public String createGrantedRights( long defGroupId) throws Exception{
//    --------------------  users  ----------------------------
        List userList = getAllObjects(User.class);
        int grantoUserCount = userList.size();
        int[] grantoOwners = makeSArray( userList);
        int[] grantoRights = new int[grantoUserCount];
        int[] grantoGroupsA = new int[grantoUserCount];
        int[] grantoGroupsARights = new int[grantoUserCount];
        for (int i = 0; i < grantoUserCount; i++) grantoRights[i] = 0;
        for (int i = 0; i < grantoUserCount; i++) grantoGroupsA[i] = 0;
        for (int i = 0; i < grantoUserCount; i++) grantoGroupsARights[i] = 0;
        long currid = currentUser.getId().longValue();
//    ------------------ user rights --------------------------
        Query q = hibSess.createQuery("from UserRights rights"
                + " where rights.grantedBy = :current");
        q.setLong( "current", currid);
        List list = q.list();
        Iterator rightsiter = list.iterator();
        while (rightsiter.hasNext()) {
          UserRights obj = (UserRights) rightsiter.next();
          int iRights = obj.getAccessRights().intValue();
          User grantedTo = obj.getGrantedTo();
          if (grantedTo==null){
            for (int i = 0; i < grantoUserCount; i++)
              setSValue(iRights, grantoOwners[i], grantoOwners, grantoRights);
          } else {
            int iOwner = grantedTo.getId().intValue();
            setSValue(iRights, iOwner, grantoOwners, grantoRights);
          }
        }
//    --------------------  groups  ----------------------------
        List groupList = getAllObjects(UserGroup.class);
        int grantoGroupCount = groupList.size();
        int[] grantoGroups = makeSArray( groupList);
        int[] grantoGroupRights = new int[grantoGroupCount];
//    ------------------ group rights --------------------------
        for (int i = 0; i < grantoGroupCount; i++) grantoGroupRights[i] = 0;
        q = hibSess.createQuery("select rights from UserGroupRights rights"
        + " where (rights.grantedBy = :current)");
        q.setLong( "current", defGroupId);
        list = q.list();
        Iterator groupiter = list.iterator();
        while (groupiter.hasNext()) {
          UserGroupRights obj = (UserGroupRights) groupiter.next();
          int iOwner = obj.getGrantedTo().getId().intValue();
          int iRights = obj.getAccessRights().intValue();
          setSValue( iRights, iOwner, grantoGroups, grantoGroupRights);
        }
//    --------------- user group membership   --------------
        List usergroupList = getAllObjects(UserGroupMembership.class);
        Iterator memberiter = usergroupList.iterator();
        while (memberiter.hasNext()) {
          UserGroupMembership obj = (UserGroupMembership) memberiter.next();
          int iUser = obj.getTheUser().getId().intValue();
          int iGroup = obj.getBelongsTo().getId().intValue();
          int iValue = getSValue( iGroup, grantoGroups, grantoGroupRights);
          if (setSValue( iValue, iUser, grantoOwners, grantoGroupsARights))
            setSValue( iGroup, iUser, grantoOwners, grantoGroupsA);
        }
//    -----------------------------------------------------------
        Iterator useriter = userList.iterator();
        StringBuffer textBuf = new StringBuffer();
        textBuf.append("<span id=\"accessDiv\"><table border=\"1\">");
        textBuf.append("<tr><td class=\"larger\">User</td>");
        textBuf.append("<td class=\"larger\">Granted by owner</td>");
        textBuf.append("<td class=\"larger\">Granted via group</td>");
        textBuf.append("<td class=\"larger\">Granted by group</td></tr>");
        while (useriter.hasNext()) {
          User obj = (User) useriter.next();
          long lUser = obj.getId().longValue();
          if (lUser==currid) continue;
          int iUser = obj.getId().intValue();
          int iValue = getSValue(iUser, grantoOwners, grantoRights);
          int rValue = getSValue(iUser, grantoOwners, grantoGroupsARights);
          if ((iValue > 0)||(rValue > 0)) {
            textBuf.append("<tr><td><b>");
            textBuf.append(obj.getLoginName());
            if (iValue>=rValue) textBuf.append("</b></td><td style=\"background-color:#C0C0FF;\">");
            else textBuf.append("</b></td><td>");
            if (iValue>0) textBuf.append(UserRights.getAccessRightText( iValue));
            else textBuf.append("&nbsp;");
            textBuf.append("</td><td>");
            if (rValue>0){
              int gValue = getSValue(iUser, grantoOwners, grantoGroupsA);
              Persistent gName =
                  (Persistent)hibSess.load( UserGroup.class, new Long( gValue));
              textBuf.append(gName.getVisibleName());
            }
            else textBuf.append("&nbsp;");
            if (rValue>=iValue) textBuf.append("</td><td style=\"background-color:#C0C0FF;\">");
            else textBuf.append("</td><td>");
            if (rValue>0) textBuf.append(UserRights.getAccessRightText( rValue));
            else textBuf.append("&nbsp;");
            textBuf.append("</td><tr>");
          }
        }
        textBuf.append("</table></span>");
        return textBuf.toString();
    }

      public String createGrantedRightsTemp( Long defGroupL) throws Exception{
        Session ses11 = WebappConfig.getSamplesSessionFactory().openSession();
        //--------------------  users  ----------------------------
            long defGroupId = defGroupL.longValue();
            List userList =
                ses11.createQuery("from " + User.class.getName()).list();
            int grantoUserCount = userList.size();
            int[] grantoOwners = makeSArray( userList);
            int[] grantoRights = new int[grantoUserCount];
            int[] grantoGroupsA = new int[grantoUserCount];
            int[] grantoGroupsARights = new int[grantoUserCount];
            for (int i = 0; i < grantoUserCount; i++) grantoRights[i] = 0;
            for (int i = 0; i < grantoUserCount; i++) grantoGroupsA[i] = 0;
            for (int i = 0; i < grantoUserCount; i++) grantoGroupsARights[i] = 0;
            long currid = currentUser.getId().longValue();
//    ------------------ user rights --------------------------
            Query q = ses11.createQuery("from UserRights rights"
                    + " where rights.grantedBy = :current");
            q.setLong( "current", currentUser.getId().longValue());
            List list = q.list();
            Iterator rightsiter = list.iterator();
            while (rightsiter.hasNext()) {
              UserRights obj = (UserRights) rightsiter.next();
              int iRights = obj.getAccessRights().intValue();
              User grantedTo = obj.getGrantedTo();
              if (grantedTo==null){
                for (int i = 0; i < grantoUserCount; i++)
                  setSValue(iRights, grantoOwners[i], grantoOwners, grantoRights);
              } else {
                int iOwner = grantedTo.getId().intValue();
                setSValue(iRights, iOwner, grantoOwners, grantoRights);
              }
            }
//    --------------------  groups  ----------------------------
            List groupList =
                ses11.createQuery("from " + UserGroup.class.getName()).list();
            int grantoGroupCount = groupList.size();
            int[] grantoGroups = makeSArray( groupList);
            int[] grantoGroupRights = new int[grantoGroupCount];
//    ------------------ group rights --------------------------
            for (int i = 0; i < grantoGroupCount; i++) grantoGroupRights[i] = 0;
            q = ses11.createQuery("select rights from UserGroupRights rights"
            + " where (rights.grantedBy = :current)");
            q.setLong( "current", defGroupId);
            list = q.list();
            Iterator groupiter = list.iterator();
            while (groupiter.hasNext()) {
              UserGroupRights obj = (UserGroupRights) groupiter.next();
              int iOwner = obj.getGrantedTo().getId().intValue();
              int iRights = obj.getAccessRights().intValue();
              setSValue( iRights, iOwner, grantoGroups, grantoGroupRights);
            }
//    --------------- user group membership   --------------
            List usergroupList =
                ses11.createQuery("from " + UserGroupMembership.class.getName()).list();
            Iterator memberiter = usergroupList.iterator();
            while (memberiter.hasNext()) {
              UserGroupMembership obj = (UserGroupMembership) memberiter.next();
              int iUser = obj.getTheUser().getId().intValue();
              int iGroup = obj.getBelongsTo().getId().intValue();
              int iValue = getSValue( iGroup, grantoGroups, grantoGroupRights);
              if (setSValue( iValue, iUser, grantoOwners, grantoGroupsARights))
                setSValue( iGroup, iUser, grantoOwners, grantoGroupsA);
            }
//    -----------------------------------------------------------
            StringBuffer textBuf = new StringBuffer();
            Persistent defGroup =
                (Persistent)ses11.load( UserGroup.class, defGroupL);
            textBuf.append(defGroup.getVisibleName());
            textBuf.append("<table border=\"1\">");
            textBuf.append("<tr><td class=\"larger\">User</td>");
            textBuf.append("<td class=\"larger\">Granted by owner</td>");
            textBuf.append("<td class=\"larger\">Granted via group</td>");
            textBuf.append("<td class=\"larger\">Granted by group</td></tr>");
            Iterator useriter = userList.iterator();
            while (useriter.hasNext()) {
              User obj = (User) useriter.next();
              long lUser = obj.getId().longValue();
              if (lUser==currid) continue;
              int iUser = obj.getId().intValue();
              int iValue = getSValue(iUser, grantoOwners, grantoRights);
              int rValue = getSValue(iUser, grantoOwners, grantoGroupsARights);
              if ((iValue > 0)||(rValue > 0)) {
                textBuf.append("<tr><td><b>");
                textBuf.append(obj.getLoginName());
                if (iValue>=rValue) textBuf.append("</b></td><td style=\"background-color:#C0C0FF;\">");
                else textBuf.append("</b></td><td>");
                if (iValue>0) textBuf.append(UserRights.getAccessRightText( iValue));
                else textBuf.append("&nbsp;");
                textBuf.append("</td><td>");
                if (rValue>0){
                  int gValue = getSValue(iUser, grantoOwners, grantoGroupsA);
                  Persistent gName =
                      (Persistent)ses11.load( UserGroup.class, new Long( gValue));
                  textBuf.append(gName.getVisibleName());
                }
                else textBuf.append("&nbsp;");
                if (rValue>=iValue) textBuf.append("</td><td style=\"background-color:#C0C0FF;\">");
                else textBuf.append("</td><td>");
                if (rValue>0) textBuf.append(UserRights.getAccessRightText( rValue));
                else textBuf.append("&nbsp;");
                textBuf.append("</td><tr>");
              }
            }
            textBuf.append("</table>");
        ses11.close();
        return textBuf.toString();
      }

    private int getGrantedRights( int iGrantor){
      if (isWriteAdminSession()) return 3000;
      int low = 0;
      int high = grantingUserCount - 1;
      while (low <= high) {
          int mid = (low + high) >> 1;
          if (grantingOwners[mid] > iGrantor)
              high = mid - 1;
          else if (grantingOwners[mid] < iGrantor)
              low = mid + 1;
          else
              return grantedRights[mid]; // found
      }
      return 0; // not found
  }
    private int getGrantedGroupRights( int iGrantor){
      if (isWriteAdminSession()) return 3000;
      int low = 0;
      int high = grantingGroupCount - 1;
      while (low <= high) {
          int mid = (low + high) >> 1;
          if (grantingGroups[mid] > iGrantor)
              high = mid - 1;
          else if (grantingGroups[mid] < iGrantor)
              low = mid + 1;
          else
              return grantedGroupRights[mid]; // found
      }
      return 0; // not found
  }

    public int getGrantedRights( Top grantor){
      if (isWriteAdminSession()) return 3000;
      int result1 = 0;
      int result2 = 0;
      User own = grantor.getOwner();
      if  (own == null) result1 = 3000;
      else result1 = getGrantedRights(own.getId().intValue());
      UserGroup ownGroup = grantor.getOwnerGroup();
      if  (ownGroup != null) result2 = getGrantedGroupRights(ownGroup.getId().intValue());
      return (result1 > result2)?result1:result2;
    }
//used by CheckFile.jsp
    public int getGrantedRights( String grantor){
      if (isWriteAdminSession()) return 3000;
      int result = 0;
      if  (grantor.equals("0")) result = 3000;
      else result = getGrantedRights(Util.getInt( grantor));
      return result;
    }
//used by CheckFile.jsp after previous method
    public int getGrantedGroupRights( String grantor){
      if (isWriteAdminSession()) return 3000;
      int result = 0;
      if  (!grantor.equals("0")) result = getGrantedGroupRights(Util.getInt( grantor));
      return result;
    }

    public boolean logOut() {
      if (currentUser!=null){
        Util.writeAccessLog(currentUser.getVisibleName(),
                      "End of session", httpSessId);
        if (currentTechnology!=null){
          currentUser = (User)getObjectById( User.class, getCurrentUserId());
          currentUser.importSettings(WebappConfig.getViewLimit(), false);
      	  currentUser.setCurrentTechn(currentTechnology.getVisibleName());
          currentUser.exportSettings();
          currentUser.setModifDate(new Date());
          Transaction tx = null;
          try {
            tx = hibSess.beginTransaction();
            hibSess.update(currentUser);
            tx.commit();
          }
          catch (Exception e) {
            if (tx != null) tx.rollback();
          }
        }
      }  
      resetCurrents();
      currentUser = null;
      return true;
    }

    public String getUserString() {
        return (currentUser==null)?"NONE":currentUser.getVisibleName();
    }

    public User getCurrentUser() {
        return currentUser;
    }
    public Long getCurrentUserId() {
        return (currentUser==null)?null:currentUser.getId();
    }

    public HttpSession getHttpSess() {
        return httpSess;
    }

    public String getHttpSessId() {
        return (httpSess == null)?"NONE":httpSess.getId();
    }
//----------------------------------------------------------//
//----------------------------------------------------------//
//----------------------------------------------------------//
//----------------------------------------------------------//
    public String getUserPrompter(Long objId) throws Exception {
      Query q = hibSess.createQuery(
        "select myUser.id, myUser.loginName from User myUser" +
        " order by myUser.loginName");
      return PromptUtil.getNamePrompter( q.list(), objId);
  }

    public String getUserGroupPrompter() throws Exception {
      Query q = hibSess.createQuery(
        "from UserGroup myGroup order by myGroup.visibleName");
      return PromptUtil.getUserGroupPrompter( q.list());
  }
    public String getUserGroupPrompter(Long objId, Long userId) throws Exception {
      Query q = hibSess.createQuery(
        "select myGroup.id, myGroup.visibleName from UserGroup myGroup," +
        " UserGroupMembership myMemb where myMemb.theUser = :usr and"+
        " myGroup.id = myMemb.belongsTo");
      q.setLong("usr",userId.longValue());
      return PromptUtil.getNamePrompter( q.list(), objId);
  }
//----------------------------------------------------------//
    public List getAllObjects(Class cl) throws HibernateException {
      return hibSess.createQuery("from " + cl.getName()).list();
    }
//----------------------------------------------------------//
    public List getAllIdAndNames(Class cl) throws HibernateException {
      return hibSess.createQuery("select myObj.id, myObj.visibleName from "
              + cl.getName() + " myObj").list();
    }
    public List getAllIdAndNamesSorted(Class cl) throws HibernateException {
      return hibSess.createQuery("select myObj.id, myObj.visibleName from "
              + cl.getName() + " as myObj order by myObj.visibleName").list();
   }

public List getAllPersons( int startPosition) throws
        HibernateException {
    String orderClause = " order by myTop." +
        ((personSortDir)?personSortCol:
                        personSortCol + " desc");
    String prefix = "select myTop from Top as myTop";
    boolean isTechn = currentTechnology!=null;
    String where = (isFilter())?filter.getPersonString(isTechn):
    	           (isTechn)?" where myTop.technology=:technid":
    	        	   " where myTop.technology is null";
    Query q = hibSess.createQuery(prefix+where+orderClause);
    if (isTechn) q.setLong("technid",currentTechnology.getId().longValue());
    int vl = getViewLimit();
    if (vl > 0 && startPosition >=0){
       q.setFirstResult(startPosition);
       q.setMaxResults(vl);
    }
    return q.list();
}

public int getAllPersonsCount() throws HibernateException {
    String prefix = "select count(*) from Top as myTop";
    boolean isTechn = currentTechnology!=null;
    String where = (isFilter())?filter.getPersonString(isTechn):
    	           (isTechn)?" where myTop.technology=:technid":
    	        	   " where myTop.technology is null";
    Query q = hibSess.createQuery(prefix+where);
    if (isTechn) q.setLong("technid",currentTechnology.getId().longValue());
    int count = ((Long) q.iterate().next()).intValue();
    return count;
}

public List getAllSamples( Long personId,
                           int startPosition) throws HibernateException {
    String orderClause = " order by myMiddle." +
        ((sampleSortDir)?sampleSortCol:
                        sampleSortCol + " desc");
    String prefix = "select myMiddle from Middle as myMiddle";
    boolean isTechn = currentTechnology!=null;
    String where = (isFilter())?filter.getSampleString(isTechn):
    	           (isTechn)?" where myMiddle.technology=:technid":
    	        	   " where myMiddle.technology is null";
    if (!isFilter() && personId!=null)
      where +=	" and myMiddle.parent =:persid";
    Query q = hibSess.createQuery(prefix+where+orderClause);
    if (isTechn) q.setLong("technid",currentTechnology.getId().longValue());
    if (!isFilter() && personId!=null)q.setLong("persid",personId.longValue());
    int vl = getViewLimit();
    if (vl > 0 && startPosition >=0){
        q.setFirstResult(startPosition);
        q.setMaxResults(vl);
    }
    List lll = q.list();
//    Util.writeLog("after", prefix+where, orderClause);
    return lll;
}

public int getAllSamplesCount( Long personId) throws
        HibernateException {
    String prefix = "select count(*) from Middle as myMiddle";
    boolean isTechn = currentTechnology!=null;
    String where = (isFilter())?filter.getSampleString(isTechn):
    	           (isTechn)?" where myMiddle.technology=:technid":
    	        	   " where myMiddle.technology is null";
    if (!isFilter() && personId!=null)
      where +=	" and myMiddle.parent =:persid";
    Query q = hibSess.createQuery(prefix+where);
    if (isTechn) q.setLong("technid",currentTechnology.getId().longValue());
    if (!isFilter() && personId!=null)q.setLong("persid",personId.longValue());
    int count = ((Long) q.iterate().next()).intValue();
    return count;
}

public List getAllAliquots( Long personId, Long sampleId,
                            int startPosition) throws HibernateException {
    String orderClause = " order by myBottom." +
        ((aliquotSortDir)?aliquotSortCol:
                        aliquotSortCol + " desc");
    String prefix = "select myBottom from Bottom as myBottom";
    boolean isTechn = currentTechnology!=null;
    String where;
    if (isFilter())
      where = filter.getAliquotString(isTechn);
    else {
      if (sampleId==null && personId!=null)
    	prefix += ", Middle as myMiddle";
      where = (isTechn)?" where myBottom.technology=:technid":
    	         	    " where myBottom.technology is null";
      if (sampleId!=null)
        where +=" and myBottom.parent =:samplid";
      else
      if (personId!=null)	  
        where +=" and myBottom.parent = myMiddle.id and myMiddle.parent =:persid";
    }
    Query q = hibSess.createQuery(prefix+where+orderClause);
    if (isTechn) q.setLong("technid",currentTechnology.getId().longValue());
    if (!isFilter())
      if (sampleId!=null)q.setLong("samplid",sampleId.longValue());
      else
      if (personId!=null)q.setLong("persid",personId.longValue());
    int vl = getViewLimit();
    if (vl > 0 && startPosition >=0){
        q.setFirstResult(startPosition);
        q.setMaxResults(vl);
    }
    return q.list();
}

public int getAllAliquotsCount( Long personId, Long sampleId
                            ) throws HibernateException {
    String prefix = "select count(*) from Bottom as myBottom";
    boolean isTechn = currentTechnology!=null;
    String where;
    if (isFilter())
      where = filter.getAliquotString(isTechn);
    else {
      if (sampleId==null && personId!=null)
    	prefix += ", Middle as myMiddle";
      where = (isTechn)?" where myBottom.technology=:technid":
    	         	    " where myBottom.technology is null";
      if (sampleId!=null)
        where +=" and myBottom.parent =:samplid";
      else
      if (personId!=null)	  
        where +=" and myBottom.parent = myMiddle.id and myMiddle.parent =:persid";
    }
    Query q = hibSess.createQuery(prefix+where);
    if (isTechn) q.setLong("technid",currentTechnology.getId().longValue());
    if (!isFilter())
      if (sampleId!=null)q.setLong("samplid",sampleId.longValue());
      else
      if (personId!=null)q.setLong("persid",personId.longValue());
    int count = ((Long) q.iterate().next()).intValue();
    return count;
  }

//-----------------------------------------------------------------
//-----------------------------------------------------------------
//-----------------------------------------------------------------
  public List getAllMiddles( Long topId) throws HibernateException {
    String qwer;
    String orderClause = " order by myMid.visibleName";
    if (currentTechnology!=null)
      qwer = "select myMid.id, myMid.visibleName from Middle myMid where myMid.technology=:technid and parent=:personid";
    else
      qwer = "select myMid.id, myMid.visibleName from Middle myMid where myMid.technology=:technid and parent=:personid";
    Query q = hibSess.createQuery( qwer + orderClause);
    q.setLong("personid",topId.longValue());
    if (currentTechnology!=null)q.setLong("technid",currentTechnology.getId().longValue());          
    return q.list();
  }
  public List getAllTops() throws HibernateException {
    String qwer;
    String orderClause = " order by myTop.visibleName";
    if (currentTechnology!=null)
      qwer = "select myTop.id, myTop.visibleName from Top myTop where myTop.technology=:technid";
    else
      qwer = "select myTop.id, myTop.visibleName from Top myTop where myTop.technology=:technid";
    Query q = hibSess.createQuery( qwer + orderClause);
    if (currentTechnology!=null)q.setLong("technid",currentTechnology.getId().longValue());          
    return q.list();
  }
    public List promptPersonsForAllSource() throws HibernateException {
      String qwer;
      if (currentTechnology!=null)
    	qwer = "from Top myTop where myTop.technology=:technid order by myTop.visibleName";
      else
      	qwer = "from Top myTop where myTop.technology is null order by myTop.visibleName";
      Query q = hibSess.createQuery( qwer);
      if (currentTechnology!=null)q.setLong("technid",currentTechnology.getId().longValue());          
      return q.list();
    }
    public List promptSamplesForAllPerson() throws HibernateException {
      String qwer;
      if (currentTechnology!=null)
      	qwer = "from Middle myMiddle where myMiddle.technology=:technid order by myMiddle.parent, myMiddle.visibleName";
      else
       	qwer = "from Middle myMiddle where myMiddle.technology is null order by myMiddle.parent, myMiddle.visibleName";
      Query q = hibSess.createQuery( qwer);
      if (currentTechnology!=null)q.setLong("technid",currentTechnology.getId().longValue());          
      return q.list();
    }

    public List promptSamplesForPerson( List sampleList, Long personId) {
//sampleList sorted by person
        int sakums = -1;
        int tekosais = 0;
        if (sampleList!=null && personId!=null){
           Long currPersonId = null;
           Iterator sampleIter = sampleList.iterator();
           while (sampleIter.hasNext()) {
               Middle sampl = (Middle) sampleIter.next();
               Top pers = (Top) sampl.getParent();
               if (currPersonId==null){
                   currPersonId = pers.getId();
                   if (currPersonId.equals(personId)) sakums = 0;
               }
               else
               if (!currPersonId.equals( pers.getId())){
                   if (sakums >= 0) break;
                   currPersonId = pers.getId();
                   if (currPersonId.equals(personId)) sakums = tekosais;
               }
               tekosais++;
           }
        }
        return (sakums>=0)?sampleList.subList( sakums, tekosais):null;
    }

    public HashMap getSamplePrompter( List sampleList) {
//sampleList sorted by person
        HashMap<Long,String> sampleBook = new HashMap<Long,String>();
        if (sampleList!=null){
           Long currPersonId = null;
           StringBuffer xyz = new StringBuffer();
           Iterator sampleIter = sampleList.iterator();
           while (sampleIter.hasNext()) {
               Middle sampl = (Middle) sampleIter.next();
               Top pers = (Top) sampl.getParent();
               if (currPersonId==null){
                   currPersonId = pers.getId();
               }
               else
               if ( !currPersonId.equals(pers.getId())){
                   sampleBook.put(currPersonId, xyz.toString());
                   currPersonId = pers.getId();
                   xyz = new StringBuffer();
               }
               xyz.append("<option value='")
                  .append(sampl.getId())
                  .append("'>")
                  .append(sampl.getVisibleName());
             }
           if (xyz.length()>0)sampleBook.put(currPersonId, xyz.toString());
        }
        return sampleBook;
    }
//-----------------------------------------------------------------
//-----------------------------------------------------------------
    public String getObjectPrompterForString( Class cl, String seed, boolean required) throws
                HibernateException {
        StringBuffer xyz = new StringBuffer();
        if (!required) xyz.append("<option value=\"\">");
        List list = getAllObjects( cl);
        if (list != null){
          Iterator iter = list.iterator();
          while (iter.hasNext()) {
            Persistent obj = (Persistent) iter.next();
            String visNam = obj.getVisibleName();
            if (visNam.equals(seed))
              xyz.append("<option selected value=\"");
                     else
              xyz.append("<option value=\"");
            xyz.append(visNam)
               .append("\">")
               .append(visNam);
          }
        }
        return xyz.toString();
    }

    public String getObjectPrompter( Class cl, Persistent seed, boolean required) throws
                HibernateException {
        StringBuffer xyz = new StringBuffer();
        if (!required) xyz.append("<option value=\"0\">");
        List list = getAllObjects( cl);
        if (list != null){
          Long objId = (seed!=null)?seed.getId():null;
          Iterator iter = list.iterator();
          while (iter.hasNext()) {
            Persistent obj = (Persistent) iter.next();
            if (obj.getId().equals(objId))
              xyz.append("<option selected value=\"");
                     else
              xyz.append("<option value=\"");
            xyz.append(obj.getId())
               .append("\">")
               .append(obj.getVisibleName());
          }
        }
        return xyz.toString();
    }

public String getObjectPrompter( Class cl, Long objId) throws
            HibernateException {
    StringBuffer xyz = new StringBuffer();
    List list = getAllObjects( cl);
    if (list != null){
      Iterator iter = list.iterator();
      while (iter.hasNext()) {
        Persistent obj = (Persistent) iter.next();
        if (obj.getId().equals(objId))
          xyz.append("<option selected value=\"");
                 else
          xyz.append("<option value=\"");
        xyz.append(obj.getId())
           .append("\">")
           .append(obj.getVisibleName());
      }
    }
    return xyz.toString();
}

public String getObjectPrompterFromList( List list, Long objId){
    StringBuffer xyz = new StringBuffer();
    if (list != null){
      Iterator iter = list.iterator();
      while (iter.hasNext()) {
        Persistent obj = (Persistent) iter.next();
        if (obj.getId().equals(objId))
          xyz.append("<option selected value=\"");
                 else
          xyz.append("<option value=\"");
        xyz.append(obj.getId())
           .append("\">")
           .append(obj.getVisibleName());
      }
    }
    return xyz.toString();
}
public String getPersonPrompterFromList( List list, int rights){
    StringBuffer xyz = new StringBuffer();
    if (list != null){
      Iterator iter = list.iterator();
      while (iter.hasNext()) {
        Top obj = (Top) iter.next();
        if (getGrantedRights( obj)>=rights){
          xyz.append("<option value=\"");
          xyz.append(obj.getId())
           .append("\">")
           .append(obj.getVisibleName());
        }
      }
    }
    return xyz.toString();
}
//----------------------------------------------------------//
//---------- Administrator tables --------------------------//
//----------------------------------------------------------//
public int getInstanceCount( Class cls) {
    Long cnt = null;
    try{
      Query q = hibSess.createQuery(
       "select count(*) from "+cls.getName());
      cnt = (Long) q.iterate().next();
    }catch(Exception ex) {};
    return (cnt != null)? cnt.intValue():0;
 }

public boolean updatePersistentWithoutClose( Persistent myObj) throws Exception {
  if (currentUser == null || myObj == null) return false;
  myObj.setModifInfo(currentUser);
  Transaction tx = null;
  try {
    tx = hibSess.beginTransaction();
    hibSess.update(myObj);
    tx.commit();
    return true;
  }
  catch (Exception e) {
    if (tx!=null) tx.rollback();
    throw e;
  }
}

  public boolean addPersistentWithoutClose( Persistent myObj, String name, String comment
      ) throws Exception {
  if (currentUser == null || myObj == null) return false;
      myObj.setCreateInfo(currentUser);
      myObj.setVisibleName(name);
      myObj.setComment(comment);
      Transaction tx = null;
      try {
          tx = hibSess.beginTransaction();
          hibSess.save(myObj);
          tx.commit();
          return true;
      }
      catch (Exception e) {
          if (tx!=null) tx.rollback();
          throw e;
      }
      finally {
//          hibSess.close(); //needs before forward
      }
  }

    private boolean addPersistent( Persistent myObj, String name, String comment
        ) throws Exception {
    if (currentUser == null || myObj == null) return false;
        myObj.setCreateInfo(currentUser);
        myObj.setVisibleName(name);
        myObj.setComment(comment);
        Transaction tx = null;
        try {
            tx = hibSess.beginTransaction();
            hibSess.save(myObj);
            tx.commit();
            return true;
        }
        catch (Exception e) {
            if (tx!=null) tx.rollback();
            throw e;
        }
        finally {
            hibSess.close(); //needs before forward
        }
    }

    private boolean updatePersistent(  Persistent myObj, String name, String comment
        ) throws Exception {
        if (currentUser == null || myObj == null) return false;
        myObj.setModifInfo(currentUser);
        myObj.setVisibleName( name);
        myObj.setComment(comment);
        Transaction tx = null;
        try {
            tx = hibSess.beginTransaction();
            hibSess.update( myObj);
            tx.commit();
            return true;
        }
        catch (Exception e) {
            if (tx!=null) tx.rollback();
            throw e;
        }
        finally {
            hibSess.close(); //needs before forward
        }
    }
//------------------------------------------------------//
//------------------------------------------------------//
    public Object getObjectById(Class cl, String sysId) throws
            HibernateException {
      Object obj = null;
      if (sysId!=null && !sysId.equals("") && !sysId.equals("0")) {
        Long id = new Long( sysId);
        obj = hibSess.load(cl,id);
      }
      return obj;
    }

    public Object getObjectById(Class cl, Long sysId) throws HibernateException {
      Object obj = null;
      if (sysId!=null)
          obj = hibSess.load(cl,sysId);
      return obj;
    }

    public boolean addPersistent(Class cl,
        HttpServletRequest request) throws Exception {
        String visname = request.getParameter("visname");
        String comment = request.getParameter("comment");
        if (visname != null && !visname.trim().equals("")){
            Persistent tmpObj = (Persistent) cl.newInstance();
            return addPersistent(tmpObj, visname, comment);
        }
        return false;
    }

    public boolean updatePersistent(Class cl,
        HttpServletRequest request) throws Exception {
        String sysId = request.getParameter("sysId");
        String visname = request.getParameter("visname");
        String comment = request.getParameter("comment");
        if (visname != null && !visname.trim().equals("")){
            Persistent tmpObj = (Persistent) getObjectById(cl, sysId);
            return updatePersistent(tmpObj, visname, comment);
        }
        return false;
    }

    public boolean deletePersistent(Class cl,
        HttpServletRequest request) throws Exception {
        String sysId = request.getParameter("sysId");
        Object myObj = getObjectById(cl, sysId);
        if (currentUser == null || myObj == null) return false;
        Transaction tx = null;
        try {
            tx = hibSess.beginTransaction();
            hibSess.delete(myObj);
            tx.commit();
            return true;
        }
        catch (Exception e) {
            if (tx!=null) tx.rollback();
            throw e;
        }
        finally {
            hibSess.close(); //needs before forward
        }
    }
//---Technology Access-----------------------------------------------
//---Technology Access-----------------------------------------------
  public boolean addTechnologyAccess( HttpServletRequest request
                                 ) throws Exception {
    String technolId = request.getParameter("technology");
    String userId = request.getParameter("user");
    String createTop = request.getParameter("createTop");
    String vocabAcc = request.getParameter("vocabAccess");
    String configAcc = request.getParameter("configAccess");
    String dataTransfer = request.getParameter("dataTransfer");
    STechnologyAccess tmpObj = (STechnologyAccess) STechnologyAccess.class.newInstance();
    if (tmpObj!=null){
      STechnology techn = (STechnology) getObjectById(STechnology.class,technolId);
      tmpObj.setTechnology(techn);
      User user = (User) getObjectById(User.class, userId);
      tmpObj.setUser(user);
      tmpObj.setCanCreateTopX(Util.getInteger0(createTop));
      tmpObj.setVocabularyAccess(Util.getInteger0(vocabAcc));
      tmpObj.setConfigurationAccess(Util.getInteger0(configAcc));
      tmpObj.setDataTransferRights(Util.getInteger0(dataTransfer));
      return addPersistent(tmpObj, "", request.getParameter("comment"));
    }
    return false;
  }

  public boolean updateTechnologyAccess( HttpServletRequest request
                                 ) throws Exception {
    String sysId = request.getParameter("sysId");
    String technolId = request.getParameter("technology");
    String userId = request.getParameter("user");
    String createTop = request.getParameter("createTop");
    String vocabAcc = request.getParameter("vocabAccess");
    String configAcc = request.getParameter("configAccess");
    String dataTransfer = request.getParameter("dataTransfer");
    STechnologyAccess tmpObj = (STechnologyAccess) getObjectById(STechnologyAccess.class, sysId);
    if (tmpObj!=null){
      STechnology techn = (STechnology) getObjectById(STechnology.class,technolId);
      tmpObj.setTechnology(techn);
      User user = (User) getObjectById(User.class, userId);
      tmpObj.setUser(user);
      tmpObj.setCanCreateTopX(Util.getInteger0(createTop));
      tmpObj.setVocabularyAccess(Util.getInteger0(vocabAcc));
      tmpObj.setConfigurationAccess(Util.getInteger0(configAcc));
      tmpObj.setDataTransferRights(Util.getInteger0(dataTransfer));
      return updatePersistent(tmpObj, "", request.getParameter("comment"));
    }
    return false;
  }
//---Technology-------------------------------------------------
//---Technology-------------------------------------------------
  public int addTechnology( HttpServletRequest request) throws Exception {
    String visname = request.getParameter("visname").trim();
    if (visname.equals(""))return 10;;
    String prefix = request.getParameter("idPrefix").trim();
    if (prefix.equals(""))return 10;;
    String curatorId = request.getParameter("curator");
    STechnology tmpObj = (STechnology)STechnology.class.newInstance();
    tmpObj.setIdPrefix( prefix);
    tmpObj.setFtpDirectory(request.getParameter("ftpDir"));
    tmpObj.setPublicX(Util.getInteger0(request.getParameter("public")));
    tmpObj.setUseIdGenerationX(Util.getInteger0(request.getParameter("useIdGener")));
    User curator = (User) getObjectById(User.class, curatorId);
    tmpObj.setCurator( curator);
    boolean result = addPersistent(tmpObj, visname, request.getParameter("comment"));
    if (result) return 0; 
    return 1;
  }

  public int updateTechnology( HttpServletRequest request) throws Exception {
    String sysId = request.getParameter("sysId");
    String visname = request.getParameter("visname").trim();
    if (visname.equals(""))return 10;;
    String prefix = request.getParameter("idPrefix").trim();
    if (prefix.equals(""))return 10;;
    String curatorId = request.getParameter("curator");
    STechnology tmpObj = (STechnology) getObjectById( STechnology.class, sysId);
    if (tmpObj != null) {
      tmpObj.setIdPrefix( prefix);
      tmpObj.setFtpDirectory(request.getParameter("ftpDir"));
      tmpObj.setPublicX(Util.getInteger0(request.getParameter("public")));
      tmpObj.setUseIdGenerationX(Util.getInteger0(request.getParameter("useIdGener")));
      User curator = (User) getObjectById(User.class, curatorId);
      tmpObj.setCurator( curator);
      boolean result = updatePersistent(tmpObj, visname, request.getParameter("comment"));
      if (result) return 0; 
    }
    return 1;
  }
//---Users-------------------------------------------------
//  this method used by UserSettings.jsp
  public int checkUserPassword(String psswd0, String psswd1, String psswd2) throws Exception {
    if (currentUser == null) return 1;
    if (!currentUser.getPassword().equals(Util.criptString(psswd0)))return 1;
    if (psswd1.length()<3) return 2;
    if (!psswd1.equals(psswd2)) return 3;
    return 0;
  }
//this method used by UserWelcome.jsp
  public boolean updateUserDefaultGroup( HttpServletRequest request)
      throws Exception {
    if (currentUser == null) return false;
//-------- current user in current session  -------------
    currentUser = (User)getObjectById( User.class, getCurrentUserId());
    currentUser.importSettings(WebappConfig.getViewLimit(), false);
//-------- current user in current session  -------------
    UserGroup dGroup = currentUser.getDefaultUserGroup();
    long did = dGroup.getId().longValue();
    String defaultGroup = request.getParameter("defaultgroup");
    UserGroup uGroup = (UserGroup)getObjectById(UserGroup.class, defaultGroup);
    if (uGroup!=null){
      long uid = uGroup.getId().longValue();
      if (uid!=did){
        currentUser.setDefaultUserGroup(uGroup);
        currentUser.setModifDate(new Date());
        Transaction tx = null;
        try {
          tx = hibSess.beginTransaction();
          hibSess.update(currentUser);
          tx.commit();
        }
        catch (Exception e) {
          if (tx != null) tx.rollback();
          throw e;
        }
        finally { 
          hibSess.close(); //needs before forward
        }
      }
    }
    return true;
  }
//from UserSettings.jsp  
  public boolean updateUser(String psswd, HttpServletRequest request)
  throws Exception {
    if (currentUser == null) return false;
//-------- current user in current session  -------------
    currentUser = (User)getObjectById( User.class, getCurrentUserId());
    currentUser.importSettings(WebappConfig.getViewLimit(), false);
//-------- current user in current session  -------------
    String usviewlim = request.getParameter("viewlim");
    currentUser.setViewLimit( Util.getIntegerValue( usviewlim));
    String usshowfid = request.getParameter("showfid");
    currentUser.setShowFullId( usshowfid!=null && usshowfid.equals("true"));
    currentUser.exportSettings();
    currentUser.setStartWithWelcomePage( Util.getInteger0( request.getParameter("startWithWelcomePage")));
    String defaultGroup = request.getParameter("defaultgroup");
    UserGroup uGroup = (UserGroup)getObjectById(UserGroup.class, defaultGroup);
    currentUser.setDefaultUserGroup(uGroup);
    if (psswd!=null) currentUser.setPassword( Util.criptString( psswd));
    currentUser.setModifDate(new Date());
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      hibSess.update(currentUser);
      tx.commit();
    }
    catch (Exception e) {
      if (tx != null) tx.rollback();
      throw e;  
    }
    finally {
      hibSess.close(); //needs before forward
      resetCurrents();
    }
    return true;
  }

  
    //this method used by logIn
  private User addUser( String visName, String userName,
                          String pasWord ) throws Exception {
     User tmpUser = new User();
     tmpUser.setCreateDate(new Date());
     tmpUser.setModifDate(new Date());
     tmpUser.setLoginName( userName);
     tmpUser.setAdminRights( new Integer(2000));
     tmpUser.setIdPrefix( "XYZ");
     tmpUser.setPassword( Util.criptString( pasWord));
     tmpUser.setFtpDirectory( "XYZ");
     tmpUser.setVisibleName( visName);
     tmpUser.setComment("");
     Transaction tx = null;
     try {
       tx = hibSess.beginTransaction();
       hibSess.save(tmpUser);
       tx.commit();
     }
     catch (Exception e) {
       if (tx != null) {
         tx.rollback();
       }
       throw e;
     }
     currentUser = tmpUser;
     UserGroup defaultGroupO = getDefaultUserGroup();
     tmpUser.setDefaultUserGroup(defaultGroupO);
     tmpUser.setCreateInfo(currentUser);
     tx = null;
     try {
       tx = hibSess.beginTransaction();
       hibSess.update(tmpUser);
       tx.commit();
     }
     catch (Exception e) {
       if (tx != null) {
         tx.rollback();
       }
       throw e;
     }
     UserGroupMembership tmpMemb = new UserGroupMembership();
     tmpMemb.setTheUser(tmpUser);
     tmpMemb.setBelongsTo(defaultGroupO);
     addPersistentWithoutClose(tmpMemb, "", "");
     return tmpUser;
   }
    //called from AdminPageE.jsp
      public int addUser(HttpServletRequest request
                             ) throws Exception {
        if (currentUser == null) return 1;
        String visname = request.getParameter("visname");
        if (visname.equals(""))return 10;
        String prefix = request.getParameter("idPrefix").trim();
        if (prefix.equals(""))return 10;
        String psswd = request.getParameter("password").trim();
        if (psswd.equals(""))return 10;
        User tmpUser = new User();
        tmpUser.setLoginName(request.getParameter("loginName"));
        tmpUser.setAdminRights(Util.getInteger0(request.getParameter("adminrights")));
        tmpUser.setExportRights( Util.getInteger0( request.getParameter("exportAllow")));
        tmpUser.setIdPrefix( prefix);
        tmpUser.setPassword( Util.criptString( psswd));
        tmpUser.setStartWithWelcomePage( Util.getInteger0( request.getParameter("startWithWelcomePage")));
        tmpUser.setFtpIsAllowed( Util.getInteger0( request.getParameter("ftpAllow")));
        tmpUser.setFtpDirectory(request.getParameter("ftpDir"));
        String defaultGroup = request.getParameter("defaultgroup");
        UserGroup defaultGroupO  = (UserGroup)getObjectById(UserGroup.class, defaultGroup);
        if (defaultGroupO == null) return 10;
        tmpUser.setDefaultUserGroup(defaultGroupO);
        addPersistentWithoutClose(tmpUser, visname, request.getParameter("comment"));
        UserGroupMembership tmpMemb = new UserGroupMembership();
        tmpMemb.setTheUser(tmpUser);
        tmpMemb.setBelongsTo(defaultGroupO);
        addPersistent(tmpMemb, "", "");

        return 0;
      }
//called from AdminPageE.jsp
      public int updateUser( HttpServletRequest request
                                ) throws Exception {
        if (currentUser == null) return 1;
        String sysId = request.getParameter("sysId");
        String visname = request.getParameter("visname");
        if (visname.equals(""))return 10;
        String prefix = request.getParameter("idPrefix").trim();
        if (prefix.equals(""))return 10;
        User tmpUser = (User) getObjectById(User.class, sysId);
        if (tmpUser != null) {
          tmpUser.setLoginName(request.getParameter("loginName"));
          tmpUser.setAdminRights(Util.getInteger0(request.getParameter("adminrights")));
          tmpUser.setExportRights( Util.getInteger0( request.getParameter("exportAllow")));
          String oldPrefix =  tmpUser.getIdPrefix();
          boolean flag = !prefix.equals(oldPrefix);
          if (flag) tmpUser.setIdPrefix( prefix);
          String psswd = request.getParameter("password");
          if (psswd!=null){
            psswd = psswd.trim();
            if (psswd.equals(""))return 10;
            tmpUser.setPassword( Util.criptString( psswd));
          }
          tmpUser.setStartWithWelcomePage( Util.getInteger0( request.getParameter("startWithWelcomePage")));
          tmpUser.setFtpIsAllowed( Util.getInteger0( request.getParameter("ftpAllow")));
          tmpUser.setFtpDirectory(request.getParameter("ftpDir"));
          String defaultGroup = request.getParameter("defaultgroup");
          UserGroup defaultGroupO = (UserGroup)getObjectById(UserGroup.class, defaultGroup);
          if (defaultGroupO == null) return 10;
          tmpUser.setDefaultUserGroup(defaultGroupO);

          boolean result = updatePersistent(tmpUser, visname, request.getParameter("comment"));
//          if (result && flag)
//            result = updateUserIdentifiers( tmpUser, oldPrefix, prefix);
        }
        return 0;
      }

     public boolean deleteUser( HttpServletRequest request) throws Exception {
  	    String sysId = request.getParameter("sysId");
   	    User myObj = (User)getObjectById(User.class, sysId);
   	    if (currentUser == null || myObj == null) return false;
        if (myObj.getId().equals(currentUser.getId())) currentUser = null;
   	    Transaction tx = null;
   	    try {
   	      tx = hibSess.beginTransaction();
   	      Query q1 = hibSess.createQuery(
   	        "from UserRights myRights" +
    	        " where myRights.grantedBy = :usrBy or myRights.grantedTo = :usrTo");
   	      q1.setLong("usrBy",myObj.getId().longValue());
   	      q1.setLong("usrTo",myObj.getId().longValue());
   	      List rList = q1.list();
   	      Iterator rIterator = rList.iterator();
   	      while (rIterator.hasNext()) {
   	        UserRights myRights = (UserRights) rIterator.next();
   	        hibSess.delete( myRights);
   	      }
   	      Query q2 = hibSess.createQuery(
   	        "from UserGroupMembership myMemb where myMemb.theUser = :usr");
   	      q2.setLong("usr",myObj.getId().longValue());
   	      List mList = q2.list();
   	      Iterator mIterator = mList.iterator();
   	      while (mIterator.hasNext()) {
   	        UserGroupMembership myMemb = (UserGroupMembership) mIterator.next();
   	        hibSess.delete( myMemb);
   	      }
   	      hibSess.delete(myObj);
   	      tx.commit();
   	      return true;
   	    }
   	    catch (Exception e) {
   	      if (tx != null) {
   	        tx.rollback();
   	      }
   	      throw e;
   	    }
   	    finally {
   	      hibSess.close(); //needs before forward
   	    }
   	  }

    //called from AdminPageE.jsp
  public boolean addUserRights(HttpServletRequest request
                         ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String grantBy = request.getParameter("visname");
    String grantTo = request.getParameter("grantto");
    String rights = request.getParameter("rights");
    UserRights tmpRights = new UserRights();
    tmpRights.setAccessRights( Util.getInteger0(rights));
    tmpRights.setGrantedBy((User)getObjectById(User.class, grantBy));
    tmpRights.setGrantedTo((User)getObjectById(User.class, grantTo));
    result = addPersistent(tmpRights, "", request.getParameter("comment"));
    return result;
  }
//called from AdminPageE.jsp
  public boolean updateUserRights( HttpServletRequest request
                            ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String sysId = request.getParameter("sysId");
    String grantBy = request.getParameter("visname");
    String grantTo = request.getParameter("grantto");
    String rights = request.getParameter("rights");
    UserRights tmpRights = (UserRights) getObjectById(UserRights.class, sysId);
    if (tmpRights != null) {
      tmpRights.setAccessRights( Util.getInteger0(rights));
      tmpRights.setGrantedBy((User)getObjectById(User.class, grantBy));
      tmpRights.setGrantedTo((User)getObjectById(User.class, grantTo));
      result = updatePersistent(tmpRights, "", request.getParameter("comment"));
    }
    return result;
  }
  //called from AdminPageE.jsp
  public boolean addUserGroupRights(HttpServletRequest request
                         ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String grantBy = request.getParameter("visname");
    String grantTo = request.getParameter("grantto");
    String rights = request.getParameter("rights");
    UserGroupRights tmpRights = new UserGroupRights();
    tmpRights.setAccessRights( Util.getInteger0(rights));
    tmpRights.setGrantedBy((UserGroup)getObjectById(UserGroup.class, grantBy));
    tmpRights.setGrantedTo((UserGroup)getObjectById(UserGroup.class, grantTo));
    result = addPersistent(tmpRights, "", request.getParameter("comment"));
    return result;
  }
//called from AdminPageE.jsp
  public boolean updateUserGroupRights( HttpServletRequest request
                            ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String sysId = request.getParameter("sysId");
    String grantBy = request.getParameter("visname");
    String grantTo = request.getParameter("grantto");
    String rights = request.getParameter("rights");
    UserGroupRights tmpRights = (UserGroupRights) getObjectById(UserGroupRights.class, sysId);
    if (tmpRights != null) {
      tmpRights.setAccessRights( Util.getInteger0(rights));
      tmpRights.setGrantedBy((UserGroup)getObjectById(UserGroup.class, grantBy));
      tmpRights.setGrantedTo((UserGroup)getObjectById(UserGroup.class, grantTo));
      result = updatePersistent(tmpRights, "", request.getParameter("comment"));
    }
    return result;
  }
  private boolean resetDefaultUserGroup() throws Exception {
    boolean result = false;
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      List gr = hibSess.createQuery("from UserGroup").list();
      Iterator groupIterator = gr.iterator();
      while (groupIterator.hasNext()) {
        UserGroup ugr = (UserGroup) groupIterator.next();
        if (ugr.isDefault()){
          ugr.setDefaultX(new Integer(0));
          hibSess.update(ugr);
        }
      }
    }
    catch (Exception e) {
      if (tx != null) tx.rollback();
      throw e;
    }
    return result;
  }
  private UserGroup getDefaultUserGroup() throws Exception {
    UserGroup tmpUGroup = null;
    List gr = hibSess.createQuery("from UserGroup").list();
    Iterator groupIterator = gr.iterator();
    while (groupIterator.hasNext()) {
      UserGroup ugr = (UserGroup) groupIterator.next();
      if (ugr.isDefault()){
        tmpUGroup = ugr;
        break;
      }
    }
    if (tmpUGroup == null){
      tmpUGroup = new UserGroup();
      tmpUGroup.setDefaultX( new Integer(1));
      addPersistentWithoutClose(tmpUGroup, "default group","");
    }
    return tmpUGroup;
  }
      //called from AdminPageE.jsp
  public boolean addUserGroup(HttpServletRequest request
                         ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String visname = request.getParameter("visname");
    Integer dx = Util.getInteger0( request.getParameter("default"));
    if (dx.byteValue()>0) resetDefaultUserGroup();
    UserGroup tmpUGroup = new UserGroup();
    tmpUGroup.setDefaultX( dx);
    result = addPersistent(tmpUGroup, visname, request.getParameter("comment"));
    return result;
  }
//called from AdminPageE.jsp
  public boolean updateUserGroup( HttpServletRequest request
                            ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String visname = request.getParameter("visname");
    String defstr = request.getParameter("default");
    String sysId = request.getParameter("sysId");
    UserGroup tmpUGroup = (UserGroup) getObjectById(UserGroup.class, sysId);
    if (tmpUGroup != null) {
      if (defstr!=null){
        Integer dx = Util.getInteger0(defstr);
        if (dx.byteValue() > 0) resetDefaultUserGroup();
        tmpUGroup.setDefaultX(dx);
      }
      result = updatePersistent(tmpUGroup, visname, request.getParameter("comment"));
    }
    return result;
  }
//called from AdminPageE.jsp
  public boolean deleteUserGroup(HttpServletRequest request
                         ) throws Exception {
    String sysId = request.getParameter("sysId");
    UserGroup myObj = (UserGroup)getObjectById(UserGroup.class, sysId);
    if (currentUser == null || myObj == null) return false;
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      Query q1 = hibSess.createQuery(
        "from UserGroupRights myRights" +
        " where myRights.grantedBy = :grBy or myRights.grantedTo = :grTo");
      q1.setLong("grBy",myObj.getId().longValue());
      q1.setLong("grTo",myObj.getId().longValue());
      List rList = q1.list();
      Iterator rIterator = rList.iterator();
      while (rIterator.hasNext()) {
        UserGroupRights myRights = (UserGroupRights) rIterator.next();
        hibSess.delete( myRights);
      }
      hibSess.delete(myObj);
      tx.commit();
      return true;
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
    }
  }
//called from AdminPageE.jsp
  public boolean addUserGroupMembership(HttpServletRequest request
                         ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String theUser = request.getParameter("visname");
    String belongsTo = request.getParameter("belongsto");
    UserGroupMembership tmpMemb = new UserGroupMembership();
    tmpMemb.setTheUser((User)getObjectById(User.class, theUser));
    tmpMemb.setBelongsTo((UserGroup)getObjectById(UserGroup.class, belongsTo));
    result = addPersistent(tmpMemb, "", request.getParameter("comment"));
    return result;
  }
//called from AdminPageE.jsp
  public boolean updateUserGroupMembership( HttpServletRequest request
                            ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String sysId = request.getParameter("sysId");
    String theUser = request.getParameter("visname");
    String belongsTo = request.getParameter("belongsto");
    UserGroupMembership tmpMemb = (UserGroupMembership) getObjectById(UserGroupMembership.class, sysId);
    if (tmpMemb != null) {
      if (theUser!=null)
        tmpMemb.setTheUser((User)getObjectById(User.class, theUser));
      if (belongsTo!=null)
        tmpMemb.setBelongsTo((UserGroup)getObjectById(UserGroup.class, belongsTo));
      result = updatePersistent(tmpMemb, "", request.getParameter("comment"));
    }
    return result;
  }
//---ProjectPartner-------------------------------------------------
//called from AdminPageE.jsp
  public int addProjectPartner( HttpServletRequest request) throws Exception {
    String visname = request.getParameter("visname").trim();
    if (visname == null || visname.trim().equals("")) return 10;
    ProjectPartner tmpObj = (ProjectPartner) ProjectPartner.class.newInstance();
    if (tmpObj != null) {
      tmpObj.setExternalPartnerX(Util.getInteger0(request.getParameter("isExternal")));
      tmpObj.setLongName(request.getParameter("longname"));
      addPersistent(tmpObj, visname, request.getParameter("comment"));
      return 0;
    }
    return 1;
  }
  public int updateProjectPartner( HttpServletRequest request) throws Exception {
    String sysId = request.getParameter("sysId");
    String visname = request.getParameter("visname").trim();
    if (visname == null || visname.trim().equals("")) return 10;
    ProjectPartner tmpObj = (ProjectPartner) getObjectById(ProjectPartner.class, sysId);
    if (tmpObj != null) {
      tmpObj.setExternalPartnerX(Util.getInteger0(request.getParameter("isExternal")));
      tmpObj.setLongName(request.getParameter("longname"));
      updatePersistent(tmpObj, visname, request.getParameter("comment"));
      return 0;
    }
    return 1;
  }
//---RelationTypes--------------------------------------
    private RelationType getRelationType(String relt) {
        RelationType myRelt = null;
        try {
            List list = hibSess.createQuery(
                "from RelationType myRelt where myRelt.visibleName='" +
                relt+"'").list();
            if (list.size() > 0) myRelt = (RelationType) list.get(0);
        } catch (Exception ex) {
            System.out.println("---getRelationType"+ex.getMessage());
        }
        return myRelt;
    }

    public boolean addRelationType(
            String visName, String rev_rel, String comment) throws Exception {
        RelationType tmpRelt = new RelationType();
        tmpRelt.setRev_relation(rev_rel);
        return addPersistent( tmpRelt, visName, comment);
    }

    public boolean updateRelationType(String reltId,
        String visName, String rev_rel, String comment) throws Exception {
        RelationType tmpRelt = (RelationType)
             getObjectById(RelationType.class, reltId);
        if (tmpRelt != null) {
            tmpRelt.setRev_relation(rev_rel);
            return updatePersistent( tmpRelt, visName, comment);
        }
        return false;
    }
//---Dependnecies----------------------------------
    public int addDependency( Class cl,
        HttpServletRequest request, Class clServer, Class clClient) throws Exception {
        Dependency tmpObj = (Dependency)cl.newInstance();
        String serverId = request.getParameter("visname");
        String clientId = request.getParameter("client");
        if (tmpObj != null) {
          Persistent server = (Persistent)getObjectById( clServer, serverId);
          tmpObj.setServer( server);
          Persistent client = (Persistent)getObjectById( clClient, clientId);
          tmpObj.setClient( client);
          if (addPersistent( tmpObj, "", request.getParameter("comment"))) return 0;
        }
        return 1;
    }

    public int updateDependency( Class cl,
      HttpServletRequest request, Class clServer, Class clClient) throws Exception {
      String sysId = request.getParameter("sysId");
      Dependency tmpObj = (Dependency)getObjectById( cl, sysId);
      String serverId = request.getParameter("visname");
      String clientId = request.getParameter("client");
      if (tmpObj != null) {
        Persistent server = (Persistent)getObjectById( clServer, serverId);
        tmpObj.setServer( server);
        Persistent client = (Persistent)getObjectById( clClient, clientId);
        tmpObj.setClient( client);
        if (updatePersistent( tmpObj, "", request.getParameter("comment"))) return 0;
      }
      return 1;
    }
    //---Identificies----------------------------------
        public int addIdentificy( Class cl, HttpServletRequest request) throws Exception {
          String visname = request.getParameter("visname");
          String abbreviation = request.getParameter("abbreviation");
          String comment = request.getParameter("comment");
          if (visname == null || visname.trim().equals("")) return 1;
          Identificy tmpObj = (Identificy)cl.newInstance();
          if (tmpObj != null) {
            tmpObj.setAbbreviation( abbreviation);
            if (addPersistent( tmpObj, visname, comment)) return 0;
          }
          return 1;
        }

        public int updateIdentificy( Class cl, HttpServletRequest request) throws Exception {
          String sysId = request.getParameter("sysId");
          Identificy tmpObj = (Identificy)getObjectById( cl, sysId);
          if (tmpObj != null) {
            String visname = request.getParameter("visname");
            String abbreviation = request.getParameter("abbreviation");
            String comment = request.getParameter("comment");
            if (visname == null || visname.trim().equals("")) return 1;
            String oldAbbr = tmpObj.getVisualAbbreviation();
            boolean flag = !abbreviation.equals(oldAbbr);
            if (flag) tmpObj.setAbbreviation( abbreviation);
            tmpObj.setAbbreviation( abbreviation);
            if (updatePersistent( tmpObj, visname, comment)){
                if (flag) updateIdentifiers( tmpObj, oldAbbr, abbreviation);
              return 0;
            }
          }
          return 1;
        }
//---SampleSubTypes----------------------------------
/*
    public boolean addSampleSubType(
            String visName, String samplType, String comment) throws Exception {
        SampleSubType tmpSamplt = new SampleSubType();
        IVT01 stype = (IVT01)getObjectById(IVT01.class, samplType);
        tmpSamplt.setSampleType( stype);
        return addPersistent( tmpSamplt, visName, comment);
    }

    public boolean updateSampleSubType(String samplId,
          String visName, String samplType, String comment) throws Exception {
        SampleSubType tmpSamplt = (SampleSubType)
                      getObjectById(SampleSubType.class, samplId);
        if (tmpSamplt != null) {
            IVT01 stype = (IVT01)getObjectById(IVT01.class, samplType);
            tmpSamplt.setSampleType( stype);
            return updatePersistent( tmpSamplt, visName, comment);
        }
        return false;
    }
*/
//---SampleTypes--------------------------------------
//---SampleTypes--------------------------------------
        public boolean updateIdentifiers( Identificy samplt,
                         String oldA, String newA) throws Exception {
            Query q = null;
            int oldL = oldA.length();
            int newL = newA.length();
            Transaction tx = null;
            try {
              hibSess = WebappConfig.getSamplesSessionFactory().openSession();
                tx = hibSess.beginTransaction();
                q = hibSess.createQuery(
                        "select myMiddle from Middle as myMiddle"
                        + " where myMiddle.ivt01 = '"
                        + samplt.getId().toString() + "'");
                List samples = q.list();
                Iterator sampleIterator = samples.iterator();
                while (sampleIterator.hasNext()) {
                    Middle sampl = (Middle) sampleIterator.next();
                    String genId = sampl.getVisibleName();
                    int k = genId.indexOf('-') + 1;
                    if (k > 1 && k+oldL <= genId.length()){
                        if (genId.substring(k,k+oldL).equals(oldA)){
                            genId = genId.substring(0, k) + newA +
                                    genId.substring(k + oldL);
                            sampl.setVisibleName(genId);
                            hibSess.update(sampl);
                        }
                    }
                }
                q = hibSess.createQuery(
                        "select myBottom from Bottom as myBottom,"
                        + " Middle as myMiddle"
                        + " where myBottom.parent = myMiddle.id"
                        + " and myMiddle.ivt01 = '"
                        + samplt.getId().toString() + "'");
                List aliquots = q.list();
                Iterator aliquotIterator = aliquots.iterator();
                while (aliquotIterator.hasNext()) {
                    Bottom aliq = (Bottom) aliquotIterator.next();
                    String genId = aliq.getVisibleName();
                    int k = genId.indexOf('-') + 1;
                    if (k > 1 && k+oldL <= genId.length()){
                        if (genId.substring(k,k+oldL).equals(oldA)){
                            genId = genId.substring(0, k) + newA +
                                    genId.substring(k + oldL);
                            aliq.setVisibleName(genId);
                            hibSess.update(aliq);
                        }
                    }
                }
                tx.commit();
            } catch (Exception e) {
                if (tx!=null) tx.rollback();
                throw e;
            }
            finally {
                hibSess.close(); //needs before forward
            }
            return true;
        }

//---MetaData------------------------------------------
    public int addMetaData( Class cl,
                     HttpServletRequest request) throws Exception {
        String visname = request.getParameter("visname");
        String shortname = request.getParameter("shortname");
        String longname = request.getParameter("longname");
        if (longname.trim().equals("")) return 9;
        String uploadname = request.getParameter("uploadname");
        if (shortname.trim().equals("")) shortname = longname;
        if (uploadname.trim().equals("")) uploadname = longname;
        String colnum = request.getParameter("colnum");
        String sortable = request.getParameter("sortable");
        String editable = request.getParameter("editable");
        String isrequired = request.getParameter("isrequired");
        String filternum = request.getParameter("filternum");
        MetaData tmpObj = (MetaData) cl.newInstance();
        tmpObj.setShortName(shortname);
        tmpObj.setLongName(longname);
        tmpObj.setUploadName(uploadname);
        tmpObj.setViewColumnNumber(Util.getInteger0(colnum));
        tmpObj.setSortableX( Util.getInteger0(sortable));
        tmpObj.setEditableX( Util.getInteger0(editable));
        tmpObj.setIsRequiredX( Util.getInteger0(isrequired));
        tmpObj.setPositionInFilter(Util.getInteger0(filternum));
        if ( addPersistent( tmpObj, visname, request.getParameter("comment"))) return 0;
        else return 1;
    }

    public int updateMetaData(Class cl,
                    HttpServletRequest request) throws Exception {
        String sysId = request.getParameter("sysId");
        String visname = request.getParameter("visname");
        String shortname = request.getParameter("shortname");
        String longname = request.getParameter("longname");
        if (longname.trim().equals("")) return 9;
        String uploadname = request.getParameter("uploadname");
        if (shortname.trim().equals("")) shortname = longname;
        if (uploadname.trim().equals("")) uploadname = longname;
        String colnum = request.getParameter("colnum");
        String sortable = request.getParameter("sortable");
        String editable = request.getParameter("editable");
        String isrequired = request.getParameter("isrequired");
        String filternum = request.getParameter("filternum");
        MetaData tmpObj = (MetaData)getObjectById( cl, sysId);
        tmpObj.setShortName(shortname);
        tmpObj.setLongName(longname);
        tmpObj.setUploadName(uploadname);
        tmpObj.setViewColumnNumber(Util.getInteger0( colnum));
        tmpObj.setSortableX( Util.getInteger0(sortable));
        tmpObj.setEditableX( Util.getInteger0(editable));
        tmpObj.setIsRequiredX( Util.getInteger0(isrequired));
        tmpObj.setPositionInFilter(Util.getInteger0(filternum));
        if (updatePersistent( tmpObj, visname, request.getParameter("comment"))) return 0;
        else return 1;
    }

//---Persistent--------------------------------------
    public boolean notUsedBy( Class cls, String fld, Persistent obj) {
       Long cnt = null;
       try{
           cnt = (Long) hibSess.createQuery(
           "select count(*) from "+cls.getName()+
           " obj where obj."+fld+
           "='"+obj.getId().toString()+"'").iterate().next();
       }catch(Exception ex) {};
       return (cnt==null || cnt.intValue()==0);
    }
    public boolean usedBy( Class cls, String fld, Persistent obj) {
      if (obj==null||obj.getId()==null)return false;
      Query q =  hibSess.createQuery(
          "select count(*) from "+cls.getName()+
          " obj where obj."+fld+"=:objid");
      q.setLong("objid",obj.getId().longValue());
      Long cnt = null;
      cnt = (Long)q.iterate().next();
      return (cnt!=null && cnt.intValue()>0);
    }

    public boolean notProcessedByMe( Class cls, User obj) {
       Long cnt = null;
       try{
           cnt = (Long) hibSess.createQuery(
           "select count(*) from "+cls.getName()
           +" obj where obj.creator = '"
           +obj.getId().toString()
           +"' or obj.modifier = '"
           +obj.getId().toString()
           +"'").iterate().next();
       }catch(Exception ex) {};
       return (cnt==null || cnt.intValue()==0);
    }
//----------------------------------------------------------//
//----------------- Person table & Relations ---------------//
//----------------------------------------------------------//
    public Relation getOppositeRelation(Long id1, Long id2) {
        Relation otherRel = null;
        try {
            List list = hibSess.createQuery(
                    "from Relation myRel where myRel.person1 = '"
                    + id2 + "' and myRel.person2 = '" + id1 + "'").list();
            if (list.size() > 0){
                otherRel = (Relation) list.get(0);
                hibSess.evict(otherRel.getPerson1());
                hibSess.evict(otherRel.getPerson2());
            }
        } catch (Exception ex) {
            System.out.println("---getOppositeRelation:"+ex.getMessage());
        }
        return otherRel;
    }

    public boolean addRelation(Top relPerson1,
                Top relPerson2, String relt) throws Exception {
        RelationType relat1 = (RelationType)
          getObjectById(RelationType.class, relt);
        RelationType relat2 = getRelationType(relat1.getRev_relation());
        if (relat1 != null && relat2 != null) {
            Relation tmpRelation = new Relation();
            tmpRelation.setCreateInfo(currentUser);
            tmpRelation.setPerson1(relPerson1);
            tmpRelation.setPerson2(relPerson2);
            tmpRelation.setRelation(relat1);
            Relation otherRelation = new Relation();
            otherRelation.setCreateInfo(currentUser);
            otherRelation.setPerson1(relPerson2);
            otherRelation.setPerson2(relPerson1);
            otherRelation.setRelation(relat2);
            Transaction tx = null;
            try {
                tx = hibSess.beginTransaction();
                hibSess.save(tmpRelation);
                hibSess.save(otherRelation);
                tx.commit();
                return true;
            }
            catch (Exception e) {
                if (tx!=null) tx.rollback();
                throw e;
            }
        }
        return true;
    }

    public boolean updateRelation(String oldRelId,
        Top relPerson1, Top relPerson2, String relt) throws Exception {
        Relation tmpRelation = (Relation)
          getObjectById(Relation.class, oldRelId);
        if (tmpRelation != null) {
            Long p1 = tmpRelation.getPerson1().getId();
            Long p2 = tmpRelation.getPerson2().getId();
            if (!p1.equals(relPerson1.getId()) ||
                !p2.equals(relPerson2.getId()) ||
                !tmpRelation.getRelation().getId().toString().equals(relt)) {
                Relation otherRelation = getOppositeRelation( p1, p2);
                RelationType relat1 = (RelationType)
                  getObjectById(RelationType.class, relt);
                RelationType relat2 = getRelationType(relat1.getRev_relation());
                if (relat1 != null && relat2 != null) {
                    tmpRelation.setModifInfo(currentUser);
                    tmpRelation.setPerson1(relPerson1);
                    tmpRelation.setPerson2(relPerson2);
                    tmpRelation.setRelation(relat1);

                    otherRelation.setModifInfo(currentUser);
                    otherRelation.setPerson1(relPerson2);
                    otherRelation.setPerson2(relPerson1);
                    otherRelation.setRelation(relat2);
                    Transaction tx = null;
                    try {
                        tx = hibSess.beginTransaction();
                        hibSess.update(otherRelation);
                        hibSess.update(tmpRelation);
                        tx.commit();
                        return true;
                    }
                    catch (Exception e) {
                        if (tx!=null) tx.rollback();
                        throw e;
                    }
                }
            }
            return true;
        }
       return false;
    }

    public boolean deleteRelation(String oldRelId) throws Exception {
        Relation tmpRelation = (Relation)
          getObjectById(Relation.class, oldRelId);
        if (tmpRelation != null) {
          Long p1 = tmpRelation.getPerson1().getId();
          Long p2 = tmpRelation.getPerson2().getId();
          Relation otherRelation = getOppositeRelation(p1, p2);
          Transaction tx = null;
          try {
              tx = hibSess.beginTransaction();
              hibSess.delete(tmpRelation);
              hibSess.delete(otherRelation);
              tx.commit();
              return true;
          }
          catch (Exception e) {
              if (tx!=null) tx.rollback();
              throw e;
          }
      }
      return true;
    }

//---Common routines------------------------------------------
//---Common routines-------------------------------------------
private int ptype;   //0 - top; 1 - middle; 2 - bottom
private Persistent source;
private Top myTop;
private Middle myMiddle;
private Bottom myBottom;
private Class sourceClass;
private HttpServletRequest questH;
private RequestParser questP;
private boolean isBatch;
private boolean[] batchB;
public void setPageInfo( Class myClass, Persistent mySource,
                             HttpServletRequest request, boolean[] batchBool){
      source = mySource;  isBatch = true;
      sourceClass = myClass;
      if (sourceClass.equals(Top.class)){
        ptype = 0; myTop = (Top)source;
      } else
      if (sourceClass.equals(Middle.class)){
        ptype = 1; myMiddle = (Middle)source;
      } else
      if (sourceClass.equals(Bottom.class)){
        ptype = 2; myBottom = (Bottom)source;
      }
      questH = request;
      questP = null;
      batchB = batchBool;
    }

public void setPageInfo( Class myClass, Persistent mySource, HttpServletRequest request){
  source = mySource;  isBatch = false;
  sourceClass = myClass;
  if (sourceClass.equals(Top.class)){
    ptype = 0; myTop = (Top)source;
  } else
  if (sourceClass.equals(Middle.class)){
    ptype = 1; myMiddle = (Middle)source;
  } else
  if (sourceClass.equals(Bottom.class)){
    ptype = 2; myBottom = (Bottom)source;
  }
  questH = request;
  questP = null;
}

public void setPageInfo( Class myClass, Persistent mySource, RequestParser request){
  source = mySource;  isBatch = false;
  sourceClass = myClass;
  if (sourceClass.equals(Top.class)){
    ptype = 0; myTop = (Top)source;
  } else
  if (sourceClass.equals(Middle.class)){
    ptype = 1; myMiddle = (Middle)source;
  } else
  if (sourceClass.equals(Bottom.class)){
    ptype = 2; myBottom = (Bottom)source;
  }
  questH = null;
  questP = request;
}

public String getLongName( String fieldName){
  return mdm.getLongName(ptype, fieldName);
}

private Object getValue( String fieldName){
  Object xyz = null;
  if (mdm.hasField(ptype, fieldName)) {
    if (source != null) {
      try{
        switch (ptype) {
        case 0:
          xyz = myTop.getValue(fieldName);
          break;
        case 1:
          xyz = myMiddle.getValue(fieldName);
          break;
        case 2:
          xyz = myBottom.getValue(fieldName);
          break;
        }
      } catch (Exception ex) {
        Util.writeLog("---NoSuchFieldExists=",ex.getMessage(),"");
      }
    }
  }
  return xyz;
}
//obsolete versions
public String getYear( String fieldName, boolean mandatory){
  return (mandatory)? getYear(fieldName,new Date()):getYear(fieldName, null);}
public String getMonth( String fieldName, boolean mandatory){
  return (mandatory)? getMonth(fieldName,new Date()):getMonth(fieldName, null);}
public String getDay( String fieldName, boolean mandatory){
  return (mandatory)? getDay(fieldName,new Date()):getDay(fieldName, null);}
public String getHour( String fieldName, boolean mandatory){
  return (mandatory)? getHour(fieldName,new Date()):getHour(fieldName, null);}
public String getMinute( String fieldName, boolean mandatory){
  return (mandatory)? getMinute(fieldName,new Date()):getMinute(fieldName, null);}

public String getYear( String fieldName, Date myDate){
  StringBuffer xyz = new StringBuffer();
  String value = null;
  if (questH!=null) value = questH.getParameter(fieldName);
  else
  if (questP!=null) value = questP.getParameter(fieldName);
  if (value==null){ value = "";
    if (mdm.hasField(ptype, fieldName)) {
      Date val = null;
      if (source != null) val = (Date)getValue( fieldName);
      else val = myDate;
      if (val != null) value = Util.getYear(val);
    }
  }
  xyz.append("<input type='text' name='")
     .append(fieldName)
     .append("' maxlength='4' size='4' alt='yyyy(year)' value='")
     .append(value)
     .append("'");
  if (isBatch)
    xyz.append(" disabled")
       .append(getFieldId(fieldName, batchB[ VocabulName.getRowNumber(fieldName)]));
  else
    xyz.append(getFieldId(fieldName));
  xyz.append("/>");
  return xyz.toString();
}

public String getMonth( String fieldName, Date myDate){
  StringBuffer xyz = new StringBuffer();
  String value = null;
  String fname = fieldName+'1';
  if (questH!=null) value = questH.getParameter(fname);
  else
  if (questP!=null) value = questP.getParameter(fname);
  if (value==null){ Date val = null;
    if (source != null) val = (Date)getValue( fieldName);
    else val = myDate;
    if (val != null) value = Util.getMonth(val); else value = "";
  }
  xyz.append("<input type='text' name='")
     .append(fname)
     .append("' maxlength='2' size='2' alt='mm(month)' value='")
     .append(value)
     .append("'");
  if (isBatch)
    xyz.append(" disabled")
       .append(getFieldId(fname, batchB[ VocabulName.getRowNumber(fieldName)]));
  else
    xyz.append(getFieldId(fname));
  xyz.append("/>");
  return xyz.toString();
}

public String getDay( String fieldName, Date myDate){
  StringBuffer xyz = new StringBuffer();
  String value = null;
  String fname = fieldName+'2';
  if (questH!=null) value = questH.getParameter(fname);
  else
  if (questP!=null) value = questP.getParameter(fname);
  if (value==null){ Date val = null;
    if (source != null) val = (Date)getValue( fieldName);
    else val = myDate;
    if (val != null) value = Util.getDay(val); else value = "";
  }
  xyz.append("<input type='text' name='")
     .append(fname)
     .append("' maxlength='2' size='2' alt='dd(day)' value='")
     .append(value)
     .append("'");
  if (isBatch)
    xyz.append(" disabled")
       .append(getFieldId(fname, batchB[ VocabulName.getRowNumber(fieldName)]));
  else
    xyz.append(getFieldId(fname));
  xyz.append("/>");
  return xyz.toString();
}

public String getHour( String fieldName, Date myDate){
  StringBuffer xyz = new StringBuffer();
  String value = null;
  String fname = fieldName+'3';
  if (questH!=null) value = questH.getParameter(fname);
  else
  if (questP!=null) value = questP.getParameter(fname);
  if (value==null){ Date val = null;
    if (source != null) val = (Date)getValue( fieldName);
    else val = myDate;
    if (val != null) value = Util.getHour(val); else value = "";
  }
  xyz.append("<input type='text' name='")
     .append(fname)
     .append("' maxlength='2' size='2' alt='hh(hour)' value='")
     .append(value)
     .append("'");
  if (isBatch)
    xyz.append(" disabled")
       .append(getFieldId(fname, batchB[ VocabulName.getRowNumber(fieldName)]));
  else
    xyz.append(getFieldId(fname));
  xyz.append("/>");
  return xyz.toString();
}

public String getMinute( String fieldName, Date myDate){
  StringBuffer xyz = new StringBuffer();
  String value = null;
  String fname = fieldName+'4';
  if (questH!=null) value = questH.getParameter(fname);
  else
  if (questP!=null) value = questP.getParameter(fname);
  if (value==null){ Date val = null;
    if (source != null) val = (Date)getValue( fieldName);
    else val = myDate;
    if (val != null) value = Util.getMinute(val); else value = "";
  }
  xyz.append("<input type='text' name='")
     .append(fname)
     .append("' maxlength='2' size='2' value='")
     .append(value)
     .append("'");
  if (isBatch)
    xyz.append(" disabled")
       .append(getFieldId(fname, batchB[ VocabulName.getRowNumber(fieldName)]));
  else
    xyz.append(getFieldId(fname));
  xyz.append("/>");
  return xyz.toString();
}

public String getTextArea( String fieldName, int cols, int rows){
  StringBuffer xyz = new StringBuffer();
  String value = null;
  if (questH!=null) value = questH.getParameter(fieldName);
  else
  if (questP!=null) value = questP.getParameter(fieldName);
  if (value==null){
    String val = (String) getValue( fieldName);
    if (val != null) value = Util.getHTMLString(val.toString()); else value = "";
  }
  xyz.append("<textarea name='")
     .append(fieldName)
     .append("' cols='")
     .append(String.valueOf(cols))
     .append("' rows='")
     .append(String.valueOf(rows))
     .append("'");
  if (isBatch)
    xyz.append(" disabled")
       .append(getFieldId(fieldName, batchB[ VocabulName.getRowNumber(fieldName)]));
  else
    xyz.append(getFieldId(fieldName));
  xyz.append(">")
     .append(value)
     .append("</textarea>");
  return xyz.toString();
}

public String getInput( String fieldName, int size){
  StringBuffer xyz = new StringBuffer();
  String value = null;
  if (questH!=null) value = questH.getParameter(fieldName);
  else
  if (questP!=null) value = questP.getParameter(fieldName);
  if (value==null){
    Object val = getValue( fieldName);
    if (val != null) value = Util.getHTMLString(val.toString()); else value = "";
  }
  xyz.append("<input type='text' name='")
     .append(fieldName)
     .append("' size='")
     .append(String.valueOf(size))
     .append("' value='")
     .append(value)
     .append("'");
  if (isBatch)
    xyz.append(" disabled")
       .append(getFieldId(fieldName, batchB[ VocabulName.getRowNumber(fieldName)]));
  else
    xyz.append(getFieldId(fieldName));
  xyz.append("/>");
  return xyz.toString();
}

public String getCheckBox( String fieldName){
  StringBuffer xyz = new StringBuffer();
  Integer val = (Integer)getValue( fieldName);
  String value = (val != null)?val.toString():null;

  xyz.append("<input type='checkbox' name='")
     .append(fieldName)
     .append("' value='1'");
  if (value!=null && value.equals("1"))
    xyz.append(" checked");
  if (isBatch)
   xyz.append(" disabled")
      .append(getFieldId(fieldName, batchB[ VocabulName.getRowNumber(fieldName)]));
  else
   xyz.append(getFieldId(fieldName));
  xyz.append("/>");
  return xyz.toString();
}

public String getPrompterSt( Class vclass, String fieldName, boolean optional){
  return getPrompterSt( vclass, fieldName);
}
public String getPrompterSt( Class vclass, String fieldName){
  StringBuffer xyz = new StringBuffer();
  String value = (String)getValue( fieldName);
  boolean required = mdm.isRequired( ptype, fieldName);
  xyz.append("<select name='")
     .append(fieldName)
     .append("'");
  if (isBatch)
    xyz.append(" disabled")
       .append(getFieldId(fieldName, batchB[ VocabulName.getRowNumber(fieldName)]));
  else
    xyz.append(getFieldId(fieldName));
  xyz.append(">");
  xyz.append(getObjectPrompterForString(vclass, value, required));
  xyz.append("</select>");
  return xyz.toString();
}
public String getPrompterVt( Class vclass, String fieldName, boolean optional){
  return getPrompterVt( vclass, fieldName);
}
public String getPrompterVt( Class vclass, String fieldName){
  StringBuffer xyz = new StringBuffer();
  Persistent value = (Persistent)getValue( fieldName);
  boolean required = mdm.isRequired( ptype, fieldName);
  xyz.append("<select name='")
     .append(fieldName)
     .append("'");
  if (isBatch)
    xyz.append(" disabled")
     .append(getFieldId(fieldName, batchB[ VocabulName.getRowNumber(fieldName)]));
  else
    xyz.append(getFieldId(fieldName));
  xyz.append(">");
  xyz.append(getObjectPrompter(vclass, value, required));
  xyz.append("</select>");
  return xyz.toString();
}
//------method used by AJAX only
public String getDependentPrompterTemp( String indepId, String dependent,
                                    String depTable, boolean required){
  StringBuffer xyz = new StringBuffer();
  Session ses11 = WebappConfig.getSamplesSessionFactory().openSession();
  Query q = ses11.createQuery(
    "from " + depTable + " myObj" +
    " where myObj.server = " + indepId);
  List list = q.list();

  xyz.append("<select name=\"")
     .append(dependent)
     .append("\"");
  if (isBatch)
    xyz.append(" disabled")
     .append(getFieldId(dependent, batchB[ VocabulName.getRowNumber(dependent)]));
  else
    xyz.append(getFieldId(dependent));
  xyz.append(">\r\n");
  if (!required) xyz.append("<option value=\"0\">");
  if (list != null){
    Iterator iter = list.iterator();
    while (iter.hasNext()) {
      Dependency dep = (Dependency) iter.next();
      Persistent obj = dep.getClient();
      xyz.append("<option value=\"");
      xyz.append(obj.getId())
         .append("\">")
         .append(obj.getVisibleName());
    }
  }
  xyz.append("\r\n</select>");
  ses11.close();
  return xyz.toString();
}

public String getDependentPrompter( String dependentField, Class dependencyClass, boolean optional,
       String independentField, Class independentClass){
  StringBuffer xyz = new StringBuffer();
  Persistent indepObj = (Persistent)getValue( independentField);
  Persistent depObj = (Persistent)getValue( dependentField);
  boolean required = !optional;
  if (indepObj == null){
    List indepList = getAllObjects(independentClass);
    indepObj = (Persistent)indepList.get(0);
  }
  List depList = null;
  if (indepObj!=null){
    Long indepId = indepObj.getId();
    Query q = hibSess.createQuery(
        "from " + dependencyClass.getName() + " myObj" +
        " where myObj.server = :type");
    q.setLong("type", indepId.longValue());
    depList = q.list();
  }
  Long objId = (depObj!=null)?depObj.getId():null;
  xyz.append("<span id=\"")
     .append(dependentField)
     .append("Div\">");
  xyz.append("<select name=\"")
     .append(dependentField)
     .append("\"");
  if (isBatch)
    xyz.append(" disabled")
     .append(getFieldId(dependentField, batchB[ VocabulName.getRowNumber(dependentField)]));
  else
    xyz.append(getFieldId(dependentField));
  xyz.append(">\r\n");
  if (!required) xyz.append("<option value=\"0\">");
  if (depList != null){
    Iterator iter = depList.iterator();
    while (iter.hasNext()) {
      Dependency dep = (Dependency) iter.next();
      Persistent obj = dep.getClient();
      if (obj.getId().equals(objId))
        xyz.append("<option selected value=\"");
      else
        xyz.append("<option value=\"");
      xyz.append(obj.getId())
         .append("\">")
         .append(obj.getVisibleName());
    }
  }
  xyz.append("\r\n</select>");
  xyz.append("</span>");
  return xyz.toString();
}

public String getIndependentPrompter( Class independentClass, String fieldName){
  Persistent indepObj = (Persistent)getValue( fieldName);
  boolean required = mdm.isRequired( ptype, fieldName);
  return getObjectPrompter( independentClass, indepObj, required);
}
//----------------------------------------------------------//
public String getUserPrompterTemp( String groupId, String userId)throws Exception {
  StringBuffer xyz = new StringBuffer();
  xyz.append("<span id=\"ow_userDiv\">");
  xyz.append("<select name=\"ow_user\"");
  xyz.append(">\r\n");
  xyz.append("<option value=\"\">--select value--");
  Session ses11 = WebappConfig.getSamplesSessionFactory().openSession();
  List depList = null;
  Long objId = (userId==null||userId=="")?null:new Long( userId);
  if (groupId==null||groupId.equals("")){
    depList = ses11.createQuery("from User").list();
    xyz.append(PromptUtil.getUserPrompterFromList( depList,objId));
  } else {
    Long indepId = new Long(groupId);
    Query q = ses11.createQuery(
        "from UserGroupMembership myObj" +
        " where myObj.belongsTo = :group");
    q.setLong("group", indepId.longValue());
    depList = q.list();
    Iterator iter = depList.iterator();
    while (iter.hasNext()) {
      UserGroupMembership dep = (UserGroupMembership) iter.next();
      User obj = dep.getTheUser();
      if (obj.getId().equals(objId))
        xyz.append("<option selected value=\"");
      else
        xyz.append("<option value=\"");
      xyz.append(obj.getId())
         .append("\">")
         .append(obj.getLoginName()); //bija getVisibleName()
    }
  }
  ses11.close();
  xyz.append("\r\n</select>");
  xyz.append("</span>");
  return xyz.toString();
}

public String getUserPrompter( String groupId, String userId, boolean disabled)throws Exception {
  StringBuffer xyz = new StringBuffer();
  xyz.append("<span id=\"ow_userDiv\">");
  xyz.append("<select name=\"ow_user\"");
  if (disabled) xyz.append(" disabled");
  xyz.append(">");
  xyz.append("<option value=\"\">--select value--");
  xyz.append("\r\n");
  List depList = null;
  Long objId = (userId==null||userId=="")?null:new Long( userId);
  if (groupId==null||groupId.equals("")){
    depList = getAllObjects(User.class);
    xyz.append(PromptUtil.getUserPrompterFromList( depList,objId));
  } else {
    Long indepId = new Long(groupId);
    Query q = hibSess.createQuery(
        "from UserGroupMembership myObj" +
        " where myObj.belongsTo = :group");
    q.setLong("group", indepId.longValue());
    depList = q.list();
    Iterator iter = depList.iterator();
    while (iter.hasNext()) {
      UserGroupMembership dep = (UserGroupMembership) iter.next();
      User obj = dep.getTheUser();
      if (obj.getId().equals(objId))
        xyz.append("<option selected value=\"");
      else
        xyz.append("<option value=\"");
      xyz.append(obj.getId())
         .append("\">")
         .append(obj.getLoginName());
    }
  }
  xyz.append("\r\n</select>");
  xyz.append("</span>");
  return xyz.toString();
}
//----------------------------------------------------------//
private int getIdentifDigNum(List depList, Long selfId){
  int max = 0;
  if (depList != null){
    Iterator iter0 = depList.iterator();
    while (iter0.hasNext()) {
      SimsData top11 = (SimsData) iter0.next();
      if (!top11.getId().equals(selfId)){
  	    String visName = top11.getVisibleName();
	    int l = visName.length();
	    while ( l > 0){
	      if (!Character.isDigit(visName.charAt(--l))) break;
	    }
	    if (++l < visName.length()){
  	      int j = Integer.parseInt( visName.substring(l));
	      if (j > max) max = j;
	    }  
	  }  
    }
  }
  return max;
}
private int getIdentifAlfaNum(List depList, Long selfId){
  int max = 0;
  if (depList != null){
    Iterator iter0 = depList.iterator();
    while (iter0.hasNext()) {
      SimsData top11 = (SimsData) iter0.next();
      if (!top11.getId().equals(selfId)){
	    String visName = top11.getVisibleName();
        int j = Util.getNumberFromStringPostfix(visName);
        if (j > max) max = j;
      }
    }
  }
  return max;
}
  
public int getTopIdentifierNum(){
  long userid = currentUser.getId().longValue();
  long techid = currentTechnology.getId().longValue();
  Long selfid = new Long(0);
  Query q = hibSess.createQuery(
        "from Top myTop" +
        " where myTop.technology=:technid and myTop.creator = :creid");
  q.setLong("creid",userid);
  q.setLong("technid",techid);
  List depList = q.list();
  return getIdentifDigNum( depList, selfid);
}
public String getTopIdentifierNew( int max){
	String usr = currentUser.getIdPrefix();
	String techn = currentTechnology.getIdPrefix();
    StringBuffer xyz = new StringBuffer();
    xyz.append(usr)
       .append('-')
       .append(techn)
       .append('-');
    DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
    snf.applyPattern("00000");
    xyz.append(snf.format(max));
    return xyz.toString();
  }
//---------------------------------------------------------------------
public String getSimsIdentifier( int level, SimsData parent, String parentName)throws ClassNotFoundException{
  List depList = null;
  long parentId = parent.getId().longValue();
  int identCount = VocabulName.getLevelIdCount(level);
  String abbr[] = new String[identCount];
  String queryText = 
   	  (level==2)?"from Bottom myObj where myObj.parent = :parent":
   	  (level==1)?"from Middle myObj where myObj.parent = :parent":
   	  /*(level==0 not applicable) */ "from Top myObj";	        	  
  for (int i = 0; i < identCount; i++){
	String fn = VocabulName.getFieldNameIVT(VocabulName.getLevelIdNum(level, i));
	queryText += " and myObj."+fn+"=:"+fn;
  }
  Query q = hibSess.createQuery( queryText);
  if (level!=0) q.setLong("parent", parentId);
  for (int i = 0; i < identCount; i++){
    long identifId = 0;  
	Class identifClass = VocabulName.getIdentificyClass(VocabulName.getLevelIdNum(level, i));  
    List identifList = getAllObjects(identifClass);
	if (identifList!=null && identifList.size()>0){
	  Identificy identifObj = (Identificy) identifList.get(0);
	  if (identifObj != null){
		identifId = identifObj.getId().longValue();
		abbr[ i] = identifObj.getVisualAbbreviation();
	  }
	}  
	String fn = VocabulName.getFieldNameIVT(VocabulName.getLevelIdNum(level, i));
    q.setLong(fn, identifId);
  }
  depList = q.list();
  int k0 = VocabulName.getLevelPostfixType(level);
  Long selfId = new Long(0);
  int k1 = (k0==2)?getIdentifAlfaNum( depList, selfId):getIdentifDigNum( depList, selfId);
  k1++;
  String postfix = (k0==2)?Util.getStringPostfixFromNumber(k1):String.valueOf(k1);
  String genName = parentName;
  for (int i = 0; i < identCount; i++){
    genName += VocabulName.getLevelIdDelimiter(level, i)+abbr[i];
  }  
  genName += VocabulName.getLevelIdDelimiter(level, identCount) + postfix;
  return genName;
}

//------method used by AJAX only if  middle id refers middle type ()
public String getSimsIdentifierTemp( int level, String parentId, String parentName,
		long identifId[], String idSelf)throws ClassNotFoundException{
  List depList = null;
  Session ses11 = WebappConfig.getSamplesSessionFactory().openSession();
  int identCount = VocabulName.getLevelIdCount(level);
  String queryText = 
   	  (level==2)?"from Bottom myObj where myObj.parent = " + parentId:
   	  (level==1)?"from Middle myObj where myObj.parent = " + parentId:
   	  /*(level==0 not applicable) */ "from Top myObj";	        	  
  for (int i = 0; i < identCount; i++){
	String fn = VocabulName.getFieldNameIVT(VocabulName.getLevelIdNum(level, i));
	queryText += " and myObj."+fn+"=:"+fn;
  }
  Query q = ses11.createQuery( queryText);
  for (int i = 0; i < identCount; i++){
	String fn = VocabulName.getFieldNameIVT(VocabulName.getLevelIdNum(level, i));
    q.setLong(fn, identifId[i]);
  }
  depList = q.list();
  int k0 = VocabulName.getLevelPostfixType(level);
  Long selfId = new Long( idSelf);
  int k1 = (k0==2)?getIdentifAlfaNum( depList, selfId):getIdentifDigNum( depList, selfId);
  k1++;
  String postfix = (k0==2)?Util.getStringPostfixFromNumber(k1):String.valueOf(k1);
  String genName = parentName;
  for (int i = 0; i < identCount; i++){
    Query q2 = ses11.createQuery(
			    "from " + 
			    VocabulName.getIdentificyClassName(VocabulName.getLevelIdNum(level, i)) +
			    " myObj where myObj.id = :identif");
    q2.setLong("identif", identifId[i]);
    List list = q2.list();
	Identificy identifObj = (Identificy) list.get(0);
    String abbr = identifObj.getVisualAbbreviation();
    genName += VocabulName.getLevelIdDelimiter(level, i)+abbr;
  }  
  genName += VocabulName.getLevelIdDelimiter(level, identCount) + postfix;
  return genName;
}
/*
//--- Set Target (HttpServletRequest)---------------------------------
private void setTargetParameters( int type, Object target,
       HttpServletRequest request ) throws Exception {
  Class targetClass = target.getClass();
  for (int i = 1; i <= VocabulName.getIdentificyCount(); i++) {
    String key = VocabulName.getFieldNameIVT(i);
    if (mdm.hasField(type, key)) {
      String value = request.getParameter(key); //may be disabled
      if (value!=null){
        Class xyz = VocabulName.getIdentificyClass(i);
        Persistent myObj = (Persistent) getObjectById(xyz, value);
        Class[] paramTypes = {xyz};
        Method meth = targetClass.getMethod(VocabulName.getSetMethodNameIVT(i),
                                            paramTypes);
        Object[] args = {myObj};
        meth.invoke(target, args);
      }
    }
  }
  for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
    String key = VocabulName.getFieldNameVT(i);
    if (mdm.hasField(type, key)) {
      String value = request.getParameter(key);
      Class xyz = VocabulName.getVocabularyClass(i);
      Persistent myObj = (Persistent) getObjectById(xyz, value);
      Class[] paramTypes = {xyz};
      Method meth = targetClass.getMethod(VocabulName.getSetMethodNameVT(i),
                                        paramTypes);
      Object[] args = {myObj};
      meth.invoke( target, args);
    }
  }
  for (int i = 1; i <= VocabulName.getStringCount(type); i++) {
    String key = VocabulName.getFieldNameST(i);
    if (mdm.hasField( type, key)) {
      String value = request.getParameter(key);
      Class[] paramTypes = {String.class};
      Method meth = targetClass.getMethod(VocabulName.getSetMethodNameST(i), paramTypes);
      Object[] args = {value};
      meth.invoke(target, args);
    }
  }
  for (int i = 1; i <= VocabulName.getIntegerCount(type); i++) {
    String itxx = VocabulName.getFieldNameIT(i);
    if (mdm.hasField(type, itxx)) {
      String value = request.getParameter(itxx);
      Integer ivalue = null;
      if (value != null && !Util.checkIntegerValue(value)){
        setInvalidFields(itxx, 7); continue;
      }
      else
        ivalue = Util.getInteger(value);
      Class[] paramTypes = {Integer.class};
      Method meth = targetClass.getMethod( VocabulName.getSetMethodNameIT(i),
                                           paramTypes);
      Object[] args = {ivalue};
      meth.invoke(target, args);
    }
  }
  for (int i = 1; i <= VocabulName.getFloatCount(type); i++) {
    String itxx = VocabulName.getFieldNameFT(i);
    if (mdm.hasField( type, itxx)) {
      String value = request.getParameter(itxx);
      Double fvalue = null;
      if (value != null && !Util.checkFloatValue(value)){
        setInvalidFields(itxx, 7); continue;
      }
      else
        fvalue = Util.getFloat(value);
      Class[] paramTypes = {Double.class};
      Method meth = targetClass.getMethod( VocabulName.getSetMethodNameFT(i),
                                           paramTypes);
      Object[] args = {fvalue};
      meth.invoke(target, args);
    }
  }
  for (int i = 1; i <= VocabulName.getDateCount(type); i++) {
    String itxx = VocabulName.getFieldNameDT(i);
    if (mdm.hasField( type, itxx)) {
      Date dvalue = getDate(request, itxx);
      Class[] paramTypes = {Date.class};
      Method meth = targetClass.getMethod(VocabulName.getSetMethodNameDT(i),
                     paramTypes);
      Object[] args = {dvalue};
      meth.invoke(target, args);
    }
  }
}
*/
//--- Set Target (RequestParser ) ------------------------------------
private void setTargetParameters( int type, Object target,
       RequestParser request ) throws Exception {
  clearInvalidFields();
  Class targetClass = target.getClass();
  for (int i = 1; i <= VocabulName.getIdentificyCount(); i++) {
    String key = VocabulName.getFieldNameIVT(i);
    if (mdm.hasField(type, key)) {
      String value = request.getParameter(key); //may be disabled
      if (value!=null){
        if (mdm.isRequired(type, key) && value.equals("")){
          setInvalidFields(key, 9);
        } else {
          Class xyz = VocabulName.getIdentificyClass(i);
          Persistent myObj = (Persistent) getObjectById(xyz, value);
          Class[] paramTypes = {xyz};
          Method meth = targetClass.getMethod(VocabulName.getSetMethodNameIVT(i),
                                            paramTypes);
          Object[] args = {myObj};
          meth.invoke(target, args);
        }  
      }
    }
  }
  for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
    String key = VocabulName.getFieldNameVT(i);
    if (mdm.hasField(type, key)) {
      String value = request.getParameter(key);
      if (mdm.isRequired(type, key) && (value==null || value.equals(""))){
        setInvalidFields(key, 9);
      } else {
        Class xyz = VocabulName.getVocabularyClass(i);
        Persistent myObj = (Persistent) getObjectById(xyz, value);
        Class[] paramTypes = {xyz};
        Method meth = targetClass.getMethod(VocabulName.getSetMethodNameVT(i),
                                        paramTypes);
        Object[] args = {myObj};
        meth.invoke( target, args);
      }
    }
  }
  for (int i = 1; i <= VocabulName.getStringCount(type); i++) {
    String key = VocabulName.getFieldNameST(i);
    if (mdm.hasField( type, key)) {
      String value = request.getParameter(key);
      if (mdm.isRequired(type, key) && (value==null || value.equals(""))){
        setInvalidFields(key, 9); 
      } else {
        Class[] paramTypes = {String.class};
        Method meth = targetClass.getMethod(VocabulName.getSetMethodNameST(i), paramTypes);
        Object[] args = {value};
        meth.invoke(target, args);
      }  
    }
  }
  for (int i = 1; i <= VocabulName.getIntegerCount(type); i++) {
    String itxx = VocabulName.getFieldNameIT(i);
    if (mdm.hasField(type, itxx)) {
      String value = request.getParameter(itxx);
      if (mdm.isRequired(type, itxx) && (value!=null && value.equals(""))){
        setInvalidFields(itxx, 9);
      } else {
        Integer ivalue = null;
        if (value != null && !Util.checkIntegerValue(value)){
          setInvalidFields(itxx, 7); continue;
        }
        else
          ivalue = Util.getInteger(value);
        Class[] paramTypes = {Integer.class};
        Method meth = targetClass.getMethod( VocabulName.getSetMethodNameIT(i),
                                           paramTypes);
        Object[] args = {ivalue};
        meth.invoke(target, args);
      }  
    }
  }
  for (int i = 1; i <= VocabulName.getFloatCount(type); i++) {
    String itxx = VocabulName.getFieldNameFT(i);
    if (mdm.hasField( type, itxx)) {
      String value = request.getParameter(itxx);
      if (mdm.isRequired(type, itxx) && (value==null || value.equals(""))){
        setInvalidFields(itxx, 9);
      } else {
        Double fvalue = null;
        if (value != null && !Util.checkFloatValue(value)){
          setInvalidFields(itxx, 7); continue;
        }
        else
          fvalue = Util.getFloat(value);
        Class[] paramTypes = {Double.class};
        Method meth = targetClass.getMethod( VocabulName.getSetMethodNameFT(i),
                                           paramTypes);
        Object[] args = {fvalue};
        meth.invoke(target, args);
      }  
    }
  }
  for (int i = 1; i <= VocabulName.getDateCount(type); i++) {
    String itxx = VocabulName.getFieldNameDT(i);
    if (mdm.hasField( type, itxx)) {
      String value = request.getParameter(itxx);
      if (mdm.isRequired(type, itxx) && (value==null || value.equals(""))){
        setInvalidFields(itxx, 9);
      } else {
        Date dvalue = getDate(request, itxx);
        Class[] paramTypes = {Date.class};
        Method meth = targetClass.getMethod(VocabulName.getSetMethodNameDT(i),
                     paramTypes);
        Object[] args = {dvalue};
        meth.invoke(target, args);
      }  
    }
  }
}
//---Batch edit routins-------------------------------------------
public String changeMark( String fieldName){
  StringBuffer xyz = new StringBuffer();
  xyz.append("<input type='checkbox' name='check' value='")
     .append(fieldName)
     .append("' id='")
     .append(fieldName)
     .append("a' onclick='changeEditMark (\"")
     .append(fieldName)
     .append("\");'/>");
  return xyz.toString();
}

//---Top-------------------------------------------
//---Top-------------------------------------------
  public int checkPersonId(String genId) {
    int result = 0;
    if (genId==null||genId.trim().equals("")) result = 2;
      else
    try {
/*
    	if (personIdCheck){
        int l = genId.length();
        if (l < 6) result = 2;
        else {
          int s = 0;
          for (int i = 0; i < l - 2; i++)
            s += (genId.charAt(i) - Character.MIN_VALUE) * (i + 1);
          s %= 10;
          s += '0';
          if (s != genId.charAt(l - 1))result = 2;
        }
      }
*/      
      Query q = hibSess.createQuery("select count(*) from Top myTop"
                   + " where myTop.technology=:technid and myTop.visibleName = :genId");
      q.setString("genId",genId);
      q.setLong("technid",currentTechnology.getId().longValue());
      Long cnt = (Long) q.iterate().next();
      if (cnt.intValue() > 0) result = 3;
    } catch (Exception ex) {
      result = 1;
    }
    return result;
  }
  
  public String getContents( RequestParser request, FileString filstr){
	    int k, l;
	    if (filstr.noContent())return "";
	    String prefix = filstr.getPrefix();
	    StringBuffer xyz = new StringBuffer();
	    String suffix, fileName, typeId;
	    String count = request.getParameter("l" + prefix);
	    k = 0; l = (count!=null)?Util.getIntegerValue(count):10;
	    while (k++ < l){
	      String key = prefix + String.valueOf(k);
	      suffix = request.getParameter("h" + key);
	      if (suffix != null) {
	        fileName = request.getParameter(key);
	        typeId = request.getParameter("t" + key);
	        xyz.append('\r')
	           .append(suffix)
	           .append('\r')
	           .append(fileName)
	           .append('\r')
	           .append(typeId);
	      }
	    }
	    xyz.append('\r');
	    String userFilePath = request.getParameter("v"+prefix);
	    String userFileName = request.getParameter(prefix);
	    String userTypeId = request.getParameter("t"+prefix);
	    String kindOfFile = request.getParameter("f"+prefix);
	    return filstr.setContents(xyz, userFilePath, userFileName, userTypeId, kindOfFile);
	  }

  
  public int addTop( RequestParser request) throws Exception {
    int rezult = 0;
    if (currentTechnology == null) return 1;
    tempTop = new Top();
    setTargetParameters( 0, tempTop, request);
    String genId = request.getParameter("genId".trim());
    List<RelationObject> relList = new ArrayList<RelationObject>();
    for (int i = 0; ; i++) {
      String a = String.valueOf(i);
      String rel = request.getParameter("rel" + a);
      String relType = request.getParameter("relType" + a);
      String oldRel = request.getParameter("oldRel" + a);
      if ((rel != null && !rel.trim().equals("0")) ||
          (oldRel != null && !oldRel.trim().equals("0")))
        relList.add(new RelationObject(relType, oldRel, rel));
      else break;
    }
    int checkP = checkPersonId( genId);
    if (checkP > 0) setInvalidFields("genId", checkP);
    Iterator iter = relList.iterator();
    while (iter.hasNext()) {
      RelationObject rlObj = (RelationObject) iter.next();
      String rel = rlObj.getPersonId();
      if (rel != null && !rel.trim().equals("0")) {
        Top relPerson = (Top)getObjectById(Top.class, rel);
        if (relPerson == null) setInvalidFields("rel1", 4);
      }
    }
    tempTop.setCreateInfo(currentUser);
    tempTop.setTechnology(currentTechnology);  
    tempTop.setComment(request.getParameter("comment"));
    tempTop.setVisibleName(genId);
    tempTop.setOwner( currentUser);
    tempTop.setOwnerGroup( currentUser.getDefaultUserGroup());
    tempTop.setProtocolFiles( getContents( request, getProtocolFileString()));
    tempTop.setDataFiles( getContents( request, getDataFileString()));
    if (isInvalidField()) rezult = 2; else {
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        hibSess.save(tempTop);
        tx.commit();
        tx = null;
        currentTop = tempTop;
        currentMiddle = null;
        currentBottom = null;
        iter = relList.iterator();
        while (iter.hasNext()) {
          RelationObject rlObj = (RelationObject) iter.next();
          String rel = rlObj.getPersonId();
          if (rel != null && !rel.trim().equals("0")) {
            Top relPerson = (Top)getObjectById(Top.class, rel);
            addRelation(tempTop, relPerson, rlObj.getRelTypeId());
          }
        }
        renameTempFile( tempTop.getId());
      }
      catch (Exception e) {
        if (tx!=null) tx.rollback();
        throw e;
      }
      finally {
        hibSess.close(); //needs before forward
        resetTransactionObjects();
      }
    }
    return rezult;
  }

    public int updateTop( RequestParser request) throws Exception {
      int rezult = 0;
      if (currentTechnology == null) return 1;
      Top tmpTop = currentTop;
      if (tmpTop == null) return 1;
      String selfId = request.getParameter("selfId");
      if (!selfId.equals(tmpTop.getId().toString())) return 1;
      setTargetParameters( 0, tmpTop, request);
      String genId = request.getParameter("genId".trim());
      List<RelationObject> relList = new ArrayList<RelationObject>();
      for (int i = 0; ; i++) {
        String a = String.valueOf(i);
        String rel = request.getParameter("rel" + a);
        String relType = request.getParameter("relType" + a);
        String oldRel = request.getParameter("oldRel" + a);
        if ((rel != null && !rel.trim().equals("0")) ||
        (oldRel != null && !oldRel.trim().equals("0")))
        relList.add(new RelationObject(relType, oldRel, rel));
        else
        break;
      }
      if (!tmpTop.getVisibleName().equals(genId)){
        int checkP = checkPersonId( genId);
        if (checkP > 0) setInvalidFields("genId", checkP);
      }
      Iterator iter1 = relList.iterator();
      while (iter1.hasNext()) {
          RelationObject rlObj = (RelationObject) iter1.next();
          String rel = rlObj.getPersonId();
          if (rel != null && !rel.trim().equals("0")) {
              if (tmpTop.getId().toString().equals(rel) ||
                  getObjectById(Top.class,rel)==null)
                  setInvalidFields("rel1", 4);            }
      }
      tmpTop.setModifInfo(currentUser);
      tmpTop.setComment(request.getParameter("comment"));
      tmpTop.setVisibleName(genId);
      String ownerId = request.getParameter("ow_user");
      User owner = (User)getObjectById(User.class, ownerId);
      if (owner!=null) tmpTop.setOwner( owner);
      String groupId = request.getParameter("ow_group");
      UserGroup group = (UserGroup)getObjectById(UserGroup.class, groupId);
      if (group!=null) tmpTop.setOwnerGroup( group);
      tmpTop.setProtocolFiles( getContents( request, getProtocolFileString()));
      tmpTop.setDataFiles( getContents( request, getDataFileString()));
      if (isInvalidField()) rezult = 2; else {
        Transaction tx = null;
        try {
          tx = hibSess.beginTransaction();
          hibSess.update(tmpTop);
          tx.commit();
          tx = null;
          Iterator iter2 = relList.iterator();
          while (iter2.hasNext()) {
            RelationObject rlObj = (RelationObject) iter2.next();
            String rel = rlObj.getPersonId();
            String oldRel = rlObj.getOldRelId();
            String relType = rlObj.getRelTypeId();
            if (rel != null && !rel.trim().equals("0")) {
              Top relPerson = (Top)getObjectById(Top.class, rel);
              if (oldRel.equals("0"))
                addRelation(tmpTop, relPerson, relType);
              else
                updateRelation(oldRel, tmpTop, relPerson, relType);
            }
            else
              if (!oldRel.equals("0")) deleteRelation(oldRel);
          }
          String[] names = protocolFileString.getDeletedFileNames();
          if (names!=null) deleteProtocolFile( names);
          names = dataFileString.getDeletedFileNames();
          if (names!=null) deleteDataFile( names);
          renameTempFile( tmpTop.getId());
        }
        catch (Exception e) {
          if (tx!=null) tx.rollback();
          throw e;
        }
        finally {
          hibSess.close(); //needs before forward
          resetTransactionObjects();
        }
      }
      return rezult;
  }

    public int deletePerson( String selfId) throws Exception {
        Top tmpPerson = getCurrentTop();
        if (tmpPerson == null) return 1;
        if (!selfId.equals(tmpPerson.getId().toString())) return 1;
        List relList = tmpPerson.getRelations1();
        Iterator iter = relList.iterator();
        while (iter.hasNext()) {
          Relation relation = (Relation) iter.next();
          String relId = relation.getId().toString();
          deleteRelation( relId);
        }
        Transaction tx = null;
        try {
            tx = hibSess.beginTransaction();
            hibSess.delete(tmpPerson);
            tx.commit();
        }
        catch (Exception e) {
            if (tx!=null) tx.rollback();
            throw e;
        }
        finally {
            currentBottom = null;
            currentMiddle = null;
            currentTop = null;
            hibSess.close(); //needs before forward
        }
        return 0;
    }
//----------------------------------------------------------//
//----------------- Sample table ---------------------------//
//----------------------------------------------------------//
  public int checkSampleId(String genId) {
      int result = 0;
      if (genId==null||genId.trim().equals("")) result = 2;
      else
      try {
          Query q = hibSess.createQuery("select count(*) from Middle sampl"
                     + " where sampl.visibleName = :genId"
                     + " and sampl.parent = :persId");
          q.setString("genId",genId);
          q.setLong( "persId", currentTop.getId().longValue());
          Long cnt = (Long) q.iterate().next();
          if (cnt.intValue() > 0) result = 3;
      } catch (Exception ex) {
          result = 1;
      }
      return result;
  }

  public int addMiddle( RequestParser request) throws Exception {
    int rezult = 0;
    if (currentTechnology == null) return 1;
    Top myPers = getCurrentTop();
    if (myPers == null) return 1;
    tempMiddle = new Middle();
    setTargetParameters( 1, tempMiddle, request);
    String genId = request.getParameter("genId").trim();
    int checkS = checkSampleId( genId);
    if (checkS > 0) setInvalidFields("genId", checkS);
    tempMiddle.setCreateInfo(currentUser);
    tempMiddle.setTechnology(currentTechnology);  
    tempMiddle.setComment(request.getParameter("comment"));
    tempMiddle.setVisibleName(genId);
    tempMiddle.setParent(myPers);
    tempMiddle.setProtocolFiles( getContents( request, getProtocolFileString()));
    tempMiddle.setDataFiles( getContents( request, getDataFileString()));
    if (isInvalidField()) rezult = 2; else {
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        hibSess.save(tempMiddle);
        tx.commit();
        tx = null;
        renameTempFile( tempMiddle.getId());
        currentMiddle = tempMiddle;
      } catch (Exception e) {
        if (tx != null) tx.rollback();
        throw e;
      } finally {
        hibSess.close(); //needs before forward
        resetTransactionObjects();
      }
    }
    return rezult;
}

  public int updateMiddle(RequestParser request) throws Exception {
    int rezult = 0;
    if (currentTechnology == null) return 1;
    Middle tmpMiddle = getCurrentMiddle();
    if (tmpMiddle == null)return 1;
    String selfId = request.getParameter("selfId");
    if (!selfId.equals(tmpMiddle.getId().toString())) return 1;
    setTargetParameters( 1, tmpMiddle, request);
    String genId = request.getParameter("genId").trim();
    if (!tmpMiddle.getVisibleName().equals(genId)){
      int checkS = checkSampleId( genId);
      if (checkS > 0) setInvalidFields("genId", checkS);
    }
    tmpMiddle.setModifInfo(currentUser);
    tmpMiddle.setComment(request.getParameter("comment"));
    tmpMiddle.setVisibleName(genId);
    tmpMiddle.setProtocolFiles( getContents( request, getProtocolFileString()));
    tmpMiddle.setDataFiles( getContents( request, getDataFileString()));
    if (isInvalidField()) rezult = 2; else {
      Transaction tx = null;
      try {
          tx = hibSess.beginTransaction();
          hibSess.update(tmpMiddle);
          tx.commit();
          tx = null;
          String[] names = protocolFileString.getDeletedFileNames();
          if (names!=null) deleteProtocolFile( names);
          names = dataFileString.getDeletedFileNames();
          if (names!=null) deleteDataFile( names);
          renameTempFile( tmpMiddle.getId());
      }
      catch (Exception e) {
          if (tx!=null) tx.rollback();
          throw e;
      }
      finally {
          hibSess.close(); //needs before forward
          resetTransactionObjects();
      }
    }
    return rezult;
  }

  public int deleteSample( String selfId) throws Exception {
      Middle tmpSample = getCurrentMiddle();
      if (tmpSample == null) return 1;
      if (!selfId.equals(tmpSample.getId().toString())) return 1;
      Transaction tx = null;
      try {
          tx = hibSess.beginTransaction();
          hibSess.delete(tmpSample);
          tx.commit();
      }
      catch (Exception e) {
          if (tx!=null) tx.rollback();
          throw e;
      }
      finally {
          hibSess.close(); //needs before forward
          currentBottom = null;
          currentMiddle = null;
      }
      return 0;
  }
//----------------------------------------------------------//
//----------------- Aliquot table ---------------------------//
//----------------------------------------------------------//
  public void checkAliquotId(String genId) {
      int result = 0;
      if (genId==null||genId.trim().equals("")){
    	  result = 2;
      }
      else
      try {
          Query q = hibSess.createQuery("select count(*) from Bottom aliq"
                     + " where aliq.visibleName = :genId"
                     + " and aliq.parent = :samplId");
          q.setString("genId",genId);
          q.setLong( "samplId", currentMiddle.getId().longValue());
          Long cnt = (Long) q.iterate().next();
          if (cnt.intValue() > 0) result = 3;
      } catch (Exception ex) {
          result = 1;
      }
      if (result > 0)setInvalidFields( "genId", result);;
  }

  public int addBottom( RequestParser request) throws Exception {
    int rezult = 0;
    if (currentTechnology == null) return 1;
    Middle mySampl = getCurrentMiddle();
    if (mySampl == null) return 1;
    tempBottom = new Bottom();
    setTargetParameters( 2, tempBottom, request);
    String genId = request.getParameter("genId").trim();
    String qualFileName = request.getParameter("inputfile");
    if (qualFileName==null||qualFileName.equals(""))
      qualFileName = request.getParameter("qualityName");
    checkAliquotId( genId);
    tempBottom.setCreateInfo(currentUser);
    tempBottom.setTechnology(currentTechnology);  
    tempBottom.setComment(request.getParameter("comment"));
    tempBottom.setVisibleName(genId);
    tempBottom.setParent(mySampl);
    tempBottom.setQualityFileName( qualFileName);

    tempBottom.setProtocolFiles( getContents( request, getProtocolFileString()));
    tempBottom.setDataFiles( getContents( request, getDataFileString()));
    
    if (isInvalidField()) rezult = 2; else {
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        hibSess.save(tempBottom);
        tx.commit();
        tx = null;
        if (qualFileName!=null && !qualFileName.equals(""))
          renameTempFile(tempBottom.getQualityName());
        renameTempFile( tempBottom.getId());
        currentBottom = tempBottom;
      } catch (Exception e) {
        if (tx != null) tx.rollback();
        throw e;
      } finally {
        hibSess.close(); //needs before forward
        resetTransactionObjects();
      }
    }
    return rezult;
}
  public int updateBottom(  RequestParser request) throws Exception {
    int rezult = 0;
    if (currentTechnology == null) return 1;
    Bottom tmpBottom = getCurrentBottom();
    if (tmpBottom == null)return 1;
    String selfId = request.getParameter("selfId");
    if (!selfId.equals(tmpBottom.getId().toString())) return 1;
    setTargetParameters( 2, tmpBottom, request);
    String genId = request.getParameter("genId").trim();
    if (!tmpBottom.getVisibleName().equals(genId)) checkAliquotId(genId);
    String qualFileName = request.getParameter("inputfile");
    if (qualFileName==null||qualFileName.equals(""))
      qualFileName = request.getParameter("qualityName");;
    tmpBottom.setModifInfo( currentUser);
    tmpBottom.setComment(request.getParameter("comment"));
    tmpBottom.setVisibleName(genId);
    String oldQualFileName = tmpBottom.getQualityFileName();
    tmpBottom.setQualityFileName( qualFileName);

    tmpBottom.setProtocolFiles( getContents( request, getProtocolFileString()));
    tmpBottom.setDataFiles( getContents( request, getDataFileString()));

    if (isInvalidField()) rezult = 2; else {
      Transaction tx = null;
      try {
          tx = hibSess.beginTransaction();
          hibSess.update(tmpBottom);
          tx.commit();
          tx = null;
          if (qualFileName!=null && !qualFileName.equals(""))
            renameTempFile(tmpBottom.getQualityName());
          else
          if (oldQualFileName!=null && !oldQualFileName.equals(""))
            deletePermFile(tmpBottom.getQualityName());
          
          String[] names = protocolFileString.getDeletedFileNames();
          if (names!=null) deleteProtocolFile( names);
          names = dataFileString.getDeletedFileNames();
          if (names!=null) deleteDataFile( names);
          renameTempFile( tmpBottom.getId());
      }
      catch (Exception e) {
          if (tx!=null) tx.rollback();
          throw e;
      }
      finally {
          hibSess.close(); //needs before forward
          resetTransactionObjects();
      }
    }
    return rezult;
  }

  public int deleteAliquot(String selfId) throws Exception {
      Bottom tmpAliquot = getCurrentBottom();
      if (tmpAliquot == null) return 1;
      if (!selfId.equals(tmpAliquot.getId().toString())) return 1;
      Transaction tx = null;
      try {
          tx = hibSess.beginTransaction();
          deletePermFile(tmpAliquot.getQualityName());
          hibSess.delete(tmpAliquot);
          tx.commit();
      }
      catch (Exception e) {
          if (tx!=null) tx.rollback();
          throw e;
      }
      finally {
          hibSess.close(); //needs before forward
          deleteTempFile();
          currentBottom = null;
      }
      return 0;
  }
//------------------------------------------------------------------------
  public boolean[] compareBatchBottom( Long[] batchArray) throws Exception {
      if (currentUser == null || batchArray == null)return null;
      Bottom firstObj = (Bottom)getObjectById(Bottom.class, batchArray[0]);
      boolean[] batchBools = new boolean[VocabulName.getTotalCount()];
      for ( int i = 0; i < batchBools.length; i++) batchBools[i]=true;
      Long[] vtIds = new Long[VocabulName.getVocabularyCount()+1];
      for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
        vtIds[i] = null; batchBools[VocabulName.getVocabularyFirst()+i] = true;
        String key = VocabulName.getFieldNameVT(i);
        if (mdm.hasBottomField(key)) {
          Method meth = Bottom.class.getMethod(VocabulName.
                                               getGetMethodNameVT(i), (Class[])null);
          Persistent tmpObj = (Persistent) meth.invoke(firstObj, (Object[])null);
          if (tmpObj != null) vtIds[i] = tmpObj.getId();
        }
      }
      for ( int ib = 1; ib < batchArray.length; ib++) {
        Bottom tmpObj = (Bottom)getObjectById(Bottom.class, batchArray[ib]);
        if (tmpObj == null) continue;
        firstObj.compareWith( tmpObj, mdm, batchBools, vtIds);
      }
      return batchBools;
  }
  public boolean[] compareBatchMiddle( Long[] batchArray) throws Exception {
      if (currentUser == null || batchArray == null)return null;
      Middle firstObj = (Middle)getObjectById(Middle.class, batchArray[0]);
      boolean[] batchBools = new boolean[VocabulName.getTotalCount()];
      for ( int i = 0; i < batchBools.length; i++) batchBools[i]=true;
      Long[] vtIds = new Long[VocabulName.getVocabularyCount()+1];
      for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
        vtIds[i] = null; batchBools[VocabulName.getVocabularyFirst()+i] = true;
        String key = VocabulName.getFieldNameVT(i);
        if (mdm.hasMiddleField(key)) {
          Method meth = Middle.class.getMethod(VocabulName.
                                               getGetMethodNameVT(i), (Class[])null);
          Persistent tmpObj = (Persistent) meth.invoke(firstObj, (Object[])null);
          if (tmpObj != null) vtIds[i] = tmpObj.getId();
        }
      }
      for ( int ib = 1; ib < batchArray.length; ib++) {
        Middle tmpObj = (Middle)getObjectById(Middle.class, batchArray[ib]);
        if (tmpObj == null) continue;
        firstObj.compareWith( tmpObj, mdm, batchBools, vtIds);
      }
      return batchBools;
  }
  public boolean[] compareBatchTop( Long[] batchArray) throws Exception {
      if (currentUser == null || batchArray == null)return null;
      Top firstObj = (Top)getObjectById(Top.class, batchArray[0]);
      boolean[] batchBools = new boolean[VocabulName.getTotalCount()];
      for ( int i = 0; i < batchBools.length; i++) batchBools[i]=true;
//      MetadataManager mdm = getMetadataManager();
      Long[] vtIds = new Long[VocabulName.getVocabularyCount()+1];
      for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
        vtIds[i] = null; batchBools[VocabulName.getVocabularyFirst()+i] = true;
        String key = VocabulName.getFieldNameVT(i);
        if (mdm.hasTopField(key)) {
          Method meth = Top.class.getMethod(VocabulName.
                                               getGetMethodNameVT(i), (Class[])null);
          Persistent tmpObj = (Persistent) meth.invoke(firstObj, (Object[])null);
          if (tmpObj != null) vtIds[i] = tmpObj.getId();
        }
      }
      for ( int ib = 1; ib < batchArray.length; ib++) {
        Top tmpObj = (Top)getObjectById(Top.class, batchArray[ib]);
        if (tmpObj == null) continue;
        firstObj.compareWith( tmpObj, mdm, batchBools, vtIds);
      }
      return batchBools;
  }
  private void setBatchParameters( int type, Object target,
         HttpServletRequest request ) throws Exception {
    Class targetClass = target.getClass();
    for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
      String key = VocabulName.getFieldNameVT(i);
      if (mdm.hasField(type, key)) {
        String value = request.getParameter(key);
        if (value == null)continue;
        Class xyz = Class.forName(VocabulName.getClassNameVT(i));
        Persistent myObj = (Persistent) getObjectById(xyz, value);
        Class[] paramTypes = {xyz};
        Method meth = targetClass.getMethod(VocabulName.getSetMethodNameVT(i),
                                          paramTypes);
        Object[] args = {myObj};
        meth.invoke( target, args);
      }
    }
    for (int i = 1; i <= VocabulName.getStringCount(type); i++) {
      String key = VocabulName.getFieldNameST(i);
      if (mdm.hasField( type, key)) {
        String value = request.getParameter(key);
        if (value == null)continue;
        Class[] paramTypes = {String.class};
        Method meth = targetClass.getMethod(VocabulName.getSetMethodNameST(i), paramTypes);
        Object[] args = {value};
        meth.invoke(target, args);
      }
    }
    for (int i = 1; i <= VocabulName.getIntegerCount(type); i++) {
      String itxx = VocabulName.getFieldNameIT(i);
      if (mdm.hasField(type, itxx)) {
        String value = request.getParameter(itxx);
        if (value == null)continue;
        if (!Util.checkIntegerValue(value))
          setInvalidFields(itxx, 7);
        else {
          Integer ivalue = Util.getInteger(value);
          Class[] paramTypes = {Integer.class};
          Method meth = targetClass.getMethod( VocabulName.getSetMethodNameIT(i),
                                               paramTypes);
          Object[] args = {ivalue};
          meth.invoke(target, args);
        }
      }
    }
    for (int i = 1; i <= VocabulName.getFloatCount(type); i++) {
      String itxx = VocabulName.getFieldNameFT(i);
      if (mdm.hasField( type, itxx)) {
        String value = request.getParameter(itxx);
        if (value == null)continue;
        if (!Util.checkFloatValue(value))
          setInvalidFields(itxx, 7);
        else {
          Double fvalue = Util.getFloat(value);
          Class[] paramTypes = {Double.class};
          Method meth = targetClass.getMethod(VocabulName.
              getSetMethodNameFT(i),
              paramTypes);
          Object[] args = {fvalue};
          meth.invoke(target, args);
        }
      }
    }
    for (int i = 1; i <= VocabulName.getDateCount(type); i++) {
      String itxx = VocabulName.getFieldNameDT(i);
      if (mdm.hasField( type, itxx)) {
        String value = request.getParameter(itxx);
        if (value == null)continue;
        Date dvalue = getDate(request, itxx);
        Class[] paramTypes = {Date.class};
        Method meth = targetClass.getMethod(VocabulName.
            getSetMethodNameDT(i),paramTypes);
        Object[] args = {dvalue};
        meth.invoke(target, args);
      }
    }
  }

  public int updateBatchBottom( Long[]batchArray, HttpServletRequest request) throws Exception {
      int rezult = 0;
      if (currentUser == null || batchArray == null)return 1;
      clearInvalidFields();
      try{
        for (int ib = 0; ib < batchArray.length; ib++) {
          Bottom tmpBottom = (Bottom)
                             getObjectById(Bottom.class, batchArray[ib]);
          if (tmpBottom == null)return 1;
          setBatchParameters( 2, tmpBottom,request);
          tmpBottom.setModifInfo(currentUser);
          if (isInvalidField()) {
            rezult = 2;
            break;
          } else {
            Transaction tx = null;
            try {
              tx = hibSess.beginTransaction();
              hibSess.update(tmpBottom);
              tx.commit();
            } catch (Exception e) {
              if (tx != null) tx.rollback();
              throw e;
            }
//            finally {
//               hibSess.close(); //needs before forward
//            }
          }
        }
      }
      catch (Exception e) {
         throw e;
      }
      return rezult;
  }
  public int updateBatchMiddle( Long[]batchArray, HttpServletRequest request) throws Exception {
      int rezult = 0;
      if (currentUser == null || batchArray == null)return 1;
      clearInvalidFields();
      try{
        for (int ib = 0; ib < batchArray.length; ib++) {
          Middle tmpMiddle = (Middle)
                             getObjectById(Middle.class, batchArray[ib]);
          if (tmpMiddle == null)return 1;
          setBatchParameters( 1, tmpMiddle,request);
          tmpMiddle.setModifInfo(currentUser);
          if (isInvalidField()) {
            rezult = 2;
            break;
          } else {
            Transaction tx = null;
            try {
              tx = hibSess.beginTransaction();
              hibSess.update(tmpMiddle);
              tx.commit();
            } catch (Exception e) {
              if (tx != null) tx.rollback();
              throw e;
            }
          }
        }
      }
      catch (Exception e) {
         throw e;
      }
      return rezult;
  }
  public int updateBatchTop( Long[]batchArray, HttpServletRequest request) throws Exception {
      int rezult = 0;
      if (currentUser == null || batchArray == null)return 1;
      clearInvalidFields();
      try{
        for (int ib = 0; ib < batchArray.length; ib++) {
          Top tmpTop = (Top)
                             getObjectById(Top.class, batchArray[ib]);
          if (tmpTop == null)return 1;
          setBatchParameters( 0, tmpTop,request);

          String ownerId = request.getParameter("ow_user");
          User owner = (User)getObjectById(User.class, ownerId);
          if (owner!=null) tmpTop.setOwner( owner);
          String groupId = request.getParameter("ow_group");
          UserGroup group = (UserGroup)getObjectById(UserGroup.class, groupId);
          if (group!=null) tmpTop.setOwnerGroup( group);

          tmpTop.setModifInfo(currentUser);
          if (isInvalidField()) {
            rezult = 2;
            break;
          } else {
            Transaction tx = null;
            try {
              tx = hibSess.beginTransaction();
              hibSess.update(tmpTop);
              tx.commit();
            } catch (Exception e) {
              if (tx != null) tx.rollback();
              throw e;
            }
          }
        }
      }
      catch (Exception e) {
         throw e;
      }
      return rezult;
  }
//----------------------------------------------------------//
//----------------------------------------------------------//
  public void setCurrentAliquot(String aliquotId) throws HibernateException {
      currentBottom = (Bottom)getObjectById(Bottom.class, aliquotId);
      if (currentBottom != null) currentMiddle = currentBottom.getParent();
      if (currentMiddle != null) currentTop = currentMiddle.getParent();
//      if (currentPerson != null)
//              currentPersonSourceId = currentPerson.getPersonSource().getId();
  }

  public void setCurrentSample(String sampleId) throws HibernateException {
      currentBottom = null;
      currentMiddle = (Middle)getObjectById(Middle.class, sampleId);
      if (currentMiddle != null) currentTop = currentMiddle.getParent();
  }

  public void setCurrentPerson(String personId) throws HibernateException {
      currentBottom = null;
      currentMiddle = null;
      currentTop = (Top) getObjectById(Top.class, personId);
  }
//invoke in session
  public Top getCurrentPersonInSession() throws HibernateException {
    if (currentTop!=null)
      currentTop = (Top)getObjectById(Top.class, currentTop.getId());
    return currentTop;
  }
//invoke in session
  public Middle getCurrentSampleInSession() throws HibernateException {
    if (currentMiddle!=null)
        currentMiddle = (Middle)
                  getObjectById(Middle.class, currentMiddle.getId());
    return currentMiddle;
  }

  public Top getCurrentTop(){
      return currentTop;
  }

  public Long getCurrentPersonId(){
      return (currentTop==null)?null:currentTop.getId();
  }

  public Middle getCurrentMiddle(){
      return currentMiddle;
  }

  public Long getCurrentSampleId(){
      return (currentMiddle==null)?null:currentMiddle.getId();
  }

  public Bottom getCurrentBottom(){
      return currentBottom;
  }

  public Long getCurrentAliquotId(){
      return (currentBottom==null)?null:currentBottom.getId();
  }

  public Top getTempTop(){
      return tempTop;
  }
  public Middle getTempMiddle(){
      return tempMiddle;
  }
  public Bottom getTempBottom(){
      return tempBottom;
  }

  public boolean resetCurrents(){
     cancelAllBatch();
     currentBottom = null;
     currentMiddle = null;
     currentTop = null;
     vam.clearValues();vsm.clearValues();vpm.clearValues();
     return true;
  }
//----------------------------------------------------------//
//----------------------------------------------------------//
/*
  private void checkValue( String value, String valueName){
      if (!value.trim().equals("")){
          try { double xx = Double.parseDouble(value);
          } catch (Exception ex) {
              setInvalidFields(valueName, 7);
          }
      }
  }

  private void checkValueAndYear( String value1, String value2, String year,
             String valueName1, String valueName2, String yearName){
      int vv;
      if (!year.trim().equals("")||
        !value1.trim().equals("")||!value2.trim().equals("")){
        try { vv = Integer.parseInt(value1);
        } catch(Exception ex){
                setInvalidFields(valueName1, 7);
        }
        try { vv = Integer.parseInt(value2);
        } catch(Exception ex){
                setInvalidFields(valueName2, 7);
        }
        try { vv = Integer.parseInt(year);
            if (vv < 1900 || vv > 2100) setInvalidFields(yearName, 5);
        } catch(Exception ex){
                setInvalidFields(yearName, 5);
        }
      }
  }
*/
  public Date getDate( String year){
      Date myDate = null;
      if (!year.trim().equals(""))
      try {
          int yy = Integer.parseInt(year);
          int mm = 1;
          int dd = 1;
          if ( (yy>1900 && yy<2100) || yy==1){
              Calendar myCal = Calendar.getInstance();
              myCal.set(yy, mm - 1, dd);
              myDate = myCal.getTime();
          }
      } catch (Exception ex) {
      }
      return myDate;
  }

  public Date getDate( String year, String month, String day,
          String yearName, String monthName, String dayName){
      int yy=0, mm=0, dd=0; boolean rez = true;
      Date myDate = null;
          try { yy = Integer.parseInt(year);
              if ((yy<1900 && yy!=1) || yy>2100){
                  rez = false; setInvalidFields(yearName, 5);
              }
          } catch(Exception ex){
              rez = false; setInvalidFields(yearName, 5);
          }
          try { mm = Integer.parseInt(month);
              if (mm<1||mm>12){
                rez = false; setInvalidFields(monthName, 5);
              }
          } catch(Exception ex){
              rez = false; setInvalidFields(monthName, 5);
          }
          try { dd = Integer.parseInt(day);
              if (dd<1||dd>31){
                rez = false; setInvalidFields(dayName, 5);
              }
          } catch(Exception ex){
               rez = false; setInvalidFields(dayName, 5);
          }
          if (rez){
              Calendar myCal = Calendar.getInstance();
              myCal.set(yy, mm - 1, dd);
              myDate = myCal.getTime();
          }
      return myDate;
  }

  public Date getDate( String year, String month, String day,
                       String hour, String minute,
                       String yearName, String monthName, String dayName,
                       String hourName, String minuteName){
      int yy=0, mm=0, dd=0, hh=0, mi=0; boolean rez = true;
      Date myDate = null;
          try { yy = Integer.parseInt(year);
              if ((yy<1900 && yy!=1) || yy>2100){
                  rez = false; setInvalidFields(yearName, 5);
              }
          } catch(Exception ex){
              rez = false; setInvalidFields(yearName, 5);
          }
          try { mm = Integer.parseInt(month);
              if (mm<1||mm>12){
                rez = false; setInvalidFields(monthName, 5);
              }
          } catch(Exception ex){
              rez = false; setInvalidFields(monthName, 5);
          }
          try { dd = Integer.parseInt(day);
              if (dd<1||dd>31){
                rez = false; setInvalidFields(dayName, 5);
              }
          } catch(Exception ex){
               rez = false; setInvalidFields(dayName, 5);
          }
          try { hh = Integer.parseInt(hour);
              if (hh<0||hh>23){
                rez = false; setInvalidFields(hourName, 5);
              }
          } catch(Exception ex){
              rez = false; setInvalidFields(hourName, 5);
          }
          try { mi = Integer.parseInt(minute);
              if (mi<0||mi>59){
                rez = false; setInvalidFields(minuteName, 5);
              }
          } catch(Exception ex){
               rez = false; setInvalidFields(minuteName, 5);
          }
          if (rez){
            Calendar myCal = Calendar.getInstance();
            myCal.set(yy, mm - 1, dd);
            myCal.set(Calendar.HOUR_OF_DAY, hh);
            myCal.set(Calendar.MINUTE, mi);
            myDate = myCal.getTime();
          }
      return myDate;
  }
  private Date getDate( HttpServletRequest request, String fieldName){
    int yy=0, mm=1, dd=1, hh=0, mi=0; boolean rez = true;
    Date myDate = null;
    String dtxx = fieldName;   //year
    String year = request.getParameter(dtxx);
    String month = request.getParameter(dtxx+'1');
    String day = request.getParameter(dtxx+'2');
    String hour = request.getParameter(dtxx+'3');
    String minute = request.getParameter(dtxx+'4');
    if ((year==null||year.equals(""))&&
        (month==null||month.equals(""))&&
        (day==null||day.equals(""))&&
        (hour==null||hour.equals(""))&&
        (minute==null||minute.equals("")))
    return null;
    try { yy = Integer.parseInt(year);
        if ((yy<1900 && yy!=1) || yy>2100){
            rez = false; setInvalidFields(dtxx, 5);
        }
    } catch(Exception ex){
        rez = false; setInvalidFields(dtxx, 5);
    }
    if (month == null) mm = 1;
    else
      try { mm = Integer.parseInt(month);
          if (mm<1||mm>12){
            rez = false; setInvalidFields(dtxx+'1', 5);
          }
      } catch(Exception ex){
          rez = false; setInvalidFields(dtxx+'1', 5);
      }
    if (day == null) dd = 1;
    else
      try { dd = Integer.parseInt(day);
          if (dd<1||dd>31){
            rez = false; setInvalidFields(dtxx+'2', 5);
          }
      } catch(Exception ex){
           rez = false; setInvalidFields(dtxx+'2', 5);
      }
    if (hour == null) hh = 0;
    else
      try { hh = Integer.parseInt(hour);
          if (hh<0||hh>23){
            rez = false; setInvalidFields(dtxx+'3', 5);
          }
      } catch(Exception ex){
          rez = false; setInvalidFields(dtxx+'3', 5);
      }
    if (minute == null) mi = 0;
    else
      try { mi = Integer.parseInt(minute);
          if (mi<0||mi>59){
            rez = false; setInvalidFields(dtxx+'4', 5);
          }
      } catch(Exception ex){
           rez = false; setInvalidFields(dtxx+'4', 5);
      }
    if (rez){
      Calendar myCal = Calendar.getInstance();
      myCal.set(yy, mm - 1, dd);
      myCal.set(Calendar.HOUR_OF_DAY, hh);
      myCal.set(Calendar.MINUTE, mi);
      myDate = myCal.getTime();
    }
    return myDate;
  }
  private Date getDate( RequestParser request, String fieldName){
    int yy=0, mm=0, dd=0, hh=0, mi=0; boolean rez = true;
    Date myDate = null;
    String dtxx = fieldName;   //year
    String year = request.getParameter(dtxx);
    String month = request.getParameter(dtxx+'1');
    String day = request.getParameter(dtxx+'2');
    String hour = request.getParameter(dtxx+'3');
    String minute = request.getParameter(dtxx+'4');
    if ((year==null||year.equals(""))&&
        (month==null||month.equals(""))&&
        (day==null||day.equals(""))&&
        (hour==null||hour.equals(""))&&
        (minute==null||minute.equals("")))
    return null;
    try { yy = Integer.parseInt(year);
        if ((yy<1900 && yy !=1) || yy>2100){
            rez = false; setInvalidFields(dtxx, 5);
        }
    } catch(Exception ex){
        rez = false; setInvalidFields(dtxx, 5);
    }
    if (month == null) mm = 1;
    else
      try { mm = Integer.parseInt(month);
          if (mm<1||mm>12){
            rez = false; setInvalidFields(dtxx+'1', 5);
          }
      } catch(Exception ex){
          rez = false; setInvalidFields(dtxx+'1', 5);
      }
    if (day == null) dd = 1;
    else
      try { dd = Integer.parseInt(day);
          if (dd<1||dd>31){
            rez = false; setInvalidFields(dtxx+'2', 5);
          }
      } catch(Exception ex){
           rez = false; setInvalidFields(dtxx+'2', 5);
      }
    if (hour == null) hh = 0;
    else
      try { hh = Integer.parseInt(hour);
          if (hh<0||hh>23){
            rez = false; setInvalidFields(dtxx+'3', 5);
          }
      } catch(Exception ex){
          rez = false; setInvalidFields(dtxx+'3', 5);
      }
    if (minute == null) mi = 0;
    else
      try { mi = Integer.parseInt(minute);
          if (mi<0||mi>59){
            rez = false; setInvalidFields(dtxx+'4', 5);
          }
      } catch(Exception ex){
           rez = false; setInvalidFields(dtxx+'4', 5);
      }
    if (rez){
      Calendar myCal = Calendar.getInstance();
      myCal.set(yy, mm - 1, dd);
      myCal.set(Calendar.HOUR_OF_DAY, hh);
      myCal.set(Calendar.MINUTE, mi);
      myDate = myCal.getTime();
    }
    return myDate;
  }

// rights: A.. all edit; G.. edit group O.. edit own V.. view only
/*  public boolean canAddObject( User creator) {
        if (currentUser == null) return false;
        switch (currentUser.getRights().charAt(0)){
            case 'A' : return true;
            case 'O' : {if (creator==null ||
                           creator.getId().equals(currentUser.getId()))
                    return true; break;}
            case 'G' : {if (creator==null ||
                           currentPartner==null ||
                    (creator.getPartner()!=null&&
                     creator.getPartner().getId().equals(currentPartner)))
                    return true; break;}
        }
        return false;
    }

    public boolean canEditObject( User creator) {
        if (currentUser == null) return false;
        switch (currentUser.getRights().charAt(0)){
            case 'A' : return true;
            case 'O' : {if (creator==null ||
                           creator.getId().equals(currentUser.getId()))
                    return true; break;}
            case 'G' : {if (creator==null ||
                           currentPartner==null ||
                    (creator.getPartner()!=null&&
                     creator.getPartner().getId().equals(currentPartner)))
                    return true; break;}
        }
        return false;
    }

    public boolean canDeleteObject( User creator) {
        if (currentUser == null) return false;
        switch (currentUser.getRights().charAt(0)){
            case 'A' : return true;
            case 'O' : {if (creator==null ||
                           creator.getId().equals(currentUser.getId()))
                    return true; break;}
            case 'G' : {if (creator==null ||
                           currentPartner==null ||
                    (creator.getPartner()!=null&&
                     creator.getPartner().getId().equals(currentPartner)))
                    return true; break;}
        }
        return false;
    }
*/

    public void clearInvalidFields() {
      invalidFields = null;
    }

    private boolean isInvalidField() {
      return invalidFields != null;
    }

    private void setInvalidFields(String fieldName, int rezult) {
      if (invalidFields == null) invalidFields = new HashMap<String,Integer>();
      invalidFields.put(fieldName, new Integer(rezult));
    }

    public String getFieldId(String fieldName) {
      if (invalidFields != null){
        Integer rezult = (Integer) invalidFields.get(fieldName);
        invalidFields.remove(fieldName);
        if (rezult != null)
          return " id=\"kluda\" title=\""
            + getMyMessage(rezult.intValue())
            + "\"";
      }
      return "";
    }

    public String getFieldId(String fieldName, boolean white) {
      if (invalidFields != null){
        Integer rezult = (Integer) invalidFields.get(fieldName);
        invalidFields.remove(fieldName);
        if (rezult != null)
          return " id=\"kluda\" title=\""
            + getMyMessage(rezult.intValue())
            + "\"";
      }
      if (!white)
        return " style='background-color:#E5EAF0'";
      return "";
    }


    public String getInvalidFieldNames() {
      if (invalidFields == null || invalidFields.isEmpty()) return "";
      Set names = invalidFields.keySet();
      Iterator iter = names.iterator();
      StringBuffer xyz = new StringBuffer();
      xyz.append("Errors in field(s):");
      while (iter.hasNext()) {
        String name = (String) iter.next();
        xyz.append(name)
           .append(';');
      }
      return xyz.toString();
    }
//----------------------------------------------------------//
//----------------------------------------------------------//
    public File getTempFile(){ //used by RequestParser
       tempFile = new File( WebappConfig.getDataDirectory(), httpSessId);
       return tempFile;
    }

    public void deleteTempFile( ){
        if (tempFile!=null){
            tempFile.delete();
            tempFile = null;
        }
    }

    public void renameTempFile( String fileName){
        if (tempFile!=null){
            File permFile = new File( WebappConfig.getDataDirectory(), fileName);
            permFile.delete();
            tempFile.renameTo(permFile);
            tempFile = null;
        }
    }

    public void deletePermFile( String fileName){
        File permFile = new File( WebappConfig.getDataDirectory(), fileName);
        permFile.delete();
    }
//----------------------------------------------------------//
//----------------------------------------------------------//
    public boolean repair20080521() throws Exception {
/*
        HashMap subtypeMap = new HashMap();
        List list = getAllObjects(SampleSubType.class);
        Iterator subtypeIterator = list.iterator();
        while (subtypeIterator.hasNext()) {
          SampleSubType subtype = (SampleSubType) subtypeIterator.next();
          IVT01 type = subtype.getSampleType();
          if (!subtypeMap.containsKey(subtype.getVisibleName()))
            subtypeMap.put(subtype.getVisibleName(), subtype);
          else
            subtype = (SampleSubType)subtypeMap.get( subtype.getVisibleName());
          DVT01 dvt01 = (DVT01)DVT01.class.newInstance();
          dvt01.setServer(type);
          dvt01.setClient(subtype);
          addPersistentWithoutClose( dvt01, "", "");
        }
        Transaction tx = null;
        try {
//           hibSess = hibFactory.openSession();
          tx = hibSess.beginTransaction();
          Query q = hibSess.createQuery(
                  "select mySample from Middle as mySample");
          List samples = q.list();
          Iterator sampleIterator = samples.iterator();
          while (sampleIterator.hasNext()) {
            Middle middle = (Middle) sampleIterator.next();
            SampleSubType subtype = middle.getSubType();
            IVT01 type = subtype.getSampleType();
            middle.setIvt01( type);
            middle.setSubType( (SampleSubType)subtypeMap.get(subtype.getVisibleName()));
            hibSess.update(middle);
          }
          tx.commit();
        } catch (Exception e) {
            if (tx!=null) tx.rollback();
            throw e;
        }
        finally {
            hibSess.close(); //needs before forward
        }
*/
        return true;
    }
//----------------------------------------------------------//
    public ViewBatchManager getViewBatchManager(){
      return batchMan;
    }
    public ViewPersonManager getViewPersonManager(){
      return vpm;
    }
    public ViewSampleManager getViewSampleManager(){
      return vsm;
    }
    public ViewAliquotManager getViewAliquotManager(){
      return vam;
    }
//----------------------------------------------------------//
//----------------------------------------------------------//
    public Persistent getObjectByName(Class cl, String name) throws Exception {
      Persistent obj = null;
      Query q = hibSess.createQuery(
            "from " + cl.getName() + " myObj where myObj.visibleName = '"
            + name + "'");
      List list = q.list();
      if (list!=null && list.size()>0) obj = (Persistent) list.get(0);
      return obj;
    }

    public Long checkObjectByName( Class cl, String visname) throws Exception {
    //used by batch analyser only
      Long rezult = null;
      if (visname != null && !visname.trim().equals(""))
        try {
          Query q = hibSess.createQuery("select obj.id from "
           + cl.getName()
           + " obj where obj.visibleName = :visname");
          q.setString("visname", visname);
          List list = q.list();
          if (list.size() > 0) rezult = (Long) list.get(0);
        }
        catch (Exception s) {
        }
      return rezult;
    }
    public Long checkDependencyByIds( Class cl, Long serverId, Long clientId) throws Exception {
    //used by XML import only
      Long rezult = null;
        try {
          Query q = hibSess.createQuery("select obj.id from "
           + cl.getName()
           + " obj where obj.server = :server and obj.client = :client");
          q.setLong("server", serverId.longValue());
          q.setLong("client", clientId.longValue());
          List list = q.list();
          if (list.size() > 0) rezult = (Long) list.get(0);
        }
        catch (Exception s) {
        }
      return rezult;
    }
    public Top getTopElement(String topName) {
      //used by batch analyser only
      Top rezult = null;
      if (topName != null && !topName.trim().equals(""))
        try {
            Query q = hibSess.createQuery("select obj from Top obj"
             + " where obj.technology=:technid and obj.visibleName = :visname");
            q.setString("visname", topName);
            q.setLong("technid",currentTechnology.getId().longValue());
            List list = q.list();
            if (list.size() > 0) rezult = (Top) list.get(0);
        }
        catch (Exception s) {}
      return rezult;
    }
    public Long getMiddleElementId(Long topId, String middleName) {
      //used by batch analyser only
      Long rezult = null;
      if (topId != null && middleName != null && !middleName.trim().equals(""))
        try {
            Query q = hibSess.createQuery("select obj.id from Middle obj"
             + " where obj.visibleName = :middlename "
             + " and obj.parent = :pid");
            q.setString("middlename", middleName);
            q.setLong("pid", topId.longValue());
            List list = q.list();
            if (list.size() > 0) rezult = (Long) list.get(0);
        }
        catch (Exception s) {}
      return rezult;
    }
    public Long getBottomElementId(Long middleId, String bottomName) {
        //used by batch analyser only
        Long rezult = null;
        if (middleId != null && bottomName != null && !bottomName.trim().equals(""))
          try {
              Query q = hibSess.createQuery("select obj.id from Bottom obj"
               + " where obj.visibleName = :bottomname "
               + " and obj.parent = :pid");
              q.setString("bottomname", bottomName);
              q.setLong("pid", middleId.longValue());
              List list = q.list();
              if (list.size() > 0) rezult = (Long) list.get(0);
          }
          catch (Exception s) {}
        return rezult;
      }
/*
    public Long checkBottomId(String visname) {
      //used by batch analyser only
      Long rezult = null;
        if (visname != null && !visname.trim().equals(""))
          try {
            Query q = hibSess.createQuery("select obj.id from Bottom obj"
             + " where obj.visibleName = :visname");
            q.setString("visname", visname);
            List list = q.list();
            if (list.size() > 0) rezult = (Long) list.get(0);
          }
          catch (Exception s) {}
      return rezult;
    }
*/
//----------------------------------------------------------//
//----------------------------------------------------------//
/*
    private static File dataDirectory = null;
    private static File workDirectory = null;
    private static boolean isFtp = false;
    private static File ftpDirectory = null;
    private static String ftpUsername = null;
    private static String ftpPassword = null;
    private static String ftpServer = null;
*/
    private File dataTempFile = null;
    private File protocolTempFile = null;
    private File parameterTempFile = null;
    private File zipTempFile = null;
    private File tarTempFile = null;
    private FileString dataFileString = null;
    private FileString protocolFileString = null;
//    private File dataTechnDirectory = null;
//batch upload
    private BatchAnalyser ban = null;

    public File newProtocolTempFile(){ //used by RequestParser
        protocolTempFile = new File( WebappConfig.getProtocolDirectory(), httpSessId);
        return protocolTempFile;
     }

     public File newDataTempFile(){ //used by RequestParser
        dataTempFile = new File( WebappConfig.getDataDirectory(), httpSessId);
        return dataTempFile;
     }

     public File newParameterTempFile(){ //used by RequestParser
        parameterTempFile = new File( WebappConfig.getWorkDirectory(), httpSessId+".par");
        return parameterTempFile;
     }

    public File newZipTempFile(){ //used by RequestParser
      zipTempFile = new File( WebappConfig.getWorkDirectory(), httpSessId+".zip");
      return zipTempFile;
    }
    public File newTarTempFile(){ //used by RequestParser
      tarTempFile = new File( WebappConfig.getWorkDirectory(), httpSessId+".tar");
      return tarTempFile;
    }

     public File getParameterTempFile(){ //used by BatchAnalyser
        return parameterTempFile;
     }
     public File getZipTempFile(){ //used by BatchAnalyser
        return zipTempFile;
     }

     public File getProtocolDirectory(){ //used by ExportFile,BatchAnalyser
        return WebappConfig.getProtocolDirectory();
     }
     public File getDataDirectory(){ //used by ExportFile,BatchAnalyser
        return WebappConfig.getDataDirectory();
     }

   private void renameTempFile( Long id){//used by addBottom etc.
      File permFile; String fileName; String knd;
      knd = protocolFileString.getKindOfFile();
      if (knd!=null){
    	fileName = protocolFileString.getFileName(id);
        if (knd.equals("u")){  //uploaded protocol file
          if (protocolTempFile != null) {
            if (fileName != null) {
              permFile = new File(WebappConfig.getProtocolDirectory(), fileName);
              permFile.delete();
              protocolTempFile.renameTo(permFile);
            }
            else
              protocolTempFile.delete();
            protocolTempFile = null;
          }
        } else
        if (knd.equals("f")){  // not implemented
          if (fileName != null) {
            permFile = new File(WebappConfig.getProtocolDirectory(), fileName);
            permFile.delete();
            File ftpFile = new File( WebappConfig.getFtpDirectory(),
//                 getUserFtpDirectory()+File.separatorChar+
//                 getTechnologyFtpDirectory()+File.separatorChar+
               protocolFileString.getUserFilePath());
//              ftpFile.renameTo(permFile);
            Util.copyFile( ftpFile, permFile);
          }
        }
      }  
      knd = dataFileString.getKindOfFile();
      if (knd!=null){
        fileName = dataFileString.getFileName(id);
        if (knd.equals("u")){    //uploaded data file
          if (dataTempFile != null) {
            if (fileName != null) {
              permFile = new File(WebappConfig.getDataDirectory(), fileName);
              permFile.delete();
              dataTempFile.renameTo(permFile);
            }
            else
              dataTempFile.delete();
            dataTempFile = null;
          }
        } else                  // ftp data file
        if (knd.equals("f")){
          if (fileName != null) {
            permFile = new File(WebappConfig.getDataDirectory(), fileName);
            permFile.delete();
            File ftpFile = new File( WebappConfig.getFtpDirectory(),
//                 getUserFtpDirectory()+File.separatorChar+
//                 getTechnologyFtpDirectory()+File.separatorChar+
               dataFileString.getUserFilePath());
//              ftpFile.renameTo(permFile);
            Util.copyFile( ftpFile, permFile);
          }
        }
      }
    }  

     private void deleteProtocolFile( String[] names){
       for ( int k=0; k < names.length; k++){
//           Util.writeLog("delete protocol",":",names[k]);
         File permFile = new File(WebappConfig.getProtocolDirectory(), names[k]);
         permFile.delete();
       }
     }

     private void deleteDataFile( String[] names){
       for ( int k=0; k < names.length; k++){
//           Util.writeLog("delete data",":",names[k]);
         File permFile = new File(WebappConfig.getDataDirectory(), names[k]);
         permFile.delete();
       }
     }
     public void newProtocolFileString( int level, String fileString, Long sysId)
         throws Exception {
          protocolFileString = new FileString( level, false, fileString, sysId);
          protocolFileString.setTypeBook( getAllObjects(ProtocolType.class));
     }
     public void newDataFileString( int level, String fileString, Long sysId)
         throws Exception {
          dataFileString = new FileString( level, true, fileString, sysId);
          dataFileString.setTypeBook( getAllObjects(DataType.class));
     }

    public FileString getProtocolFileString() throws Exception {
      if (protocolFileString==null)
          throw new Exception( UserHttpSess.getMyMessage(8));
      return protocolFileString;
    }
    public FileString getDataFileString() throws Exception {
      if (dataFileString==null)
          throw new Exception( UserHttpSess.getMyMessage(8));
      return dataFileString;
    }
    public void resetTransactionObjects(){
         ban = null;
         protocolFileString = null;
         dataFileString = null;
         if (protocolTempFile!=null){
             protocolTempFile.delete();
             protocolTempFile = null;
         }
         if (dataTempFile!=null){
             dataTempFile.delete();
             dataTempFile = null;
         }
         if (parameterTempFile!=null){
             parameterTempFile.delete();
             parameterTempFile = null;
         }
         if (zipTempFile!=null){
             zipTempFile.delete();
             zipTempFile = null;
         }
         if (tarTempFile!=null){
             tarTempFile.delete();
             tarTempFile = null;
         }
    }

    public void clearFileStrings() throws Exception {
         getProtocolFileString().clearFileString();
         getDataFileString().clearFileString();
         if (protocolTempFile!=null){
             protocolTempFile.delete();
             protocolTempFile = null;
         }
         if (dataTempFile!=null){
             dataTempFile.delete();
             dataTempFile = null;
         }
    }
    
       public BatchAnalyser newBatchAnalyser( int level){
         ban = new BatchAnalyser( this, level);
         return ban;
       }

       public BatchAnalyser getBatchAnalyser() throws Exception {
         if (ban==null)
             throw new Exception(UserHttpSess.getMyMessage(12));
         return ban;
       }

//-----------------------Ftp used by BatchAnalyser and elsewhere--
  public boolean isFtp(){
    return (currentUser==null)?false:WebappConfig.isFtp() /*&& currentUser.isFtpAllowed()*/;
  }
  public static File getFtpDirectory(){
    return WebappConfig.getFtpDirectory();
  }
  public String getUserFtpDirectory(){
    return (currentUser==null)?"":currentUser.getFtpDirectory();
  }
  public String getTechnologyFtpDirectory(){
    return (currentTechnology==null)?"":currentTechnology.getVisibleFtpDirectory();
  }
//----------------------------------------------------------//
  public void addPendingTask( PendingTask pending, Bottom bottom){
    pending.setBottom( bottom);
    pending.setBatchId( bottom.getBatchId());
    pending.setCreateInfo(currentUser);
    hibSess.save(pending);
  }
  public void addPendingTask( PendingTask pending, Middle middle){
      pending.setMiddle( middle);
      pending.setBatchId( middle.getBatchId());
      pending.setCreateInfo(currentUser);
      hibSess.save(pending);
    }
  public void addPendingTask( PendingTask pending, Top top){
      pending.setTop( top);
      pending.setBatchId( top.getBatchId());
      pending.setCreateInfo(currentUser);
      hibSess.save(pending);
    }
  public void deletePendingTask( Bottom bottom){
      Query q = hibSess.createQuery(
                "select myPen from PendingTask as myPen"
                + " where myPen.bottom = '"
                + bottom.getId().toString() + "'");
      List tasks = q.list();
      Iterator taskIterator = tasks.iterator();
      while (taskIterator.hasNext()) {
        PendingTask task = (PendingTask) taskIterator.next();
        hibSess.delete(task);
      }
    }
  public void deletePendingTask( Middle middle){
      Query q = hibSess.createQuery(
                "select myPen from PendingTask as myPen"
                + " where myPen.middle = '"
                + middle.getId().toString() + "'");
      List tasks = q.list();
      Iterator taskIterator = tasks.iterator();
      while (taskIterator.hasNext()) {
        PendingTask task = (PendingTask) taskIterator.next();
        hibSess.delete(task);
      }
    }
  public void deletePendingTask( Top top){
      Query q = hibSess.createQuery(
              "select myPen from PendingTask as myPen"
              + " where myPen.top = '"
              + top.getId().toString() + "'");
      List tasks = q.list();
      Iterator taskIterator = tasks.iterator();
      while (taskIterator.hasNext()) {
        PendingTask task = (PendingTask) taskIterator.next();
        hibSess.delete(task);
      }
    }
//----------------------------------------------------------//
//----------Upload top-------------------------------
  /*
    private Persistent[] getBatchVocabularyDefaults( int level) throws Exception {
      Persistent[]defaults=null;
      int vcount = VocabulName.getVocabularyCount();
      if (vcount > 0){
        defaults = new Persistent[vcount+1];  defaults[0] = null;
        for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
          defaults[i] = null;
          String key = VocabulName.getFieldNameVT(i);
          if (mdm.hasField( level, key)) {
            String cln = VocabulName.getClassNameVT(i);
            List list = getAllObjects( cln);
            if (list!=null && list.size()>0) defaults[i] = (Persistent)list.get(0);
          }
        }
      }
      return defaults;
    }
*/      
      public int importBatchTop() throws Exception {
        int rezult = 0;
        boolean start = true; String batchId = null;
        if (currentUser == null) return 1;
//        Persistent[]defVT = getBatchVocabularyDefaults(0);
        BatchAnalyser analyser = getBatchAnalyser();
        analyser.startIterator();
        while (analyser.hasNextElement()){
          tempTop = new Top();
          tempTop.setCreateInfo(currentUser);
          tempTop.setTechnology(currentTechnology);  
          tempTop.setOwner( currentUser);
          tempTop.setOwnerGroup( currentUser.getDefaultUserGroup());
          analyser.nextElement(tempTop);
          if (isInvalidField()) rezult = 2; else {
            if (start){ batchId = tempTop.getVisibleName(); start = false;}
            tempTop.setBatchId(batchId);
            Transaction tx = null;
            try {
              tx = hibSess.beginTransaction();
              hibSess.save(tempTop);
              analyser.ProcessFiles(tempTop); //new method!!!
              tx.commit();
              vpm.changePersonTotal(1);
              currentTop = tempTop;
            }
            catch (Exception e) {
              if (tx != null) {
                tx.rollback();
              }
              throw e;
            }
          }
        }
        hibSess.close(); //needs before forward
        resetTransactionObjects();
        return rezult;
      }

      public int importBatchMiddle() throws Exception {
        int rezult = 0;
        boolean start = true; String batchId = null;
        if (currentUser == null) return 1;
//        Persistent[]defVT = getBatchVocabularyDefaults(1);
        BatchAnalyser analyser = getBatchAnalyser();
        analyser.startIterator();
        while (analyser.hasNextElement()){
          tempMiddle = new Middle();
          tempMiddle.setCreateInfo(currentUser);
          tempMiddle.setTechnology(currentTechnology);  
          analyser.nextElement(tempMiddle);
          if (isInvalidField()) rezult = 2; else {
            if (start){ batchId = tempMiddle.getVisibleName(); start = false;}
            tempMiddle.setBatchId(batchId);
            Transaction tx = null;
            try {
              tx = hibSess.beginTransaction();
              hibSess.save(tempMiddle);
              analyser.ProcessFiles(tempMiddle); //new method!!!
              tx.commit();
              vsm.changeSampleTotal(1);
              currentMiddle = tempMiddle;
            }
            catch (Exception e) {
              if (tx != null) tx.rollback();
              throw e;
            }
          }
        }
        hibSess.close(); //needs before forward
        resetTransactionObjects();
        return rezult;
      }

      public int importBatchBottom() throws Exception {
        int rezult = 0;
        boolean start = true; String batchId = null;
        if (currentUser == null) return 1;
//        Persistent[]defVT = getBatchVocabularyDefaults(2);
        BatchAnalyser analyser = getBatchAnalyser();
        analyser.startIterator();
        while (analyser.hasNextElement()){
          tempBottom = new Bottom();
          tempBottom.setCreateInfo(currentUser);
          tempBottom.setTechnology(currentTechnology);  
          analyser.nextElement(tempBottom);
          if (isInvalidField()) rezult = 2; else {
            if (start){ batchId = tempBottom.getVisibleName(); start = false;}
            tempBottom.setBatchId(batchId);
            Transaction tx = null;
            try {
              tx = hibSess.beginTransaction();
              hibSess.save(tempBottom);
              analyser.ProcessFiles(tempBottom); //new method!!!
              tx.commit();
              vam.changeAliquotTotal(1);
              currentBottom = tempBottom;
            }
            catch (Exception e) {
              if (tx != null) tx.rollback();
              throw e;
            }
          }
        }
        hibSess.close(); //needs before forward
        resetTransactionObjects();
        return rezult;
      }
}
