package molpage.com;

import java.util.Date;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.text.DateFormat;
import java.io.File;
import java.io.IOException;
import java.io.FileWriter;
import java.security.NoSuchAlgorithmException;
import java.security.MessageDigest;
import java.io.FileOutputStream;
import java.io.FileInputStream;

public final class Util {

  public static void copyFile( File in, File out){
    int len;
    byte[] buffer = new byte[1024];
    try {
 /*     Util.writeLog("---Copy from:",
                    in.getAbsolutePath(),
                    "----");
      Util.writeLog("---Copy to:",
                    out.getAbsolutePath(),
                    "----");*/
      FileInputStream fin = new FileInputStream( in);
      FileOutputStream fout = new FileOutputStream( out);
      while ((len = fin.read(buffer)) >= 0)
         fout.write(buffer, 0, len);
      fin.close();
      fout.close();
    }
    catch (IOException ex) {}
  }

  public static String[] makeArrayFromString( String in){
    if (in==null)return null;
    int k = 0;
    int to = in.indexOf(',');
    while (to > 0){   //xxx,xxx,xxx,....
      k++; to++;
      to = in.indexOf(',', to);
    }
    if (k==0) return null;
    String[] array = new String[k];
    int from = 0; to = in.indexOf(','); k = 0;
    while (to > 0){   //xxx,xxx,xxx,....
      array[k++] = in.substring(from, to);
      from = to + 1;
      to = in.indexOf(',', from);
    }
    return array;
  }
  public static String getParameterName0( String name, int inpDate){
    DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
    snf.applyPattern(name+"0");
    return snf.format(inpDate);
  }
    public static String truncateTime( Date inpDate){
       if (inpDate != null) {
           SimpleDateFormat sdf = (SimpleDateFormat)DateFormat.getDateTimeInstance();
           sdf.applyPattern("yyyy-MMM-dd HH:mm:ss");
//       SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MMM-dd HH:mm");
           return sdf.format(inpDate);
       }
    return "&nbsp;";
    }

    public static String getYear( Date date){
         Calendar myCal = Calendar.getInstance();
         myCal.setTime( date);
         return String.valueOf(myCal.get(Calendar.YEAR));
    }
    public static String getMonth( Date date){
         Calendar myCal = Calendar.getInstance();
         myCal.setTime( date);
         return String.valueOf(myCal.get(Calendar.MONTH)+1);
    }
    public static String getDay( Date date){
         Calendar myCal = Calendar.getInstance();
         myCal.setTime( date);
         return String.valueOf(myCal.get(Calendar.DAY_OF_MONTH));
    }
    public static String getHour( Date date){
         Calendar myCal = Calendar.getInstance();
         myCal.setTime( date);
         return String.valueOf(myCal.get(Calendar.HOUR_OF_DAY));
    }
    public static String getMinute( Date date){
         Calendar myCal = Calendar.getInstance();
         myCal.setTime( date);
         return String.valueOf(myCal.get(Calendar.MINUTE));
    }

    public static String getDateString( Date value, int attribute1) {
      if (value!=null)
        try {
          SimpleDateFormat sdf = (SimpleDateFormat)DateFormat.getDateTimeInstance();
          if (attribute1 < 2)
            sdf.applyPattern("yyyy");
          else
          if (attribute1 < 3)
            sdf.applyPattern("yyyy-MMM-dd");
          else
            sdf.applyPattern("yyyy-MMM-dd HH:mm");
          return sdf.format(value);
        }
        catch (Exception ex) {
        }
      return "";
    }
    public static String getDateStringForExport( Date value, int attribute1) {
      if (value!=null)
        try {
          SimpleDateFormat sdf = (SimpleDateFormat)DateFormat.getDateTimeInstance();
          if (attribute1 < 2)
            sdf.applyPattern("yyyy");
          else
          if (attribute1 < 3)
            sdf.applyPattern("yyyy-MM-dd");
          else
            sdf.applyPattern("yyyy-MM-dd HH:mm");
          return sdf.format(value);
        }
        catch (Exception ex) {
        }
      return "";
    }

   public static String truncateString( String inpStr){
     if (inpStr != null) {
         int l = inpStr.length();
         if (l > 21)return inpStr.substring(0, 18) + "...";
         else
         if (l > 0)return inpStr;
     }
     return "&nbsp;";
   }

   public static String truncateDate( Date inpDate){
      if (inpDate != null) {
          SimpleDateFormat sdf = (SimpleDateFormat)DateFormat.getDateInstance();
          sdf.applyPattern("yyyy-MMM-dd");
//          SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MMM-dd");
          return sdf.format(inpDate);
      }
      return "&nbsp;";
   }

   public static int getInt( String number){
       int myInteger = 0;
       try {
           myInteger = Integer.parseInt(number);
       } catch (Exception ex) {
       }
       return myInteger ;
   }
   public static int getIntegerValue( String number){
       int myInteger = 0;
       if (number!=null)
       try {
           myInteger = Integer.parseInt(number);
       } catch (Exception ex) {
       }
       return myInteger ;
   }

   public static long getLongValue( String number){
       long myLong = 0;
       if (number!=null)
       try {
           myLong = Long.parseLong(number);
       } catch (Exception ex) {
       }
       return myLong ;
   }

   public static boolean checkFloatValue(String value) {
     boolean result = true;
     try {
       if (!value.trim().equals("")) {
         /*double xx =*/ Double.parseDouble(value);
       }
     }
     catch (Exception ex) {
       result = false;
     }
     return result;
   }

   public static boolean checkIntegerValue(String value) {
     boolean result = true;
     try {
       if (!value.trim().equals("")) {
         /*double xx =*/ Integer.parseInt(value);
       }
     }
     catch (Exception ex) {
       result = false;
     }
     return result;
   }

   public static boolean checkBooleanValue(String value) {
     return value.equals("0")||value.equals("1");
   }
/*
   public static String checkDateTimeValue( String value, int attribute1) {
     StringBuffer xyz = new StringBuffer();
     SimpleDateFormat sdf = (SimpleDateFormat)DateFormat.getDateTimeInstance();
     if (attribute1 < 2)
       sdf.applyPattern("yyyy");
     else
       if (attribute1 < 3)
         sdf.applyPattern("yyyy-MM-dd");
       else
         sdf.applyPattern("yyyy-MM-dd HH:mm");
     try {
       Date myDate = sdf.parse(value);
       Calendar myCal = Calendar.getInstance();
       myCal.setTime(myDate);
       xyz.append(myCal.get(Calendar.YEAR));
       if (attribute1 > 1)
         xyz.append(',')
            .append(myCal.get(Calendar.MONTH)+1)
            .append(',')
            .append(myCal.get(Calendar.DAY_OF_MONTH));
       if (attribute1 > 2)
         xyz.append(',')
           .append(myCal.get(Calendar.HOUR_OF_DAY))
           .append(',')
           .append(myCal.get(Calendar.MINUTE));
       xyz.append(',');
       return xyz.toString();
     }
     catch (Exception ex) {
     }
     return null;
   }
*/
  public static boolean checkDateTimeValue( String value, int attribute1) {
    boolean xyz = false;
    SimpleDateFormat sdf = (SimpleDateFormat)DateFormat.getDateTimeInstance();
    if (attribute1 < 2)
      sdf.applyPattern("yyyy");
    else
      if (attribute1 < 3)
        sdf.applyPattern("yyyy-MM-dd");
      else
        sdf.applyPattern("yyyy-MM-dd HH:mm");
    try {
      Date myDate = sdf.parse(value);
      xyz = true;
    }
    catch (Exception ex) {
    }
    return xyz;
  }
  public static Date getDateTimeValue( String value, int attribute1) {
     Date myDate = null;
     SimpleDateFormat sdf = (SimpleDateFormat)DateFormat.getDateTimeInstance();
     if (attribute1 < 2)
       sdf.applyPattern("yyyy");
     else
       if (attribute1 < 3)
         sdf.applyPattern("yyyy-MM-dd");
       else
         sdf.applyPattern("yyyy-MM-dd HH:mm");
     try {
       myDate = sdf.parse(value);
     }
     catch (Exception ex) {
     }
     return myDate;
   }

   public static String checkTimeValue( String value, int attribute1) {
     StringBuffer xyz = new StringBuffer();
     int m = attribute1; int k = 0; int l;
     try {
       if (m >= 4){
         l = value.indexOf(',', k);
         if (l > k) {
           Integer.parseInt(value.substring(k, l));
           xyz.append(value.substring(k, l));
         }
         if (l >= 0) k = l + 1;
         m -= 4;
       }
       xyz.append(',');
       if (m >= 2){
         l = value.indexOf(',', k);
         if (l > k) {
           Integer.parseInt(value.substring(k, l));
           xyz.append(value.substring(k, l));
         }
         if (l >= 0) k = l + 1;
         m -= 2;
       }
       xyz.append(',');
       if (m >= 1){
         l = value.indexOf(',', k);
         if (l > k) {
           Integer.parseInt(value.substring(k, l));
           xyz.append(value.substring(k, l));
         }
       }
       xyz.append(',');
       return xyz.toString();
     }
     catch (Exception ex) {
     }
     return null;
   }



   public static Integer getInteger0( String number){
       Integer myInteger ;
       try {
           myInteger = new Integer( number);
       } catch (Exception ex) {
           myInteger = new Integer( 0);
       }
       return myInteger ;
   }

   public static Integer getInteger( String number){
       Integer myInteger = null;
       if (number!=null && !number.trim().equals(""))
       try {
           myInteger = new Integer( number);
       } catch (Exception ex) {
           myInteger = new Integer( 0);
       }
       return myInteger ;
   }

   public static Long getLong( String number){
       Long myLong;
       try {
           myLong = new Long( number);
       } catch (Exception ex) {
           myLong = new Long( 0);
       }
       return myLong ;
   }

   public static Double getFloat( String number){
       Double myDouble = null;
       if (number!=null && !number.trim().equals(""))
       try {
           myDouble = new Double( Double.parseDouble(number));
       } catch (Exception ex) {
       }
       return myDouble ;
   }

   public static Double getNumber( String number){
       Double myDouble = null;
       if (number!=null && !number.trim().equals(""))
       try {
           myDouble = new Double( Double.parseDouble(number));
       } catch (Exception ex) {
       }
       return myDouble ;
   }

   public static Double getNumber( String v1, String v2){
          Double myDouble = null;
          if (!v1.trim().equals("")||!v2.trim().equals(""))
          try {
              String s1 = (v1.equals(""))?"0":v1;
              String s2 = (v2.equals(""))?"0":v2;
              String s12 = s1+"."+s2;
              myDouble = new Double( Double.parseDouble(s12));
          } catch (Exception ex) {
          }
          return myDouble ;
   }

   public static String getNumberString( int number){
       Integer myInteger = new Integer( number);
       return myInteger.toString() ;
   }

   public static String getIntegerPart ( Double d){
        if (d==null) return "";
        String s11 = d.toString();
        int i = s11.indexOf('.');
        return (i<0)?s11:
               (i==0)?"0":s11.substring(0,i);
   }

   public static String getFractionPart ( Double d){
       if (d==null) return "";
       String s11 = d.toString();
       int i = s11.indexOf('.');
       return (i<0)?"0":s11.substring(i+1);
   }

   public static int getNumberFromStringPostfix( String str){
       int visitCount = 0;
       int fact = 1;
       for (int i = str.length(); i > 0; ) {
           char ch = str.charAt(--i);
           if (!Character.isUpperCase( ch))break;
           visitCount += (ch - ('A' -1))*fact;
           fact *= 26;
       }
       return visitCount;
   }

   public static String getStringPostfixFromNumber( int num){
       String s = "";
       int darb = num;
       do {
           int darb1 = darb % 26;
           darb /= 26;
           if (darb1==0){ darb1 = 26; darb--;}
           s = ((char) (('A' - 1) + darb1)) + s;
       }
       while (darb > 0);
       return s;
   }

   public static String getHTMLString( String inpStr){
     if (inpStr != null) {
       int l = inpStr.length();
       if (l > 0) {
         StringBuffer xyz = new StringBuffer();
         for (int i = 0; i < l; i++) {
           char c = inpStr.charAt(i);
           switch (c) {
             case '<': xyz.append("&lt;"); break;
             case '>': xyz.append("&gt;"); break;
             case '"': xyz.append("&quot;"); break;
             case '&': xyz.append("&amp;"); break;
             default: xyz.append(c);
           }
         }
         return xyz.toString();
       }
     }
     return "";
   }

   public static String truncateHTMLString( String inpStr){
     if (inpStr != null) {
         int l = inpStr.length();
         if (l > 0){
           int l1 = (l < 22)?l:18;
           StringBuffer xyz = new StringBuffer();
           for (int i = 0; i < l1; i++){
             char c = inpStr.charAt(i);
             switch(c){
               case '<': xyz.append("&lt;"); break;
               case '>': xyz.append("&gt;"); break;
               case '"': xyz.append("&quot;"); break;
               case '&': xyz.append("&amp;"); break;
               default : xyz.append(c);
             }
           }
           if (l>21)xyz.append("...");
           return xyz.toString();
         }
     }
     return "";
   }
//----------------------------------------------------------//
// cript
//----------------------------------------------------------//
   public static String criptString( String pswd){
       StringBuffer xyz = new StringBuffer();
       try {
         byte inarray[] = pswd.getBytes();
         MessageDigest md5 = MessageDigest.getInstance("MD5");
         md5.reset();
         md5.update(inarray,0,inarray.length);
         byte outarray[] = md5.digest();
         for (int i=0; i<outarray.length; i++) xyz.append( outarray[i]);
       } catch (NoSuchAlgorithmException ex) {}
      return xyz.toString();
    }
//----------------------------------------------------------//
//----------------------------------------------------------//
   private static File logFile = null;
   private static File accessLogFile = null;
   private static void writeString(String string){
     boolean append = true;
     if (logFile!=null)
     try {
       FileWriter fos = new FileWriter(logFile, append);
       fos.write(string);
       fos.write("\r\n");
       fos.close();
     }
     catch (IOException ex) {
     }
   }
   private static void writeAccessString(String string){
     boolean append = true;
     if (accessLogFile!=null){
       try {
         FileWriter fos = new FileWriter(accessLogFile, append);
         fos.write(string);
         fos.write("\r\n");
         fos.close();
       }
       catch (IOException ex) {
       }
     }
   }

   public static void initializeLog( File logDirectory){
     long MAX_SIZE = 100000;
     logFile = new File( logDirectory, "samples.log");
     long l = logFile.length();
     if (l > MAX_SIZE){
       String[] files = logDirectory.list();
       int n = 0;
       for (int i=0; i<files.length; i++){
         int j = files[i].indexOf('_');
         if (j<0) continue;
         int k = files[i].indexOf('.');
         if (k<0) continue;
         if (files[i].substring(j+1,k).equals("access")) continue;
         int m = getInt(files[i].substring(j+1,k));
         if (m>n) n=m;
       }
       n++;
       String newName ="samples_"+n+".log";
       File permFile = new File( logDirectory, newName);
       logFile.renameTo(permFile);
     }
     accessLogFile = new File( logDirectory, "samples_access.log");
     l = accessLogFile.length();
     if (l > MAX_SIZE){
       String[] files = logDirectory.list();
       int n = 0;
       for (int i=0; i<files.length; i++){
         int j = files[i].indexOf('_');
         if (j<0) continue;
         int k = files[i].indexOf('.');
         if (k<0) continue;
         if (files[i].substring(j+1,k).equals("samples")) continue;
         int m = getInt(files[i].substring(j+1,k));
         if (m>n) n=m;
       }
       n++;
       String newName ="samplesaccess_"+n+".log";
       File permFile = new File( logDirectory, newName);
       accessLogFile.renameTo(permFile);
     }
     StringBuffer strBuf = new StringBuffer();
     strBuf.append(truncateTime(new Date()))
           .append('\t')
           .append("Start of application")
           .append("(log size=")
           .append(l)
           .append(')');
     writeAccessString(strBuf.toString());
   }

   public static synchronized void writeLog( String fullName,
                               String logName, String sessId){
     StringBuffer strBuf = new StringBuffer();
     strBuf.append(truncateTime(new Date()))
           .append('\t')
           .append(fullName)
           .append('\t')
           .append(logName)
           .append('\t')
           .append(sessId);
     writeString(strBuf.toString());
   }
   public static synchronized void writeAccessLog( String fullName,
                               String logName, String sessId){
     StringBuffer strBuf = new StringBuffer();
     strBuf.append(truncateTime(new Date()))
           .append('\t')
           .append(fullName)
           .append('\t')
           .append(logName)
           .append('\t')
           .append(sessId);
     writeAccessString(strBuf.toString());
     writeString(strBuf.toString());
   }
   public static synchronized void writeEndOfApplication(){
     StringBuffer strBuf = new StringBuffer();
     strBuf.append(truncateTime(new Date()))
           .append('\t')
           .append("End of application");
     writeAccessString(strBuf.toString());
   }
//----------------------------------------------------------//
//----------------------------------------------------------//
}
