package molpage.com;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import sims.hibernate.*;

public final class ViewBatchManager {
  private UserHttpSess userSession;
  private int total;
  private HashSet<Long> batch;
  private boolean checked;
  private int level;    //2-assay; 1-study; 0-view;  3-study for view define
  private int cause;    //1-edit;  2-export;3-define view 
  public ViewBatchManager( UserHttpSess tmpHttpSessObj, int count, int level, int cause) {
	total = count;
	userSession = tmpHttpSessObj;
	batch = new HashSet<Long>( count);
	checked = true;
	this.level = level;
	this.cause = cause;
  }
  
  public void checkAll() {
	checked = false;
	batch.clear();
	
    List objList = null;	
	try{	
	  if (level==2){
        ViewAliquotManager vam = userSession.getViewAliquotManager();
        Long samplId = vam.getSampleId();
        Long persId = vam.getPersonId();
        objList = userSession.getAllAliquots( persId, samplId, -1) ;
      } else
      if (level==1){	
        ViewSampleManager vsm = userSession.getViewSampleManager();
        Long persId = vsm.getPersonId();
        objList = userSession.getAllSamples( persId, -1) ;
      } else
      if (level==0){
        objList = userSession.getAllPersons( -1) ;
      } 
	  Iterator liter = objList.iterator();
      if (level==2)
		while (liter.hasNext()){
		  Bottom aliquot = (Bottom)liter.next();
          int myRights = userSession.getGrantedRights( aliquot.getParent().getParent());
	      Long objId = aliquot.getId();
//          if (myRights < 1000) batch.add(objId);
		  if ((cause==1&myRights<3000)|(cause==2&myRights<1000)) batch.add(objId);
		}
        else
        if (level==1)	
   		while (liter.hasNext()){
  		  Middle sampl = (Middle)liter.next();
          int myRights = userSession.getGrantedRights( sampl.getParent());
    	  Long objId = sampl.getId();
//          if (myRights < 1000) batch.add(objId);
    	  if ((cause==1&myRights<3000)|(cause==2&myRights<1000)) batch.add(objId);
    	}
        else
        if (level==0)	
       	while (liter.hasNext()){
      	  Top pers = (Top)liter.next();
          int myRights = userSession.getGrantedRights( pers);
       	  Long objId = pers.getId();
//          if (myRights < 3000) batch.add(objId);
       	  if ((cause==1&myRights<3000)|(cause==2&myRights<1000)) batch.add(objId);
       	}
      }
      catch (Exception ex)
      {
      }
  }
  public void uncheckAll() {
	checked = true;
	batch.clear();
  }
  public void changeCheck( Long objId){
    if (!batch.add(objId))batch.remove(objId);	
  }
  public int getSelectedCount(){
	int size = batch.size();
	return (checked)?size:total-size;
  }
  public boolean isSelected( Long objId){
	return (checked)?batch.contains(objId):!batch.contains(objId);
  }
  public Long[] getBatchArray(){
	int size = getSelectedCount();
	if (size < 1) return null;
	Long[] barray = new Long[size];
    int ind = 0;
	if (checked){
	  Iterator<Long> biter = batch.iterator();
	  while (biter.hasNext()){
		barray[ind++] = biter.next();  
	  }
	} else{
	  List objList = null;	
	  try{	
	    if (level==2){
          ViewAliquotManager vam = userSession.getViewAliquotManager();
          Long samplId = vam.getSampleId();
          Long persId = vam.getPersonId();
          objList = userSession.getAllAliquots( persId, samplId, -1) ;
        } else
        if (level==1){	
          ViewSampleManager vsm = userSession.getViewSampleManager();
          Long persId = vsm.getPersonId();
          objList = userSession.getAllSamples( persId, -1) ;
        } else
        if (level==0){
          objList = userSession.getAllPersons( -1) ;
        } 
		Iterator liter = objList.iterator();
		while (liter.hasNext()){
		  SimsData xyz = (SimsData)liter.next();
		  Long objId = xyz.getId();
		  if (!batch.contains(objId)) barray[ind++] = objId;
		}
      }
      catch (Exception ex)
      {
          return null;
      }
	}
	return barray;
  }
}
