package molpage.com;

public final class ViewSampleManager {

      private UserHttpSess parent;
      private int total;
      private int first;
      private int step;
      private Long personId;
      private int sampleCount;

      public ViewSampleManager(UserHttpSess tmpHttpSessObj) {
        parent = tmpHttpSessObj;
        step = 0;
        total = -1;
        first = 0;
        personId = null;
      }

      public void clearValues() {
        total = -1;
        first = 0;
        step = parent.getViewLimit();
        personId = null;
      }

      public int getSampleTotal() throws Exception {
        if ((step > 0) && (total < 0))
          total = parent.getAllSamplesCount( personId);
        return total;
      }

      public void changeSampleTotal( int diff) {
        total += diff;
      }

      public void setSampleCount( int val) {
        sampleCount = val;
        if (total < sampleCount) total = sampleCount;
      }

      public boolean hasSamplePrevious() {
        return (step > 0) && (first > 0);
      }

      public void setSamplePrevious() {
        first -= step;
        if (first < 0) first = 0;
      }

      public boolean hasSampleNext() {
        return (step > 0) && (first + step < total - 1);
      }

      public void setSampleNext() {
        first += step;
        if (first >= total) setSamplePrevious();
      }

      public void setSampleFirst() {
        first = 0;
      }

      public void setSampleLast() {
        first = total - step;
        if (first < 0) first = 0;
      }

      public int getSampleStep() {
        return step;
      }

      public int getSampleCurrent() {
        return first;
      }

      public void setPersonIdDown(Long newPersonId) {
        boolean change = false;
        if (newPersonId == null) {
          if (personId != null) change = true;
        }
        else
        if (!newPersonId.equals(personId)) change = true;
        if (change){
          total = -1;
          first = 0;
          personId = newPersonId;
          ViewAliquotManager vam = parent.getViewAliquotManager();
          vam.setPersonAndSampleIdDown( personId, null);
        }
      }

      public void setPersonIdUp(Long newPersonId) {
        boolean change = false;
        if (newPersonId == null) {
          if (personId != null) change = true;
        }
        else
        if (!newPersonId.equals(personId)) change = true;
        if (change){
          total = -1;
          first = 0;
          personId = newPersonId;
        }
      }

      public Long getPersonId() {
        return personId;
      }

      public String getSampleControlString(boolean down) {
        StringBuffer xyz = new StringBuffer();
        xyz.append("&nbsp;");
        if (total>0){
      	  if (down) xyz.append(
    "<a href='javascript:jumpFocus(\"bottomLine\")'><img border='0' src='./images/down_d_10_b.gif' title='bottom of page' alt=''></a>"
          ); else xyz.append(	
    "<a href='javascript:scrollTo(0,0)'><img border='0' src='./images/up_d_10_b.gif' title='top of page' alt=''></a>"
          );xyz.append("&nbsp;");
        }
        if ((step > 0) && (total > step)) {
          if (first > 0){
            xyz.append("<button type='button' onclick='gotoFirst()' title='first' class='lines'>")
                .append("<img border='0' src='./images/left_d_10_b.gif' title='first' alt=''>")
                .append("</button>");
            xyz.append("<button type='button' onclick='gotoPrevious()' title='previous' class='lines'>")
                .append("<img border='0' src='./images/left_10_b.gif' title='previous' alt=''>")
                .append("</button>");
          }
         else{
           xyz.append("<button type='button' disabled class='lines'>")
               .append("<img border='0' src='./images/left_d_10_h.gif' alt=''>")
               .append("</button>");
           xyz.append("<button type='button' disabled class='lines'>")
               .append("<img border='0' src='./images/left_10_h.gif' alt=''>")
               .append("</button>");
         }
          xyz.append(first+1)
             .append('-')
             .append(first+sampleCount)
             .append("&nbsp;of&nbsp;")
             .append(total)
             .append("&nbsp;items&nbsp;");
           if (first + sampleCount < total){
             xyz.append("<button type='button' onclick='gotoNext()' title='next' class='lines'>")
                 .append("<img border='0' src='./images/right_10_b.gif' title='next' alt=''>")
                 .append("</button>");
             xyz.append("<button type='button' onclick='gotoLast()' title='last' class='lines'>")
                 .append("<img border='0' src='./images/right_d_10_b.gif' title='last' alt=''>")
                 .append("</button>");
           }
          else{
            xyz.append("<button type='button' disabled class='lines'>")
                .append("<img border='0' src='./images/right_10_h.gif' alt=''>")
                .append("</button>");
            xyz.append("<button type='button' disabled class='lines'>")
                .append("<img border='0' src='./images/right_d_10_h.gif' alt=''>")
                .append("</button>");
          }
        }
        else
          xyz.append(total)
             .append("&nbsp;items&nbsp;");
        return xyz.toString();
      }

}
