package molpage.com;

import java.io.File;
import java.util.zip.ZipInputStream;
import java.util.zip.GZIPInputStream;
import java.io.*;
import java.util.HashMap;
import java.util.zip.ZipEntry;
import com.ice.tar.*;

public class ZipProcessor {
  private HashMap<String,Integer> entries = null;
  public ZipProcessor (File myFile, int zipType){
    int num = 0;
    entries = new HashMap<String,Integer>();
    if (zipType==1){
      ZipInputStream zipinpstr = null;
      try {
        zipinpstr = new ZipInputStream(new FileInputStream(myFile));
        if (zipinpstr!= null){
          ZipEntry entry;
          while ( (entry = zipinpstr.getNextEntry()) != null) {
            entries.put(entry.getName(), new Integer(++num));
            zipinpstr.closeEntry();
          }
          zipinpstr.close();
        }  
      }
      catch (IOException ex) {
          Util.writeLog("fastInputZipfile", ex.getMessage(), "");
      }
    }
    else
    if (zipType==2){
      FastTarStream tarinpstr = null;
      try {
        GZIPInputStream gzipinpstr = new GZIPInputStream(new FileInputStream(myFile));
        tarinpstr = new FastTarStream( gzipinpstr);
        if (tarinpstr!= null){
  	    TarEntry entry;
          while ( (entry = tarinpstr.getNextEntry()) != null) {
            entries.put(entry.getName(), new Integer(++num));
//	          zipinpstr.closeEntry();
          }
//	        zipinpstr.close();
        }
      }  
      catch (IOException ex) {
          Util.writeLog("fastInputGZipfile", ex.getMessage(), "");
      }
    }
  }  

  public static boolean expandGZipFile( File inputFile, File outputFile){
    boolean result = false;
    int len, bufSize = 8192;
    byte buffer[] = new byte[bufSize];
    try {
      GZIPInputStream gzipinpstr = new GZIPInputStream(new FileInputStream(inputFile));
      FileOutputStream outstr = new FileOutputStream(outputFile);
      while ((len = gzipinpstr.read(buffer)) >= 0)
    	  outstr.write(buffer, 0, len);
      gzipinpstr.close();
      outstr.close();
      result = true;	
    }
    catch (Exception ex) {
      Util.writeLog("expandGZipfile", ex.getMessage(), "");
    }
	return result;  
  }
  
  public static boolean getFile( File myFile, String inputFile, File outputFile, int zipType){
    boolean result = false;
    int l, bufSize = 8192;
    byte buffer[] = new byte[bufSize];
    if (zipType==2)
    try {
      TarEntry entry;
      TarInputStream inpstr = new TarInputStream(new FileInputStream(myFile));
      while ( (entry = inpstr.getNextEntry()) != null){
        if (entry.getName().equals(inputFile)){
          FileOutputStream fos = new FileOutputStream( outputFile);
          l = inpstr.read(buffer, 0, bufSize);
          while (l > 0){
            fos.write(buffer, 0, l);
            l = inpstr.read(buffer, 0, bufSize);
          }
          fos.close();
//          inpstr.closeEntry();
          result = true;
          break;
        }
      }
      inpstr.close();
    }
    catch (IOException ex1) {
    }
    else
    try {
      ZipEntry entry;
      ZipInputStream zipinpstr = new ZipInputStream(new FileInputStream(myFile));
      while ( (entry = zipinpstr.getNextEntry()) != null){
        if (!entry.getName().equals(inputFile))
          zipinpstr.closeEntry();
        else {
          FileOutputStream fos = new FileOutputStream( outputFile);
          l = zipinpstr.read(buffer, 0, bufSize);
          while (l > 0){
            fos.write(buffer, 0, l);
            l = zipinpstr.read(buffer, 0, bufSize);
          }
          fos.close();
          zipinpstr.closeEntry();
          result = true;
          break;
        }
      }
      zipinpstr.close();
    }
    catch (IOException ex1) {
    }
    return result;
  }

  public Integer existsFile(String fileName){
    return (Integer)entries.get(fileName);
  }

  public void closeFile(){
  }
}
