package sims.hibernate;

public abstract class MetaData extends Persistent {
    private String shortName;
    private String longName;
    private String uploadName;
    private Integer viewColumnNumber;
    private Integer sortableX;
    private Integer editableX;
    private Integer isRequiredX;
    private Integer positionInFilter;
    private int valueRowNumber;
    private byte actualColumnNumber;

    public String getShortName() {
        return shortName;
    }

    public String getLongName() {
        return longName;
    }

    public String getUploadName() {
        return uploadName;
    }

    public String getUploadNameCom() {
        int rowNum = Fieldname.getRowNumber( getVisibleName()); 
        return (rowNum>=0)?VocabulName.getUploadName(rowNum):uploadName;
   }
    public boolean isRequiredCom() {
        int rowNum = Fieldname.getRowNumber( getVisibleName()); 
        if (rowNum>=0){
          String xyz = VocabulName.getUploadName(rowNum);
          if (xyz== null || xyz.equals("")) return false;
        }  
        return isRequiredX != null && isRequiredX.byteValue() > 0;
   }
   public Integer getViewColumnNumber() {
        return viewColumnNumber;
    }

    public byte getActualColumnNumber() {
        return actualColumnNumber;
    }

    public int getValueRowNumber() {
        return valueRowNumber;
    }

    public Integer getSortableX() {
        return sortableX;
    }

    public Integer getEditableX() {
        return editableX;
    }

    public Integer getIsRequiredX() {
        return isRequiredX;
    }
    public Integer getPositionInFilter() {
        return positionInFilter;
   }
    public Integer getVisiblePositionInFilter() {
        return (positionInFilter==null)?new Integer(0):positionInFilter;
   }
    public Integer getPositionInFilterCom() {
        int rowNum = Fieldname.getRowNumber( getVisibleName()); 
        return (rowNum>=0||positionInFilter==null)?new Integer(0):positionInFilter;
   }

    public boolean isSortable() {
            return sortableX != null && sortableX.byteValue() > 0;
    }

    public boolean isEditable() {
            return editableX != null && editableX.byteValue() > 0;
    }

    public boolean isRequired() {
            return isRequiredX != null && isRequiredX.byteValue() > 0;
    }

    public void setShortName(String val) {
            shortName = val;
    }

    public void setLongName(String val) {
            longName = val;
    }

    public void setUploadName(String val) {
            uploadName = val;
    }

    public void setViewColumnNumber(Integer cNumber) {
            viewColumnNumber = cNumber;
    }

    public void setActualColumnNumber(byte val) {
            actualColumnNumber = val;
    }

    public void setValueRowNumber(int cNumber) {
            valueRowNumber = cNumber;
    }

    public void setSortableX(Integer sortab) {
            sortableX = sortab;
    }

    public void setEditableX(Integer editab) {
            editableX = editab;
    }

    public void setIsRequiredX(Integer show) {
            isRequiredX = show;
    }
    public void setPositionInFilter(Integer val) {
        positionInFilter = val;
   }

}

