package sims.hibernate;

import java.util.*;
import java.lang.reflect.Field;
import javax.servlet.http.HttpServletRequest;
public final class MetadataManager   implements Comparator<TempMetaData>{

    private HashMap<String,TempMetaData> aliquotData = null;
    private HashMap<String,TempMetaData> sampleData = null;
    private HashMap<String,TempMetaData> personData = null;
    private int aliquotViewSize = 0;
    private int sampleViewSize = 0;
    private int personViewSize = 0;

/*
    private void buildCommonData( int level, HashMap<String,TempMetaData> dataMap){
    	TempMetaData meta;
        meta = new TempMetaData( level, Fieldname.VISIBLENAME, VocabulName.getUploadName(Fieldname.VISIBLENAMEnum));
        meta.setValueRowNumber( Fieldname.VISIBLENAMEnum);
        dataMap.put( Fieldname.VISIBLENAME, meta);
        meta = new TempMetaData( level, Fieldname.COMMENT, VocabulName.getUploadName(Fieldname.COMMENTnum));
        meta.setValueRowNumber( Fieldname.COMMENTnum);
        dataMap.put( Fieldname.COMMENT, meta);
        meta = new TempMetaData( level, Fieldname.CREATOR, VocabulName.getUploadName(Fieldname.CREATORnum));
        dataMap.put( Fieldname.CREATOR, meta);
        meta = new TempMetaData( level, Fieldname.CREATEDATE, VocabulName.getUploadName(Fieldname.CREATEDATEnum));
        dataMap.put( Fieldname.CREATEDATE, meta);
        meta = new TempMetaData( level, Fieldname.MODIFIER, VocabulName.getUploadName(Fieldname.MODIFIERnum));
        dataMap.put( Fieldname.MODIFIER, meta);
        meta = new TempMetaData( level, Fieldname.MODIFDATE, VocabulName.getUploadName(Fieldname.MODIFDATEnum));
        dataMap.put( Fieldname.MODIFDATE, meta);
        meta = new TempMetaData( level, Fieldname.PROTOCOL, VocabulName.getUploadName(Fieldname.PROTOCOLnum));
        meta.setValueRowNumber( Fieldname.PROTOCOLnum);
        dataMap.put( Fieldname.PROTOCOL, meta);
        meta = new TempMetaData( level, Fieldname.PROTOCOLTYPE, VocabulName.getUploadName(Fieldname.PROTOCOLTYPEnum));
        meta.setValueRowNumber( Fieldname.PROTOCOLTYPEnum);
        dataMap.put( Fieldname.PROTOCOLTYPE, meta);
        meta = new TempMetaData( level, Fieldname.DATAFILES, VocabulName.getUploadName(Fieldname.DATAFILESnum));
        meta.setValueRowNumber( Fieldname.DATAFILESnum);
        dataMap.put( Fieldname.DATAFILES, meta);
        meta = new TempMetaData( level, Fieldname.DATAFILESTYPE, VocabulName.getUploadName(Fieldname.DATAFILESTYPEnum));
        meta.setValueRowNumber( Fieldname.DATAFILESTYPEnum);
        dataMap.put( Fieldname.DATAFILESTYPE, meta);
    }
*/    
    public void buildAliquotData( List aliquotMD){
        int viewSize = 0;
        aliquotData = new HashMap<String,TempMetaData>(aliquotMD.size()+20);
//        buildCommonData( 2, aliquotData);
        Iterator iter = aliquotMD.iterator();
        while (iter.hasNext()) {
          MetaData metadata = (MetaData) iter.next();
          String key = metadata.getVisibleName();
          int m = VocabulName.getRowNumberCheck(key, 2);
          if (m==0) m = Fieldname.getRowNumber(key);
          if (m<0) continue;
          TempMetaData meta = aliquotData.get(key);
          if (meta!=null){ continue;
//        	meta.completeData(metadata); 
          } else {
            meta = new TempMetaData( 2, metadata);
            aliquotData.put( key, meta);
          }  
          meta.setValueRowNumber( m);
          int n = metadata.getViewColumnNumber().intValue();
          if (n > viewSize) viewSize = n;
        }
    // normalization of column numbers
        byte target = 0;
        for ( int destin = 1; destin <= viewSize; destin++){
          Iterator miter = aliquotData.values().iterator();
          while (miter.hasNext()) {
            TempMetaData meta = (TempMetaData) miter.next();
            if (meta.getViewColumnNumber() == destin)
              meta.setActualColumnNumber( ++target);
          }
        }
//        aliquotViewSize = target;
        saveBottomColumnNumbers();        
    }

    public void buildSampleData( List sampleMD){
        int viewSize = 0;
        sampleData = new HashMap<String,TempMetaData>(sampleMD.size()+20);
//        buildCommonData( 1, sampleData);
        Iterator iter = sampleMD.iterator();
        while (iter.hasNext()) {
          MetaData metadata = (MetaData) iter.next();
          String key = metadata.getVisibleName();
          int m = VocabulName.getRowNumberCheck(key, 1);
          if (m==0) m = Fieldname.getRowNumber(key);
          if (m<0) continue;
          TempMetaData meta = sampleData.get(key);
          if (meta!=null){ continue;
//          	meta.completeData(metadata); 
          } else {
            meta = new TempMetaData( 1, metadata);
            sampleData.put(key, meta);
          }  
          meta.setValueRowNumber( m);
          int n = metadata.getViewColumnNumber().intValue();
          if (n > viewSize) viewSize = n;
        }
    // normalization of column numbers
        byte target = 0;
        for ( int destin = 1; destin <= viewSize; destin++){
          Iterator miter = sampleData.values().iterator();
          while (miter.hasNext()) {
            TempMetaData meta = (TempMetaData) miter.next();
            if (meta.getViewColumnNumber() == destin)
              meta.setActualColumnNumber(++target);
          }
        }
//        sampleViewSize = target;
        saveMiddleColumnNumbers(); 
      }

    public void buildPersonData( List personMD){
        int viewSize = 0;
        personData = new HashMap<String,TempMetaData>(personMD.size()+20);
//        buildCommonData( 0, personData);
        Iterator iter = personMD.iterator();
        while (iter.hasNext()) {
          MetaData metadata = (MetaData) iter.next();
          String key = metadata.getVisibleName();
          int m = VocabulName.getRowNumberCheck(key, 0);
          if (m==0) m = Fieldname.getRowNumber(key);
          if (m<0) continue;
          TempMetaData meta = personData.get(key);
          if (meta!=null){ continue;
//          	meta.completeData(metadata); 
          } else {
            meta = new TempMetaData( 0, metadata);
            personData.put(key, meta);
          }  
          meta.setValueRowNumber( m);
          int n = metadata.getViewColumnNumber().intValue();
          if (n > viewSize) viewSize = n;
        }
    // normalization of column numbers
        byte target = 0;
        for ( int destin = 1; destin <= viewSize; destin++){
          Iterator miter = personData.values().iterator();
          while (miter.hasNext()) {
            TempMetaData meta = (TempMetaData) miter.next();
            if (meta.getViewColumnNumber() == destin)
              meta.setActualColumnNumber(++target);
          }
        }
//        personViewSize = target;
        saveTopColumnNumbers();
      }

    public String getLongName( int type, String key){
      TempMetaData metadata = null;
      switch (type){
        case 0:metadata = (TempMetaData)personData.get(key); break;
        case 1:metadata = (TempMetaData)sampleData.get(key); break;
        case 2:metadata = (TempMetaData)aliquotData.get(key); break;
      }
      return (metadata!=null)?metadata.getLongName():key;
    }
    public String getAliquotLongName( String key){
        TempMetaData metadata = (TempMetaData)aliquotData.get(key);
        return (metadata!=null)?metadata.getLongName():key;
    }
    public String getSampleLongName( String key){
        TempMetaData metadata = (TempMetaData)sampleData.get(key);
        return (metadata!=null)?metadata.getLongName():key;
    }
    public String getPersonLongName( String key){
        TempMetaData metadata = (TempMetaData)personData.get(key);
        return (metadata!=null)?metadata.getLongName():key;
    }
//for Peter
    public String getPropertyLongName( String sort, String key){
        return (sort.equals(Fieldname.TOP))?getPersonLongName( key):
               (sort.equals(Fieldname.MIDDLE))?getSampleLongName( key):
               (sort.equals(Fieldname.BOTTOM))?getAliquotLongName( key):
               "";
    }
    public String getAliquotShortName( String key){
        TempMetaData metadata = (TempMetaData)aliquotData.get(key);
        return (metadata!=null)?metadata.getShortName():key;
    }
    public String getSampleShortName( String key){
        TempMetaData metadata = (TempMetaData)sampleData.get(key);
        return (metadata!=null)?metadata.getShortName():key;
    }
    public String getPersonShortName( String key){
        TempMetaData metadata = (TempMetaData)personData.get(key);
        return (metadata!=null)?metadata.getShortName():key;
    }
//for upload
    public String getBottomName( String key){
        TempMetaData metadata = (TempMetaData)aliquotData.get(key);
        return (metadata!=null)?metadata.getUploadName():key;
    }
    public String getMiddleName( String key){
        TempMetaData metadata = (TempMetaData)sampleData.get(key);
        return (metadata!=null)?metadata.getUploadName():key;
    }
    public String getTopName( String key){
        TempMetaData metadata = (TempMetaData)personData.get(key);
        return (metadata!=null)?metadata.getUploadName():key;
    }
//for Peter
    public String getPropertyShortName( String sort, String key){
        return (sort.equals(Fieldname.TOP))?getPersonShortName( key):
               (sort.equals(Fieldname.MIDDLE))?getSampleShortName( key):
               (sort.equals(Fieldname.BOTTOM))?getAliquotShortName( key):
               "";
    }
    public boolean getAliquotSortable( String key){
        TempMetaData metadata = (TempMetaData)aliquotData.get(key);
        return (metadata!=null)?metadata.isSortable():false;
    }
    public boolean getSampleSortable( String key){
        TempMetaData metadata = (TempMetaData)sampleData.get(key);
        return (metadata!=null)?metadata.isSortable():false;
    }
    public boolean getPersonSortable( String key){
        TempMetaData metadata = (TempMetaData)personData.get(key);
        return (metadata!=null)?metadata.isSortable():false;
    }
//for Peter
    public boolean getPropertySortable( String sort, String key){
        return (sort.equals(Fieldname.TOP))?getPersonSortable( key):
               (sort.equals(Fieldname.MIDDLE))?getSampleSortable( key):
               (sort.equals(Fieldname.BOTTOM))?getAliquotSortable( key):
               false;
    }
    public int getAliquotViewColumnNumber( String key){
        TempMetaData metadata = (TempMetaData)aliquotData.get(key);
        return (metadata!=null)?metadata.getViewColumnNumber():0;
    }
    public int getSampleViewColumnNumber( String key){
        TempMetaData metadata = (TempMetaData)sampleData.get(key);
        return (metadata!=null)?metadata.getViewColumnNumber():0;
    }
    public int getPersonViewColumnNumber( String key){
        TempMetaData metadata = (TempMetaData)personData.get(key);
        return (metadata!=null)?metadata.getViewColumnNumber():0;
    }
//for Peter
    public int getPropertyViewColumnNumber( String sort, String key){
        return (sort.equals(Fieldname.TOP))?getPersonViewColumnNumber( key):
               (sort.equals(Fieldname.MIDDLE))?getSampleViewColumnNumber( key):
               (sort.equals(Fieldname.BOTTOM))?getAliquotViewColumnNumber( key):
               0;
    }
    public String[] getAliquotKeyArray(){
        String[] keyArray = new String[aliquotViewSize];
        Iterator iter = aliquotData.values().iterator();
        while (iter.hasNext()) {
            TempMetaData metadata = (TempMetaData) iter.next();
            if (metadata.getViewColumnNumber() > 0)
                keyArray[metadata.getViewColumnNumber() - 1]=
                        metadata.getVisibleName();
        }
        return keyArray;
    }

    public byte[] getAliquotIndexArray(){
        byte[] indexArray = new byte[VocabulName.getTotalCount()];
        Iterator iter = aliquotData.values().iterator();
        while (iter.hasNext()) {
            TempMetaData metadata = (TempMetaData) iter.next();
            if (metadata.getViewColumnNumber() > 0)
                indexArray[metadata.getValueRowNumber()]=
                        (byte)metadata.getViewColumnNumber();
        }
        return indexArray;
    }

    public String[] getSampleKeyArray(){
        String[] keyArray = new String[sampleViewSize];
        Iterator iter = sampleData.values().iterator();
        while (iter.hasNext()) {
            TempMetaData metadata = (TempMetaData) iter.next();
            if (metadata.getViewColumnNumber() > 0)
                keyArray[metadata.getViewColumnNumber() - 1]=
                        metadata.getVisibleName();
        }
        return keyArray;
    }

    public byte[] getSampleIndexArray(){
        byte[] indexArray = new byte[VocabulName.getTotalCount()];
        Iterator iter = sampleData.values().iterator();
        while (iter.hasNext()) {
            TempMetaData metadata = (TempMetaData) iter.next();
            if (metadata.getViewColumnNumber() > 0)
                indexArray[metadata.getValueRowNumber()]=
                        (byte)metadata.getViewColumnNumber();
        }
        return indexArray;
    }
    public String[] getPersonKeyArray(){
        String[] keyArray = new String[personViewSize];
        Iterator iter = personData.values().iterator();
        while (iter.hasNext()) {
            TempMetaData metadata = (TempMetaData) iter.next();
            if (metadata.getViewColumnNumber() > 0)
                keyArray[metadata.getViewColumnNumber() - 1]=
                        metadata.getVisibleName();
        }
        return keyArray;
    }

    public byte[] getPersonIndexArray(){
        byte[] indexArray = new byte[VocabulName.getTotalCount()];
        Iterator iter = personData.values().iterator();
        while (iter.hasNext()) {
            TempMetaData metadata = (TempMetaData) iter.next();
            if (metadata.getViewColumnNumber() > 0)
                indexArray[metadata.getValueRowNumber()]=
                        (byte)metadata.getViewColumnNumber();
        }
        return indexArray;
    }

    public boolean hasField( int type, String key){
      switch (type){
        case 0: return personData.containsKey(key);
        case 1: return sampleData.containsKey(key);
        case 2: return aliquotData.containsKey(key);
      }
      return false;
    }
    public boolean isRequired( int type, String key){
        TempMetaData xyz = null;
    	switch (type){
          case 0: xyz = personData.get(key); break;
          case 1: xyz = sampleData.get(key); break;
          case 2: xyz = aliquotData.get(key); break;
        }
        return (xyz!=null)?xyz.isRequired():false;
      }
    public boolean hasBottomField( String key){
    	TempMetaData xyz = aliquotData.get(key);
        return xyz!=null && xyz.isUserDef();
    }
    public boolean hasMiddleField( String key){
    	TempMetaData xyz = sampleData.get(key);
        return xyz!=null && xyz.isUserDef();
    }
    public boolean hasTopField( String key){
    	TempMetaData xyz = personData.get(key);
        return xyz!=null && xyz.isUserDef();
    }
//for Peter's view/export
    public TempMetaData getAliquotMetaData( String key){
        return (TempMetaData)aliquotData.get(key);
    }
    public TempMetaData getSampleMetaData( String key){
        return (TempMetaData)sampleData.get(key);
    }
    public TempMetaData getPersonMetaData( String key){
        return (TempMetaData)personData.get(key);
    }


    public Collection<TempMetaData> getAliquotMetaData(){
        return aliquotData.values();
    }
    public Collection<TempMetaData> getSampleMetaData(){
        return sampleData.values();
    }
    public Collection<TempMetaData> getPersonMetaData(){
        return personData.values();
    }
    public List getAliquotMetaDataForFilter(){
        ArrayList<TempMetaData> dataList = new ArrayList<TempMetaData>(aliquotData.values());
        orderMetaDataForFilter(dataList);
        return dataList;
    }
    public List getSampleMetaDataForFilter(){
        ArrayList<TempMetaData> dataList = new ArrayList<TempMetaData>(sampleData.values());
        orderMetaDataForFilter(dataList);
        return dataList;
    }
    public List getPersonMetaDataForFilter(){
        ArrayList<TempMetaData> dataList = new ArrayList<TempMetaData>(personData.values());
        orderMetaDataForFilter(dataList);
        return dataList;
    }
    public List createOrderMetaData(Collection<TempMetaData> values)
    {
        // order settings by column number
        ArrayList<TempMetaData> dataList = new ArrayList<TempMetaData>(values);
        orderMetaData(dataList);
        return dataList;
    }
    public List getTopMetadataOrdered(){
        ArrayList<TempMetaData> dataList = new ArrayList<TempMetaData>( personData.values());
        Collections.sort(dataList, this);
        return dataList;
      }
    public List getMiddleMetadataOrdered(){
        ArrayList<TempMetaData> dataList = new ArrayList<TempMetaData>( sampleData.values());
        Collections.sort(dataList, this);
        return dataList;
      }
    public List getBottomMetadataOrdered(){
        ArrayList<TempMetaData> dataList = new ArrayList<TempMetaData>( aliquotData.values());
        Collections.sort(dataList, this);
        return dataList;
      }

    public int compare(TempMetaData data1, TempMetaData data2)
    {
        if (data1.getActualColumnNumber() != data2.getActualColumnNumber())
        {
            if (Math.max(data1.getActualColumnNumber(), data2.getActualColumnNumber()) > 0)
            {
                if (Math.min(data1.getActualColumnNumber(), data2.getActualColumnNumber()) > 0)
                    return (data1.getActualColumnNumber() < data2.getActualColumnNumber() ? -1 : 1);
                else return(data1.getActualColumnNumber() <= 0 ? 1 : -1);
            }
        }

        return data1.getShortName().compareTo(data2.getShortName());
    }

    private void orderMetaData(List<TempMetaData> dataList)
    {
        Collections.sort(dataList, this);
    }
    private void orderMetaDataForFilter(List<TempMetaData> dataList)
    {
        Collections.sort(dataList, new FilterMetaData());
    }
/*    
    public void normalizeAliquotData(){
        int viewMax = 0;
        Iterator iter = aliquotData.values().iterator();
        while (iter.hasNext()) {
            TempMetaData metadata = (TempMetaData) iter.next();
            metadata.setActualColumnNumber((byte)0);
            int n = metadata.getViewColumnNumber();
            if (n > viewMax) viewMax = n;
        }
        byte target = 0;
        for ( int destin = 1; destin <= viewMax; destin++){
          Iterator miter = aliquotData.values().iterator();
          while (miter.hasNext()) {
            TempMetaData metadata = (TempMetaData) miter.next();
            if (metadata.getViewColumnNumber() == destin)
              metadata.setActualColumnNumber(++target);
          }
        }
        aliquotViewSize = target;
    }
    public void normalizeSampleData(){
        int viewMax = 0;
        Iterator iter = sampleData.values().iterator();
        while (iter.hasNext()) {
            TempMetaData metadata = (TempMetaData) iter.next();
            metadata.setActualColumnNumber((byte)0);
            int n = metadata.getViewColumnNumber();
            if (n > viewMax) viewMax = n;
        }
        byte target = 0;
        for ( int destin = 1; destin <= viewMax; destin++){
          Iterator miter = sampleData.values().iterator();
          while (miter.hasNext()) {
            TempMetaData metadata = (TempMetaData) miter.next();
            if (metadata.getViewColumnNumber() == destin)
              metadata.setActualColumnNumber(++target);
          }
        }
        sampleViewSize = target;
    }
    public void normalizePersonData(){
        int viewMax = 0;
        Iterator iter = personData.values().iterator();
        while (iter.hasNext()) {
            TempMetaData metadata = (TempMetaData) iter.next();
            metadata.setActualColumnNumber((byte)0);
            int n = metadata.getViewColumnNumber();
            if (n > viewMax) viewMax = n;
        }
        byte target = 0;
        for ( int destin = 1; destin <= viewMax; destin++){
          Iterator miter = personData.values().iterator();
          while (miter.hasNext()) {
            TempMetaData metadata = (TempMetaData) miter.next();
            if (metadata.getViewColumnNumber() == destin)
              metadata.setActualColumnNumber(++target);
          }
        }
        personViewSize = target;
    }

    public void setSettings( HttpServletRequest request) throws HibernateException {
        String className[] = {"top", "middle", "bottom"};
        List list[] = new List[3];
        Iterator iter[] = new Iterator[3];
//        TempMetaData data[] = new TempMetaData[3];
        TempMetaData tempMetaData;

        list[0] =  createOrderMetaData( getPersonMetaData());
        list[1] =  createOrderMetaData( getSampleMetaData());
        list[2] =  createOrderMetaData( getAliquotMetaData());
        int size = 0;
        int cNumb;
        String reportName;
        String value;

        for (int i = 0; i < 3; i++)
        {
          iter[i] = list[i].iterator();
          size = Math.max(size, list[i].size());
        }

        for (int j = 0; j < size; j++)
        {
            for (int i = 0; i < 3; i++)
            {
                tempMetaData = iter[i].hasNext() ? (TempMetaData) iter[i].next() : null;

                if (tempMetaData != null)
                {
                    reportName = className[i] + " " + tempMetaData.getVisibleName() +
                                 " colNumb";
                    value = request.getParameter(reportName);

                    try
                    {
                        cNumb = Integer.parseInt(value);
                        tempMetaData.setViewColumnNumber(cNumb);
                    }
                    catch (Exception ex)
                    {
                        tempMetaData.setViewColumnNumber(0);
                    }
                }
            }
        }



        for (int i = 0; i < 3; i++)
        {
            orderMetaData( list[i]);
            iter[i] = list[i].iterator();
            cNumb = 1;

            while (iter[i].hasNext())
            {
                tempMetaData = (TempMetaData) iter[i].next();
                tempMetaData.setViewColumnNumber(tempMetaData.getViewColumnNumber() > 0 ? cNumb++ : 0);
            }
        }

        normalizePersonData();
        normalizeSampleData();
        normalizeAliquotData();
    }
*/

// utility methods
  private static int getInt( String number){
      int myInteger = 0;
      try {
          myInteger = Integer.parseInt(number);
      } catch (Exception ex) {
      }
      return myInteger ;
  }

 private static void appendFields(
          StringBuffer toAppend,Field[]fs,String selName, int level){
     for (int i = 0; i < fs.length; i++){
       String name = fs[i].getName();
       if (name.matches("st\\d\\d")){
         int k = getInt( name.substring(2,4));
         if (k > VocabulName.getStringCount(level)) continue;
       } else
       if (name.matches("it\\d\\d")){
         int k = getInt( name.substring(2,4));
         if (k > VocabulName.getIntegerCount(level)) continue;
       } else
       if (name.matches("ft\\d\\d")){
         int k = getInt( name.substring(2,4));
         if (k > VocabulName.getFloatCount(level)) continue;
       } else
       if (name.matches("dt\\d\\d")){
         int k = getInt( name.substring(2,4));
         if (k > VocabulName.getDateCount(level)) continue;
       } else
       if (name.matches("vt\\d\\d")){
         int k = getInt( name.substring(2,4));
         if (k > VocabulName.getVocabularyCount()) continue;
       } else
       if (name.matches("ivt\\d\\d")){
         int k = getInt( name.substring(2,4));
          if (k > VocabulName.getIdentificyCount()) continue;
       } else
       if (name.startsWith("class$")) continue;
       else
       if (name.equals("id")||name.equals("aliquots")||
           name.equals("samples")||name.equals("relations2")||
           name.equals("concentrationUnit")||name.equals("volumeUnit")
           ) continue;
       toAppend.append("<option");
       if (name.equals(selName)) toAppend.append(" selected");
       toAppend.append(" value='")
          .append(name)
          .append("'>")
          .append(name);
     }
 }

 public static String getClassFieldPrompter(Class cl, String selName){
     StringBuffer xyz = new StringBuffer();
     String cName = cl.getName();
     int i = cName.lastIndexOf('.');
     if (i >= 0) cName = cName.substring(i + 1);
     int level = (cName.equals("Bottom"))?2:(cName.equals("Middle"))?1:0;
     Field[] fs = cl.getDeclaredFields();
     appendFields( xyz, fs, selName, level);
     Class cl1 = cl.getSuperclass();
     fs = cl1.getDeclaredFields();
     appendFields( xyz, fs, selName, level);
     Class cl2 = cl1.getSuperclass();
     fs = cl2.getDeclaredFields();
     appendFields( xyz, fs, selName, level);
     return xyz.toString();
 }

 //--------------------------------------------------------------------
//---------------- Report/import -------------------------------------
//--------------------------------------------------------------------
 // this method uses BatchAnalyser by analysis of header
   public TempMetaData findParameter(int level, String pName){
     Iterator iter;
     if (pName!=null){
   	   int j = pName.indexOf('#');
       String key = (j<3)?pName:pName.substring(0,j);
    	 
       switch ( level){
         case 0:iter = personData.values().iterator(); break;
         case 1:iter = sampleData.values().iterator(); break;
         default:iter = aliquotData.values().iterator(); break;
       }
       while (iter.hasNext()) {
         TempMetaData metadata = (TempMetaData) iter.next();
         if ( key.equals( metadata.getUploadName())) return metadata;
       }
     }
     return null;
   }
//this uses ExportBatchHeader.jsp
   private String getBottomMinimalParameterHeader( List params, StringBuffer xyz){
     boolean flag = true;
     TempMetaData pdata = (TempMetaData) sampleData.get(Fieldname.VISIBLENAME);
     if (pdata!=null){
       xyz.append(VocabulName.getMiddlePrefix())
          .append(pdata.getUploadName());
       flag = false;
     }
     pdata = (TempMetaData) aliquotData.get(Fieldname.VISIBLENAME);
     if (pdata!=null){
       if (flag) flag = false;
       else xyz.append('\t');
       xyz.append(VocabulName.getBottomPrefix())
          .append(pdata.getUploadName());
       flag = false;
     }
     pdata = (TempMetaData) aliquotData.get(Fieldname.COMMENT);
     if (pdata!=null){
       if (flag) flag = false;
       else xyz.append('\t');
       xyz.append(VocabulName.getBottomPrefix())
          .append(pdata.getUploadName());
       flag = false;
     }
     Iterator iter = params.iterator();
     while (iter.hasNext()) {
       MetaData param = (MetaData) iter.next();
       String key = param.getVisibleName();
       if (key.equals(Fieldname.VISIBLENAME)||key.equals(Fieldname.COMMENT)) continue;
       TempMetaData metadata = (TempMetaData) aliquotData.get(key);
       if (metadata!=null && metadata.isRequired()){
         String upln = metadata.getUploadName();
         if (!upln.equals("")){
           if (flag) flag = false;
           else xyz.append('\t');
           xyz.append(VocabulName.getBottomPrefix())
               .append(upln);
         }
       }
     }
     return xyz.toString();
   }
   private String getMiddleMinimalParameterHeader( List params, StringBuffer xyz){
     boolean flag = true;
     TempMetaData pdata = (TempMetaData) personData.get(Fieldname.VISIBLENAME);
     if (pdata!=null){
       xyz.append(VocabulName.getTopPrefix())
          .append(pdata.getUploadName());
       flag = false;
     }
     pdata = (TempMetaData) sampleData.get(Fieldname.VISIBLENAME);
     if (pdata!=null){
       if (flag) flag = false;
       else xyz.append('\t');
       xyz.append(VocabulName.getMiddlePrefix())
          .append(pdata.getUploadName());
       flag = false;
     }
     pdata = (TempMetaData) sampleData.get(Fieldname.COMMENT);
     if (pdata!=null){
       if (flag) flag = false;
       else xyz.append('\t');
       xyz.append(VocabulName.getMiddlePrefix())
          .append(pdata.getUploadName());
       flag = false;
     }
     Iterator iter = params.iterator();
     while (iter.hasNext()) {
       MetaData param = (MetaData) iter.next();
       String key = param.getVisibleName();
       if (key.equals(Fieldname.VISIBLENAME)||key.equals(Fieldname.COMMENT)) continue;
       TempMetaData metadata = (TempMetaData) sampleData.get(key);
       if (metadata!=null && metadata.isRequired()){
         String upln = metadata.getUploadName();
         if (!upln.equals("")){
           if (flag) flag = false;
           else xyz.append('\t');
           xyz.append(VocabulName.getMiddlePrefix())
               .append(upln);
         }
       }
     }
     return xyz.toString();
   }
   private String getTopMinimalParameterHeader( List params, StringBuffer xyz){
     boolean flag = true;
     TempMetaData pdata = (TempMetaData) personData.get(Fieldname.VISIBLENAME);
     if (pdata!=null){
       if (flag) flag = false;
       else xyz.append('\t');
       xyz.append(VocabulName.getTopPrefix())
          .append(pdata.getUploadName());
       flag = false;
     }
     pdata = (TempMetaData) personData.get(Fieldname.COMMENT);
     if (pdata!=null){
       if (flag) flag = false;
       else xyz.append('\t');
       xyz.append(VocabulName.getTopPrefix())
          .append(pdata.getUploadName());
       flag = false;
     }
     Iterator iter = params.iterator();
     while (iter.hasNext()) {
       MetaData param = (MetaData) iter.next();
       String key = param.getVisibleName();
       if (key.equals(Fieldname.VISIBLENAME)||key.equals(Fieldname.COMMENT)) continue;
       TempMetaData metadata = (TempMetaData) personData.get(key);
       if (metadata!=null && metadata.isRequired()){
         String upln = metadata.getUploadName();
         if (!upln.equals("")){
           if (flag) flag = false;
           else xyz.append('\t');
           xyz.append(VocabulName.getTopPrefix())
               .append(upln);
         }
       }
     }
     return xyz.toString();
   }
   public String getBottomParameterHeader( List params, boolean minimal){
     StringBuffer xyz = new StringBuffer();
     getBottomMinimalParameterHeader( params, xyz);
     if (minimal) return xyz.toString();
     Iterator iter = params.iterator();
     while (iter.hasNext()) {
       MetaData param = (MetaData) iter.next();
       String key = param.getVisibleName();
       if (key.equals(Fieldname.VISIBLENAME)||key.equals(Fieldname.COMMENT)) continue;
       TempMetaData metadata = (TempMetaData) aliquotData.get(key);
       if (metadata!=null && !metadata.isRequired()){
         String upln = metadata.getUploadName();
         if (!upln.equals("")){
           xyz.append('\t');
           xyz.append(VocabulName.getBottomPrefix())
               .append(upln);
         }
       }
     }
     return xyz.toString();
   }
   public String getMiddleParameterHeader( List params, boolean minimal){
     StringBuffer xyz = new StringBuffer();
     getMiddleMinimalParameterHeader( params, xyz);
     if (minimal) return xyz.toString();
     Iterator iter = params.iterator();
     while (iter.hasNext()) {
       MetaData param = (MetaData) iter.next();
       String key = param.getVisibleName();
       if (key.equals(Fieldname.VISIBLENAME)||key.equals(Fieldname.COMMENT)) continue;
       TempMetaData metadata = (TempMetaData) sampleData.get(key);
       if (metadata!=null && !metadata.isRequired()){
         String upln = metadata.getUploadName();
         if (!upln.equals("")){
           xyz.append('\t');
           xyz.append(VocabulName.getMiddlePrefix())
               .append(upln);
         }
       }
     }
     return xyz.toString();
   }
   public String getTopParameterHeader( List params, boolean minimal){
     StringBuffer xyz = new StringBuffer();
     getTopMinimalParameterHeader( params, xyz);
     if (minimal) return xyz.toString();
     Iterator iter = params.iterator();
     while (iter.hasNext()) {
       MetaData param = (MetaData) iter.next();
       String key = param.getVisibleName();
       if (key.equals(Fieldname.VISIBLENAME)||key.equals(Fieldname.COMMENT)) continue;
       TempMetaData metadata = (TempMetaData) personData.get(key);
       if (metadata!=null && !metadata.isRequired()){
         String upln = metadata.getUploadName();
         if (!upln.equals("")){
           xyz.append('\t');
           xyz.append(VocabulName.getTopPrefix())
               .append(upln);
         }
       }
     }
     return xyz.toString();
   }

// this method not used by BatchAnalyser before it analyses header
   public void clearTempColumnNumber( int level) {
     Iterator iter;
     switch ( level){
       case 0:iter = personData.values().iterator(); break;
       case 1:iter = sampleData.values().iterator(); break;
       default:iter = aliquotData.values().iterator(); break;
     }
     while (iter.hasNext()) {
       TempMetaData metadata = (TempMetaData) iter.next();
       metadata.setTempColumnNumber(0);
     }
   }
//this method uses BatchAnalyser after it fills tempColumnNumbers
   public TempMetaData[] getInputParameterArray( int level, int size) {
     Iterator iter;
     switch ( level){
       case 0:iter = personData.values().iterator(); break;
       case 1:iter = sampleData.values().iterator(); break;
       default:iter = aliquotData.values().iterator(); break;
     }
     TempMetaData[] paramArray = new TempMetaData[ size];
     while (iter.hasNext()) {
       TempMetaData metadata = (TempMetaData) iter.next();
       if (metadata.getTempColumnNumber() > 0) {
         paramArray[metadata.getTempColumnNumber()] = metadata;
       }
     }
     return paramArray;
   }
//this method used by BatchAnalyser to get missing required field name
   public String checkRequiredParameter( int level){
     Iterator iter; String prefix;
     switch ( level){
       case 0:iter = personData.values().iterator();
              prefix = VocabulName.getTopPrefix(); break;
       case 1:iter = sampleData.values().iterator();
              prefix = VocabulName.getMiddlePrefix(); break;
       default:iter = aliquotData.values().iterator();
              prefix = VocabulName.getBottomPrefix(); break;
     }
     while (iter.hasNext()) {
       TempMetaData metadata = (TempMetaData) iter.next();
       if ((metadata.isRequired() || metadata.isIdentificy())
           && metadata.getTempColumnNumber()==0)
         return prefix + metadata.getUploadName();
     }
     return null;
   }
//------  methods used by Define...View.jsp  --------------------------
   private void clearActualColumnNumber( int level) {
	     Iterator iter;
	     switch ( level){
	       case 0:iter = personData.values().iterator(); break;
	       case 1:iter = sampleData.values().iterator(); break;
	       default:iter = aliquotData.values().iterator(); break;
	     }
	     while (iter.hasNext()) {
	       TempMetaData metadata = (TempMetaData) iter.next();
	       metadata.setActualColumnNumber((byte)0);
	     }
	   }
   public void copyBottomColumnNumbers() {
	   Iterator iter = aliquotData.values().iterator();
	   while (iter.hasNext()) {
	     TempMetaData metadata = (TempMetaData) iter.next();
	     metadata.setActualColumnNumber((byte)metadata.getViewColumnNumber());
	   }
	 }
   public void copyMiddleColumnNumbers() {
	   Iterator iter = sampleData.values().iterator();
	   while (iter.hasNext()) {
	     TempMetaData metadata = (TempMetaData) iter.next();
	     metadata.setActualColumnNumber((byte)metadata.getViewColumnNumber());
	   }
	 }
   public void copyTopColumnNumbers() {
	   Iterator iter = personData.values().iterator();
	   while (iter.hasNext()) {
	     TempMetaData metadata = (TempMetaData) iter.next();
	     metadata.setActualColumnNumber((byte)metadata.getViewColumnNumber());
	   }
	 }
   public void saveBottomColumnNumbers() {
	   Iterator iter = aliquotData.values().iterator();
	   aliquotViewSize = 0;
	   while (iter.hasNext()) {
	     TempMetaData metadata = (TempMetaData) iter.next();
	     int num = metadata.getActualColumnNumber();
	     if ( num > 0) aliquotViewSize++;
	     metadata.setViewColumnNumber( num);
	   }
	 }
   public void saveMiddleColumnNumbers() {
	   Iterator iter = sampleData.values().iterator();
	   sampleViewSize = 0;
	   while (iter.hasNext()) {
	     TempMetaData metadata = (TempMetaData) iter.next();
	     int num = metadata.getActualColumnNumber();
	     if ( num > 0) sampleViewSize++;
	     metadata.setViewColumnNumber( num);
	   }
	 }
   public void saveTopColumnNumbers() {
	   Iterator iter = personData.values().iterator();
	   personViewSize = 0;
	   while (iter.hasNext()) {
	     TempMetaData metadata = (TempMetaData) iter.next();
	     int num = metadata.getActualColumnNumber();
	     if ( num > 0) personViewSize++;
	     metadata.setViewColumnNumber( num);
	   }
	 }
   public void processBottomColumns( HttpServletRequest request)
   {
     String[] keyArray = request.getParameterValues("key");
     if (keyArray!=null && keyArray.length > 1){
       String[] num1Array = request.getParameterValues("column");
       String[] num2Array = request.getParameterValues("column_10");
       int[]numArray = new int[keyArray.length];
       int max = 0;
       for (int i = 0; i < keyArray.length; i++){
         numArray[i] = MyUtil.getIntegerValue( num1Array[i] + num2Array[i]);
         if (numArray[i] > max) max = numArray[i];
       }
       clearActualColumnNumber(2);
       byte target = 0;
       for ( int destin = 1; destin <= max; destin++){
         for (int i = 0; i < keyArray.length; i++){
           if (numArray[i] == destin) {
             TempMetaData metadata = (TempMetaData) aliquotData.get( keyArray[i]);
             metadata.setActualColumnNumber( ++target);
           }
         }
       }
     }
   }
   public void processMiddleColumns( HttpServletRequest request)
   {
     String[] keyArray = request.getParameterValues("key");
     if (keyArray!=null && keyArray.length > 1){
       String[] num1Array = request.getParameterValues("column");
       String[] num2Array = request.getParameterValues("column_10");
       int[]numArray = new int[keyArray.length];
       int max = 0;
       for (int i = 0; i < keyArray.length; i++){
         numArray[i] = MyUtil.getIntegerValue( num1Array[i] + num2Array[i]);
         if (numArray[i] > max) max = numArray[i];
       }
       clearActualColumnNumber(1);
       byte target = 0;
       for ( int destin = 1; destin <= max; destin++){
         for (int i = 0; i < keyArray.length; i++){
           if (numArray[i] == destin) {
             TempMetaData metadata = (TempMetaData) sampleData.get( keyArray[i]);
             metadata.setActualColumnNumber( ++target);
           }
         }
       }
     }
   }
   public void processTopColumns( HttpServletRequest request)
   {
     String[] keyArray = request.getParameterValues("key");
     if (keyArray!=null && keyArray.length > 1){
       String[] num1Array = request.getParameterValues("column");
       String[] num2Array = request.getParameterValues("column_10");
       int[]numArray = new int[keyArray.length];
       int max = 0;
       for (int i = 0; i < keyArray.length; i++){
         numArray[i] = MyUtil.getIntegerValue( num1Array[i] + num2Array[i]);
         if (numArray[i] > max) max = numArray[i];
       }
       clearActualColumnNumber(0);
       byte target = 0;
       for ( int destin = 1; destin <= max; destin++){
         for (int i = 0; i < keyArray.length; i++){
           if (numArray[i] == destin) {
             TempMetaData metadata = (TempMetaData) personData.get( keyArray[i]);
             metadata.setActualColumnNumber( ++target);
           }
         }
       }
     }
   }

}
