package sims.hibernate;

import java.util.Date;

public abstract class Persistent {
        private Long id;
        private String visibleName;
        private User creator;
        private User modifier;
        private Date createDate;
        private Date modifDate;
        private String comment;

        public Long getId() {
                return id;
        }
        public String getIdAsTitle(){
          return "title=\"Id="+this.getId().toString()+"\"";
        }
        public String getVisibleName() {
                return visibleName;
        }
        public User getCreator() {
                return creator;
        }
        public User getModifier() {
                return modifier;
        }
        public Date getCreateDate() {
                return createDate;
        }
        public Date getModifDate() {
                return modifDate;
        }
        public String getComment() {
                return comment;
        }

        public String getVisualComment() {
                return MyUtil.getHTMLString( comment);
        }

        public String[] getValueArray( byte[] indexArray, int viewSize)
                                                      throws Exception{
            String[] valueArray = new String[viewSize];
            if (indexArray[0]>0) valueArray[indexArray[0]-1]=
                  visibleName;
            if (indexArray[1]>0) valueArray[indexArray[1]-1]=
                  MyUtil.truncateHTMLString(comment);
            if (indexArray[2]>0) valueArray[indexArray[2]-1]=
                  creator.getLoginName();
            if (indexArray[3]>0) valueArray[indexArray[3]-1]=
                  MyUtil.truncateDate(createDate);
            if (indexArray[4]>0) valueArray[indexArray[4]-1]=
                 (modifier!=null)?modifier.getLoginName():"";
            if (indexArray[5]>0) valueArray[indexArray[5]-1]=
                 MyUtil.truncateDate(modifDate);
            return valueArray;
        }

        public String[] getValueArrayForExport( byte[] indexArray, int viewSize)
                                        throws Exception {
          return  getValueArray( indexArray, viewSize);
        }
// -------------------------------------------
// -------------------------------------------
// -------------------------------------------
        private void setId(Long long1) {
                id = long1;
        }

        public void setVisibleName(String string) {
                visibleName = string;
        }

        public void setCreator(User user) {
                creator = user;
        }

        public void setModifier(User user) {
                modifier = user;
        }

        public void setCreateDate(Date date) {
                createDate = date;
        }

        public void setModifDate(Date date) {
                modifDate = date;
        }

        public void setComment(String string) {
                comment = string;
        }

        public void setCreateInfo(User user) {
                createDate = new Date();
                modifDate =  new Date();
                creator = user;
                modifier = user;
        }

        public void setModifInfo(User user) {
                modifDate =  new Date();
                modifier = user;
        }

        public String getCreateAndModifyString() {
          StringBuffer strBuf = new StringBuffer
                 ("<tr><td>&nbsp;</td><td>Created by &nbsp;");
          strBuf.append(creator.getLoginName())
                  .append("&nbsp; Create data &nbsp;")
                  .append(MyUtil.truncateTime(createDate))
                  .append("</td></tr>");
          if (modifier != null)
              strBuf.append("<tr><td>&nbsp;</td><td>Modified by &nbsp;")
                    .append(modifier.getLoginName())
                    .append("&nbsp; Modify data &nbsp;")
                    .append(MyUtil.truncateTime(modifDate))
                    .append("</td></tr>");
              return strBuf.toString();
        }

        public String toString() {
                return /*this.getId() + "  " + */this.getVisibleName();
        }
}
