package sims.hibernate;

public final class STechnologyAccess extends Persistent {
  private User user;
  private Integer canCreateTopX;
  private Integer vocabularyAccess;
  private Integer configurationAccess;
  private Integer dataTransferRights;
//	-------------------------------------------
  private STechnology technology;
  public STechnology getTechnology() {
    return technology;
  }
  public void setTechnology(STechnology tech) {
    technology = tech;
  }
//-------------------------------------------
  public User getUser() {
    return user;
  }
  public void setUser(User val) {
    user = val;
  }
  public Integer getCanCreateTopX() {
    return canCreateTopX;
  }
  public void setCanCreateTopX(Integer val) {
    canCreateTopX = val;
  }
  public boolean canCreateTop() {
    return canCreateTopX!=null && canCreateTopX.byteValue() > 0;
  }
  public Integer getVocabularyAccess() {
    return (vocabularyAccess==null)?new Integer(0):vocabularyAccess;
  }
  public void setVocabularyAccess(Integer val) {
    vocabularyAccess = val;
  }
  public Integer getConfigurationAccess() {
    return (configurationAccess==null)?new Integer(0):configurationAccess;
  }
  public void setConfigurationAccess(Integer val) {
    configurationAccess = val;
  }
  public Integer getDataTransferRights() {
    return (dataTransferRights==null)?new Integer(0):dataTransferRights;
  }
  public void setDataTransferRights(Integer val) {
	dataTransferRights = val;
  }
  private static final String[] dataTransferVariants = {
      "non-accessible",
      "default",
      "predefined",
      "default+predefined",
      "user defined",
      "default+user defined"
  };
  private static final int[] dataTransferValues = {
      0, 1000, 2000, 3000, 4000, 5000
  };
  private static final String[] accessVariants = {
      "non-accessible",
      "view only",
      "limited editing",
      "full editing"
  };
  private static final int[] accessValues = {
      0, 1000, 2000, 3000
  };
  public static String getAccessRightSelectionNew(){
    StringBuffer xyz = new StringBuffer();
    for (int i = 0; i < accessVariants.length; i++){
        xyz.append("<option ");
        xyz.append("value=\"")
            .append( accessValues[i])
            .append("\">")
            .append(accessVariants[i]);
      }
    return xyz.toString();
  }
  public static String getDataTransferRightSelectionNew(){
    StringBuffer xyz = new StringBuffer();
    for (int i = 0; i < dataTransferVariants.length; i++){
        xyz.append("<option ");
        xyz.append("value=\"")
            .append( dataTransferValues[i])
            .append("\">")
            .append(dataTransferVariants[i]);
      }
    return xyz.toString();
  }
  public String getVocabRightSelection(){
    StringBuffer xyz = new StringBuffer();
    int j = 1; int v = (vocabularyAccess!=null)?vocabularyAccess.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    j--;
    for (int i = 0; i < accessVariants.length; i++){
        xyz.append("<option ");
        if ( i==j) xyz.append("selected ");
        xyz.append("value=\"")
            .append( accessValues[i])
            .append("\">")
            .append(accessVariants[i]);
      }
    return xyz.toString();
  }
  public String getConfigRightSelection(){
    StringBuffer xyz = new StringBuffer();
    int j = 1; int v = (configurationAccess!=null)?configurationAccess.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    j--;
    for (int i = 0; i < accessVariants.length; i++){
        xyz.append("<option ");
        if ( i==j) xyz.append("selected ");
        xyz.append("value=\"")
            .append( accessValues[i])
            .append("\">")
            .append(accessVariants[i]);
      }
    return xyz.toString();
  }
  public String getDataTransferRightSelection(){
    StringBuffer xyz = new StringBuffer();
    int j = 1; int v = (dataTransferRights!=null)?dataTransferRights.intValue():0;
    while ( j < dataTransferValues.length && v >= dataTransferValues[j]) j++;
    j--;
    for (int i = 0; i < dataTransferVariants.length; i++){
        xyz.append("<option ");
        if ( i==j) xyz.append("selected ");
        xyz.append("value=\"")
            .append( dataTransferValues[i])
            .append("\">")
            .append(dataTransferVariants[i]);
    }
    return xyz.toString();
  }
  public String getVocabRightText(){
    int j = 1; int v = (vocabularyAccess!=null)?vocabularyAccess.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    return accessVariants[--j];
  }
  public String getConfigRightText(){
    int j = 1; int v = (configurationAccess!=null)?configurationAccess.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    return accessVariants[--j];
  }
  public String getDataTransferRightText(){
    int j = 1; int v = (dataTransferRights!=null)?dataTransferRights.intValue():0;
    while ( j < dataTransferValues.length && v >= dataTransferValues[j]) j++;
    return dataTransferVariants[--j];
  }
}
