package sims.hibernate;

public final class UserRights extends Persistent {
  private User grantedBy;
  private User grantedTo;
  private Integer accessRights;

  public User getGrantedBy(){
    return grantedBy;
  }
  public User getGrantedTo(){
    return grantedTo;
  }
  public Integer getAccessRights(){
    return accessRights;
  }

  public void setGrantedBy(User val){
    grantedBy = val;
  }
  public void setGrantedTo(User val){
    grantedTo = val;
  }
  public void setAccessRights(Integer val){
    accessRights = val;
  }

  private static final String[] accessVariants = {
      "non-accessible",
      "view only, data files non-accessible",
      "view only, data files accessible",
      "full access"
  };
  private static final int[] accessValues = {
      0, 1000, 2000, 3000
  };
  public static String getAccessRightSelectionNew(){
    StringBuffer xyz = new StringBuffer();
    for (int i = 0; i < accessVariants.length; i++){
        xyz.append("<option ");
        xyz.append("value=\"")
            .append( accessValues[i])
            .append("\">")
            .append(accessVariants[i]);
      }
    return xyz.toString();
  }

  public String getAccessRightSelection(){
    StringBuffer xyz = new StringBuffer();
    int j = 1; int v = (accessRights!=null)?accessRights.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    j--;
    for (int i = 0; i < accessVariants.length; i++){
        xyz.append("<option ");
        if ( i==j) xyz.append("selected ");
        xyz.append("value=\"")
            .append( accessValues[i])
            .append("\">")
            .append(accessVariants[i]);
      }
    return xyz.toString();
  }
  public String getAccessRightText(){
    int j = 1; int v = (accessRights!=null)?accessRights.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    return accessVariants[--j];
  }
  public static String getAccessRightText( int accessRightsValue){
    int j = 1; int v = accessRightsValue;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    return accessVariants[--j];
  }
}
